------------------------------------------------------------------------------
--                                                                          --
--                            GNAT2WHY COMPONENTS                           --
--                                                                          --
--                  W H Y - A T R E E - A C C E S S O R S                   --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--                       Copyright (C) 2010-2025, AdaCore                   --
--                                                                          --
-- gnat2why is  free  software;  you can redistribute  it and/or  modify it --
-- under terms of the  GNU General Public License as published  by the Free --
-- Software  Foundation;  either version 3,  or (at your option)  any later --
-- version.  gnat2why is distributed  in the hope that  it will be  useful, --
-- but WITHOUT ANY WARRANTY; without even the implied warranty of  MERCHAN- --
-- TABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public --
-- License for  more details.  You should have  received  a copy of the GNU --
-- General  Public License  distributed with  gnat2why;  see file COPYING3. --
-- If not,  go to  http://www.gnu.org/licenses  for a complete  copy of the --
-- license.                                                                 --
--                                                                          --
-- gnat2why is maintained by AdaCore (http://www.adacore.com)               --
--                                                                          --
------------------------------------------------------------------------------
--  This package is automatically generated by xtree. Do not edit manually.

with Why.Ids;           use Why.Ids;
with Why.Unchecked_Ids; use Why.Unchecked_Ids;
with Why.Conversions;   use Why.Conversions;

package Why.Atree.Accessors is
   --  This package provides a set of accessors to the content of
   --  Why_Node objects.

   function Get_Ada_Node
     (Id : Why_Node_Id)
     return Node_Id;

   function Get_Domain
     (Id : Why_Node_Id)
     return EW_Domain;

   function Type_Get_Type_Kind
     (Id : W_Type_Unchecked_Id)
     return EW_Type;

   function Type_Get_Name
     (Id : W_Type_Unchecked_Id)
     return W_Name_Unchecked_Id;

   function Type_Get_Is_Mutable
     (Id : W_Type_Unchecked_Id)
     return Boolean;

   function Type_Get_Relaxed_Init
     (Id : W_Type_Unchecked_Id)
     return Boolean;

   function Name_Get_Symb
     (Id : W_Name_Unchecked_Id)
     return Symbol;

   function Name_Get_Namespace
     (Id : W_Name_Unchecked_Id)
     return Symbol;

   function Name_Get_Module
     (Id : W_Name_Unchecked_Id)
     return W_Module_Unchecked_OId;

   function Name_Get_Infix
     (Id : W_Name_Unchecked_Id)
     return Boolean;

   function Effects_Get_Reads
     (Id : W_Effects_Unchecked_Id)
     return W_Identifier_Unchecked_OList;

   function Effects_Get_Writes
     (Id : W_Effects_Unchecked_Id)
     return W_Identifier_Unchecked_OList;

   function Effects_Get_Raises
     (Id : W_Effects_Unchecked_Id)
     return W_Raise_Effect_Unchecked_OList;

   function Raise_Effect_Get_Name
     (Id : W_Raise_Effect_Unchecked_Id)
     return W_Name_Unchecked_Id;

   function Raise_Effect_Get_Arg_Id
     (Id : W_Raise_Effect_Unchecked_Id)
     return W_Identifier_Unchecked_OId;

   function Raise_Effect_Get_Post
     (Id : W_Raise_Effect_Unchecked_Id)
     return W_Pred_Unchecked_OId;

   function Binder_Get_Name
     (Id : W_Binder_Unchecked_Id)
     return W_Identifier_Unchecked_OId;

   function Binder_Get_Arg_Type
     (Id : W_Binder_Unchecked_Id)
     return W_Type_Unchecked_Id;

   function Transparent_Type_Definition_Get_Type_Definition
     (Id : W_Transparent_Type_Definition_Unchecked_Id)
     return W_Type_Unchecked_Id;

   function Record_Binder_Get_Name
     (Id : W_Record_Binder_Unchecked_Id)
     return W_Identifier_Unchecked_OId;

   function Record_Binder_Get_Arg_Type
     (Id : W_Record_Binder_Unchecked_Id)
     return W_Type_Unchecked_Id;

   function Record_Binder_Get_Labels
     (Id : W_Record_Binder_Unchecked_Id)
     return Symbol_Set;

   function Record_Binder_Get_Is_Mutable
     (Id : W_Record_Binder_Unchecked_Id)
     return Boolean;

   function Record_Definition_Get_Fields
     (Id : W_Record_Definition_Unchecked_Id)
     return W_Record_Binder_Unchecked_List;

   function Range_Type_Definition_Get_First
     (Id : W_Range_Type_Definition_Unchecked_Id)
     return Uint;

   function Range_Type_Definition_Get_Last
     (Id : W_Range_Type_Definition_Unchecked_Id)
     return Uint;

   function Triggers_Get_Triggers
     (Id : W_Triggers_Unchecked_Id)
     return W_Trigger_Unchecked_List;

   function Trigger_Get_Terms
     (Id : W_Trigger_Unchecked_Id)
     return W_Expr_Unchecked_List;

   function Axiom_Dep_Get_Name
     (Id : W_Axiom_Dep_Unchecked_Id)
     return W_Identifier_Unchecked_Id;

   function Axiom_Dep_Get_Kind
     (Id : W_Axiom_Dep_Unchecked_Id)
     return EW_Axiom_Dep_Kind;

   function Handler_Get_Name
     (Id : W_Handler_Unchecked_Id)
     return W_Name_Unchecked_Id;

   function Handler_Get_Arg_Id
     (Id : W_Handler_Unchecked_Id)
     return W_Identifier_Unchecked_OId;

   function Handler_Get_Def
     (Id : W_Handler_Unchecked_Id)
     return W_Prog_Unchecked_Id;

   function Field_Association_Get_Field
     (Id : W_Field_Association_Unchecked_Id)
     return W_Identifier_Unchecked_Id;

   function Field_Association_Get_Value
     (Id : W_Field_Association_Unchecked_Id)
     return W_Expr_Unchecked_Id;

   function Variant_Get_Cmp_Op
     (Id : W_Variant_Unchecked_Id)
     return W_Identifier_Unchecked_Id;

   function Variant_Get_Labels
     (Id : W_Variant_Unchecked_Id)
     return Symbol_Set;

   function Variant_Get_Expr
     (Id : W_Variant_Unchecked_Id)
     return W_Term_Unchecked_Id;

   function Variants_Get_Variants
     (Id : W_Variants_Unchecked_Id)
     return W_Variant_Unchecked_List;

   function Universal_Quantif_Get_Variables
     (Id : W_Universal_Quantif_Unchecked_Id)
     return W_Identifier_Unchecked_List;

   function Universal_Quantif_Get_Labels
     (Id : W_Universal_Quantif_Unchecked_Id)
     return Symbol_Set;

   function Universal_Quantif_Get_Var_Type
     (Id : W_Universal_Quantif_Unchecked_Id)
     return W_Type_Unchecked_Id;

   function Universal_Quantif_Get_Triggers
     (Id : W_Universal_Quantif_Unchecked_Id)
     return W_Triggers_Unchecked_OId;

   function Universal_Quantif_Get_Pred
     (Id : W_Universal_Quantif_Unchecked_Id)
     return W_Pred_Unchecked_Id;

   function Existential_Quantif_Get_Variables
     (Id : W_Existential_Quantif_Unchecked_Id)
     return W_Identifier_Unchecked_List;

   function Existential_Quantif_Get_Labels
     (Id : W_Existential_Quantif_Unchecked_Id)
     return Symbol_Set;

   function Existential_Quantif_Get_Var_Type
     (Id : W_Existential_Quantif_Unchecked_Id)
     return W_Type_Unchecked_Id;

   function Existential_Quantif_Get_Pred
     (Id : W_Existential_Quantif_Unchecked_Id)
     return W_Pred_Unchecked_Id;

   function Not_Get_Right
     (Id : W_Not_Unchecked_Id)
     return W_Expr_Unchecked_Id;

   function Connection_Get_Left
     (Id : W_Connection_Unchecked_Id)
     return W_Expr_Unchecked_Id;

   function Connection_Get_Op
     (Id : W_Connection_Unchecked_Id)
     return EW_Connector;

   function Connection_Get_Right
     (Id : W_Connection_Unchecked_Id)
     return W_Expr_Unchecked_Id;

   function Connection_Get_More_Right
     (Id : W_Connection_Unchecked_Id)
     return W_Expr_Unchecked_OList;

   function Label_Get_Labels
     (Id : W_Label_Unchecked_Id)
     return Symbol_Set;

   function Label_Get_Def
     (Id : W_Label_Unchecked_Id)
     return W_Expr_Unchecked_Id;

   function Label_Get_Typ
     (Id : W_Label_Unchecked_Id)
     return W_Type_Unchecked_OId;

   function Loc_Label_Get_Sloc
     (Id : W_Loc_Label_Unchecked_Id)
     return Source_Ptr;

   function Loc_Label_Get_Def
     (Id : W_Loc_Label_Unchecked_Id)
     return W_Expr_Unchecked_Id;

   function Loc_Label_Get_Marker
     (Id : W_Loc_Label_Unchecked_Id)
     return Symbol;

   function Identifier_Get_Name
     (Id : W_Identifier_Unchecked_Id)
     return W_Name_Unchecked_Id;

   function Identifier_Get_Typ
     (Id : W_Identifier_Unchecked_Id)
     return W_Type_Unchecked_OId;

   function Identifier_Get_Labels
     (Id : W_Identifier_Unchecked_Id)
     return String_Sets.Set;

   function Tagged_Get_Tag
     (Id : W_Tagged_Unchecked_Id)
     return Symbol;

   function Tagged_Get_Def
     (Id : W_Tagged_Unchecked_Id)
     return W_Expr_Unchecked_Id;

   function Tagged_Get_Typ
     (Id : W_Tagged_Unchecked_Id)
     return W_Type_Unchecked_OId;

   function Call_Get_Name
     (Id : W_Call_Unchecked_Id)
     return W_Identifier_Unchecked_Id;

   function Call_Get_Args
     (Id : W_Call_Unchecked_Id)
     return W_Expr_Unchecked_OList;

   function Call_Get_Typ
     (Id : W_Call_Unchecked_Id)
     return W_Type_Unchecked_OId;

   function Literal_Get_Value
     (Id : W_Literal_Unchecked_Id)
     return EW_Literal;

   function Literal_Get_Typ
     (Id : W_Literal_Unchecked_Id)
     return W_Type_Unchecked_OId;

   function Binding_Get_Name
     (Id : W_Binding_Unchecked_Id)
     return W_Identifier_Unchecked_Id;

   function Binding_Get_Def
     (Id : W_Binding_Unchecked_Id)
     return W_Expr_Unchecked_Id;

   function Binding_Get_Context
     (Id : W_Binding_Unchecked_Id)
     return W_Expr_Unchecked_Id;

   function Binding_Get_Typ
     (Id : W_Binding_Unchecked_Id)
     return W_Type_Unchecked_OId;

   function Elsif_Get_Condition
     (Id : W_Elsif_Unchecked_Id)
     return W_Expr_Unchecked_Id;

   function Elsif_Get_Then_Part
     (Id : W_Elsif_Unchecked_Id)
     return W_Expr_Unchecked_Id;

   function Elsif_Get_Typ
     (Id : W_Elsif_Unchecked_Id)
     return W_Type_Unchecked_OId;

   function Epsilon_Get_Name
     (Id : W_Epsilon_Unchecked_Id)
     return W_Identifier_Unchecked_Id;

   function Epsilon_Get_Typ
     (Id : W_Epsilon_Unchecked_Id)
     return W_Type_Unchecked_Id;

   function Epsilon_Get_Pred
     (Id : W_Epsilon_Unchecked_Id)
     return W_Pred_Unchecked_Id;

   function Conditional_Get_Condition
     (Id : W_Conditional_Unchecked_Id)
     return W_Expr_Unchecked_Id;

   function Conditional_Get_Then_Part
     (Id : W_Conditional_Unchecked_Id)
     return W_Expr_Unchecked_Id;

   function Conditional_Get_Elsif_Parts
     (Id : W_Conditional_Unchecked_Id)
     return W_Expr_Unchecked_OList;

   function Conditional_Get_Else_Part
     (Id : W_Conditional_Unchecked_Id)
     return W_Expr_Unchecked_OId;

   function Conditional_Get_Typ
     (Id : W_Conditional_Unchecked_Id)
     return W_Type_Unchecked_OId;

   function Integer_Constant_Get_Value
     (Id : W_Integer_Constant_Unchecked_Id)
     return Uint;

   function Range_Constant_Get_Value
     (Id : W_Range_Constant_Unchecked_Id)
     return Uint;

   function Range_Constant_Get_Typ
     (Id : W_Range_Constant_Unchecked_Id)
     return W_Type_Unchecked_Id;

   function Modular_Constant_Get_Value
     (Id : W_Modular_Constant_Unchecked_Id)
     return Uint;

   function Modular_Constant_Get_Typ
     (Id : W_Modular_Constant_Unchecked_Id)
     return W_Type_Unchecked_Id;

   function Fixed_Constant_Get_Value
     (Id : W_Fixed_Constant_Unchecked_Id)
     return Uint;

   function Fixed_Constant_Get_Typ
     (Id : W_Fixed_Constant_Unchecked_Id)
     return W_Type_Unchecked_Id;

   function Real_Constant_Get_Value
     (Id : W_Real_Constant_Unchecked_Id)
     return Ureal;

   function Float_Constant_Get_Value
     (Id : W_Float_Constant_Unchecked_Id)
     return Ureal;

   function Float_Constant_Get_Typ
     (Id : W_Float_Constant_Unchecked_Id)
     return W_Type_Unchecked_Id;

   function Comment_Get_Comment
     (Id : W_Comment_Unchecked_Id)
     return Symbol;

   function Deref_Get_Right
     (Id : W_Deref_Unchecked_Id)
     return W_Identifier_Unchecked_Id;

   function Deref_Get_Typ
     (Id : W_Deref_Unchecked_Id)
     return W_Type_Unchecked_Id;

   function Record_Access_Get_Name
     (Id : W_Record_Access_Unchecked_Id)
     return W_Expr_Unchecked_Id;

   function Record_Access_Get_Field
     (Id : W_Record_Access_Unchecked_Id)
     return W_Identifier_Unchecked_Id;

   function Record_Access_Get_Typ
     (Id : W_Record_Access_Unchecked_Id)
     return W_Type_Unchecked_OId;

   function Record_Update_Get_Name
     (Id : W_Record_Update_Unchecked_Id)
     return W_Expr_Unchecked_Id;

   function Record_Update_Get_Updates
     (Id : W_Record_Update_Unchecked_Id)
     return W_Field_Association_Unchecked_List;

   function Record_Update_Get_Typ
     (Id : W_Record_Update_Unchecked_Id)
     return W_Type_Unchecked_OId;

   function Record_Aggregate_Get_Associations
     (Id : W_Record_Aggregate_Unchecked_Id)
     return W_Field_Association_Unchecked_List;

   function Record_Aggregate_Get_Typ
     (Id : W_Record_Aggregate_Unchecked_Id)
     return W_Type_Unchecked_OId;

   function Any_Expr_Get_Effects
     (Id : W_Any_Expr_Unchecked_Id)
     return W_Effects_Unchecked_OId;

   function Any_Expr_Get_Pre
     (Id : W_Any_Expr_Unchecked_Id)
     return W_Pred_Unchecked_OId;

   function Any_Expr_Get_Post
     (Id : W_Any_Expr_Unchecked_Id)
     return W_Pred_Unchecked_OId;

   function Any_Expr_Get_Return_Type
     (Id : W_Any_Expr_Unchecked_Id)
     return W_Type_Unchecked_Id;

   function Any_Expr_Get_Labels
     (Id : W_Any_Expr_Unchecked_Id)
     return Symbol_Set;

   function Assignment_Get_Name
     (Id : W_Assignment_Unchecked_Id)
     return W_Identifier_Unchecked_Id;

   function Assignment_Get_Value
     (Id : W_Assignment_Unchecked_Id)
     return W_Prog_Unchecked_Id;

   function Assignment_Get_Typ
     (Id : W_Assignment_Unchecked_Id)
     return W_Type_Unchecked_Id;

   function Assignment_Get_Labels
     (Id : W_Assignment_Unchecked_Id)
     return Symbol_Set;

   function Binding_Ref_Get_Name
     (Id : W_Binding_Ref_Unchecked_Id)
     return W_Identifier_Unchecked_Id;

   function Binding_Ref_Get_Def
     (Id : W_Binding_Ref_Unchecked_Id)
     return W_Prog_Unchecked_Id;

   function Binding_Ref_Get_Context
     (Id : W_Binding_Ref_Unchecked_Id)
     return W_Prog_Unchecked_Id;

   function Binding_Ref_Get_Typ
     (Id : W_Binding_Ref_Unchecked_Id)
     return W_Type_Unchecked_Id;

   function Loop_Get_Code_Before
     (Id : W_Loop_Unchecked_Id)
     return W_Prog_Unchecked_Id;

   function Loop_Get_Invariants
     (Id : W_Loop_Unchecked_Id)
     return W_Pred_Unchecked_OList;

   function Loop_Get_Variants
     (Id : W_Loop_Unchecked_Id)
     return W_Variants_Unchecked_OList;

   function Loop_Get_Code_After
     (Id : W_Loop_Unchecked_Id)
     return W_Prog_Unchecked_Id;

   function Statement_Sequence_Get_Statements
     (Id : W_Statement_Sequence_Unchecked_Id)
     return W_Prog_Unchecked_List;

   function Abstract_Expr_Get_Expr
     (Id : W_Abstract_Expr_Unchecked_Id)
     return W_Prog_Unchecked_Id;

   function Abstract_Expr_Get_Post
     (Id : W_Abstract_Expr_Unchecked_Id)
     return W_Pred_Unchecked_Id;

   function Abstract_Expr_Get_Typ
     (Id : W_Abstract_Expr_Unchecked_Id)
     return W_Type_Unchecked_OId;

   function Assert_Get_Pred
     (Id : W_Assert_Unchecked_Id)
     return W_Pred_Unchecked_Id;

   function Assert_Get_Assert_Kind
     (Id : W_Assert_Unchecked_Id)
     return EW_Assert_Kind;

   function Raise_Get_Name
     (Id : W_Raise_Unchecked_Id)
     return W_Name_Unchecked_Id;

   function Raise_Get_Arg
     (Id : W_Raise_Unchecked_Id)
     return W_Expr_Unchecked_OId;

   function Raise_Get_Typ
     (Id : W_Raise_Unchecked_Id)
     return W_Type_Unchecked_OId;

   function Try_Block_Get_Prog
     (Id : W_Try_Block_Unchecked_Id)
     return W_Prog_Unchecked_Id;

   function Try_Block_Get_Handler
     (Id : W_Try_Block_Unchecked_Id)
     return W_Handler_Unchecked_List;

   function Try_Block_Get_Typ
     (Id : W_Try_Block_Unchecked_Id)
     return W_Type_Unchecked_OId;

   function Function_Decl_Get_Name
     (Id : W_Function_Decl_Unchecked_Id)
     return W_Identifier_Unchecked_Id;

   function Function_Decl_Get_Binders
     (Id : W_Function_Decl_Unchecked_Id)
     return W_Binder_Unchecked_OList;

   function Function_Decl_Get_Effects
     (Id : W_Function_Decl_Unchecked_Id)
     return W_Effects_Unchecked_OId;

   function Function_Decl_Get_Pre
     (Id : W_Function_Decl_Unchecked_Id)
     return W_Pred_Unchecked_OId;

   function Function_Decl_Get_Post
     (Id : W_Function_Decl_Unchecked_Id)
     return W_Pred_Unchecked_OId;

   function Function_Decl_Get_Return_Type
     (Id : W_Function_Decl_Unchecked_Id)
     return W_Type_Unchecked_OId;

   function Function_Decl_Get_Def
     (Id : W_Function_Decl_Unchecked_Id)
     return W_Expr_Unchecked_OId;

   function Function_Decl_Get_Labels
     (Id : W_Function_Decl_Unchecked_Id)
     return Symbol_Set;

   function Function_Decl_Get_Location
     (Id : W_Function_Decl_Unchecked_Id)
     return Source_Ptr;

   function Axiom_Get_Name
     (Id : W_Axiom_Unchecked_Id)
     return Symbol;

   function Axiom_Get_Def
     (Id : W_Axiom_Unchecked_Id)
     return W_Pred_Unchecked_Id;

   function Axiom_Get_Dep
     (Id : W_Axiom_Unchecked_Id)
     return W_Axiom_Dep_Unchecked_OId;

   function Goal_Get_Name
     (Id : W_Goal_Unchecked_Id)
     return Symbol;

   function Goal_Get_Def
     (Id : W_Goal_Unchecked_Id)
     return W_Pred_Unchecked_Id;

   function Type_Decl_Get_Args
     (Id : W_Type_Decl_Unchecked_Id)
     return W_Identifier_Unchecked_OList;

   function Type_Decl_Get_Name
     (Id : W_Type_Decl_Unchecked_Id)
     return W_Name_Unchecked_Id;

   function Type_Decl_Get_Labels
     (Id : W_Type_Decl_Unchecked_Id)
     return Symbol_Set;

   function Type_Decl_Get_Definition
     (Id : W_Type_Decl_Unchecked_Id)
     return W_Type_Definition_Unchecked_OId;

   function Global_Ref_Declaration_Get_Name
     (Id : W_Global_Ref_Declaration_Unchecked_Id)
     return W_Identifier_Unchecked_Id;

   function Global_Ref_Declaration_Get_Ref_Type
     (Id : W_Global_Ref_Declaration_Unchecked_Id)
     return W_Type_Unchecked_Id;

   function Global_Ref_Declaration_Get_Labels
     (Id : W_Global_Ref_Declaration_Unchecked_Id)
     return Symbol_Set;

   function Global_Ref_Declaration_Get_Location
     (Id : W_Global_Ref_Declaration_Unchecked_Id)
     return Source_Ptr;

   function Namespace_Declaration_Get_Declarations
     (Id : W_Namespace_Declaration_Unchecked_Id)
     return W_Declaration_Unchecked_OList;

   function Namespace_Declaration_Get_Name
     (Id : W_Namespace_Declaration_Unchecked_Id)
     return Symbol;

   function Exception_Declaration_Get_Name
     (Id : W_Exception_Declaration_Unchecked_Id)
     return W_Name_Unchecked_Id;

   function Exception_Declaration_Get_Arg
     (Id : W_Exception_Declaration_Unchecked_Id)
     return W_Type_Unchecked_OId;

   function Meta_Declaration_Get_Name
     (Id : W_Meta_Declaration_Unchecked_Id)
     return Symbol;

   function Meta_Declaration_Get_Parameter
     (Id : W_Meta_Declaration_Unchecked_Id)
     return Symbol;

   function Clone_Declaration_Get_Origin
     (Id : W_Clone_Declaration_Unchecked_Id)
     return W_Module_Unchecked_Id;

   function Clone_Declaration_Get_As_Name
     (Id : W_Clone_Declaration_Unchecked_Id)
     return Symbol;

   function Clone_Declaration_Get_Clone_Kind
     (Id : W_Clone_Declaration_Unchecked_Id)
     return EW_Clone_Type;

   function Clone_Declaration_Get_Substitutions
     (Id : W_Clone_Declaration_Unchecked_Id)
     return W_Clone_Substitution_Unchecked_OList;

   function Clone_Declaration_Get_Theory_Kind
     (Id : W_Clone_Declaration_Unchecked_Id)
     return EW_Theory_Type;

   function Clone_Substitution_Get_Kind
     (Id : W_Clone_Substitution_Unchecked_Id)
     return EW_Subst_Type;

   function Clone_Substitution_Get_Orig_Name
     (Id : W_Clone_Substitution_Unchecked_Id)
     return W_Name_Unchecked_Id;

   function Clone_Substitution_Get_Image
     (Id : W_Clone_Substitution_Unchecked_Id)
     return W_Name_Unchecked_Id;

   function Include_Declaration_Get_Module
     (Id : W_Include_Declaration_Unchecked_Id)
     return W_Module_Unchecked_Id;

   function Include_Declaration_Get_Kind
     (Id : W_Include_Declaration_Unchecked_Id)
     return EW_Theory_Type;

   function Include_Declaration_Get_Use_Kind
     (Id : W_Include_Declaration_Unchecked_Id)
     return EW_Clone_Type;

   function Theory_Declaration_Get_Declarations
     (Id : W_Theory_Declaration_Unchecked_Id)
     return W_Declaration_Unchecked_OList;

   function Theory_Declaration_Get_Name
     (Id : W_Theory_Declaration_Unchecked_Id)
     return Symbol;

   function Theory_Declaration_Get_Kind
     (Id : W_Theory_Declaration_Unchecked_Id)
     return EW_Theory_Type;

   function Theory_Declaration_Get_Includes
     (Id : W_Theory_Declaration_Unchecked_Id)
     return W_Include_Declaration_Unchecked_OList;

   function Theory_Declaration_Get_Comment
     (Id : W_Theory_Declaration_Unchecked_Id)
     return Symbol;

   function Module_Get_File
     (Id : W_Module_Unchecked_Id)
     return Symbol;

   function Module_Get_Name
     (Id : W_Module_Unchecked_Id)
     return Symbol;

   function Get_Type_Kind
     (Id : W_Type_Id)
     return EW_Type;

   function Get_Name
     (Id : W_Type_Id)
     return W_Name_Id;

   function Get_Is_Mutable
     (Id : W_Type_Id)
     return Boolean;

   function Get_Relaxed_Init
     (Id : W_Type_Id)
     return Boolean;

   function Get_Symb
     (Id : W_Name_Id)
     return Symbol;

   function Get_Namespace
     (Id : W_Name_Id)
     return Symbol;

   function Get_Module
     (Id : W_Name_Id)
     return W_Module_OId;

   function Get_Infix
     (Id : W_Name_Id)
     return Boolean;

   function Get_Reads
     (Id : W_Effects_Id)
     return W_Identifier_OList;

   function Get_Writes
     (Id : W_Effects_Id)
     return W_Identifier_OList;

   function Get_Raises
     (Id : W_Effects_Id)
     return W_Raise_Effect_OList;

   function Get_Name
     (Id : W_Raise_Effect_Id)
     return W_Name_Id;

   function Get_Arg_Id
     (Id : W_Raise_Effect_Id)
     return W_Identifier_OId;

   function Get_Post
     (Id : W_Raise_Effect_Id)
     return W_Pred_OId;

   function Get_Name
     (Id : W_Binder_Id)
     return W_Identifier_OId;

   function Get_Arg_Type
     (Id : W_Binder_Id)
     return W_Type_Id;

   function Get_Type_Definition
     (Id : W_Transparent_Type_Definition_Id)
     return W_Type_Id;

   function Get_Name
     (Id : W_Record_Binder_Id)
     return W_Identifier_OId;

   function Get_Arg_Type
     (Id : W_Record_Binder_Id)
     return W_Type_Id;

   function Get_Labels
     (Id : W_Record_Binder_Id)
     return Symbol_Set;

   function Get_Is_Mutable
     (Id : W_Record_Binder_Id)
     return Boolean;

   function Get_Fields
     (Id : W_Record_Definition_Id)
     return W_Record_Binder_List;

   function Get_First
     (Id : W_Range_Type_Definition_Id)
     return Uint;

   function Get_Last
     (Id : W_Range_Type_Definition_Id)
     return Uint;

   function Get_Triggers
     (Id : W_Triggers_Id)
     return W_Trigger_List;

   function Get_Terms
     (Id : W_Trigger_Id)
     return W_Expr_List;

   function Get_Name
     (Id : W_Axiom_Dep_Id)
     return W_Identifier_Id;

   function Get_Kind
     (Id : W_Axiom_Dep_Id)
     return EW_Axiom_Dep_Kind;

   function Get_Name
     (Id : W_Handler_Id)
     return W_Name_Id;

   function Get_Arg_Id
     (Id : W_Handler_Id)
     return W_Identifier_OId;

   function Get_Def
     (Id : W_Handler_Id)
     return W_Prog_Id;

   function Get_Field
     (Id : W_Field_Association_Id)
     return W_Identifier_Id;

   function Get_Value
     (Id : W_Field_Association_Id)
     return W_Expr_Id;

   function Get_Cmp_Op
     (Id : W_Variant_Id)
     return W_Identifier_Id;

   function Get_Labels
     (Id : W_Variant_Id)
     return Symbol_Set;

   function Get_Expr
     (Id : W_Variant_Id)
     return W_Term_Id;

   function Get_Variants
     (Id : W_Variants_Id)
     return W_Variant_List;

   function Get_Variables
     (Id : W_Universal_Quantif_Id)
     return W_Identifier_List;

   function Get_Labels
     (Id : W_Universal_Quantif_Id)
     return Symbol_Set;

   function Get_Var_Type
     (Id : W_Universal_Quantif_Id)
     return W_Type_Id;

   function Get_Triggers
     (Id : W_Universal_Quantif_Id)
     return W_Triggers_OId;

   function Get_Pred
     (Id : W_Universal_Quantif_Id)
     return W_Pred_Id;

   function Get_Variables
     (Id : W_Existential_Quantif_Id)
     return W_Identifier_List;

   function Get_Labels
     (Id : W_Existential_Quantif_Id)
     return Symbol_Set;

   function Get_Var_Type
     (Id : W_Existential_Quantif_Id)
     return W_Type_Id;

   function Get_Pred
     (Id : W_Existential_Quantif_Id)
     return W_Pred_Id;

   function Get_Right
     (Id : W_Not_Id)
     return W_Expr_Id;

   function Get_Left
     (Id : W_Connection_Id)
     return W_Expr_Id;

   function Get_Op
     (Id : W_Connection_Id)
     return EW_Connector;

   function Get_Right
     (Id : W_Connection_Id)
     return W_Expr_Id;

   function Get_More_Right
     (Id : W_Connection_Id)
     return W_Expr_OList;

   function Get_Labels
     (Id : W_Label_Id)
     return Symbol_Set;

   function Get_Def
     (Id : W_Label_Id)
     return W_Expr_Id;

   function Get_Typ
     (Id : W_Label_Id)
     return W_Type_OId;

   function Get_Sloc
     (Id : W_Loc_Label_Id)
     return Source_Ptr;

   function Get_Def
     (Id : W_Loc_Label_Id)
     return W_Expr_Id;

   function Get_Marker
     (Id : W_Loc_Label_Id)
     return Symbol;

   function Get_Name
     (Id : W_Identifier_Id)
     return W_Name_Id;

   function Get_Typ
     (Id : W_Identifier_Id)
     return W_Type_OId;

   function Get_Labels
     (Id : W_Identifier_Id)
     return String_Sets.Set;

   function Get_Tag
     (Id : W_Tagged_Id)
     return Symbol;

   function Get_Def
     (Id : W_Tagged_Id)
     return W_Expr_Id;

   function Get_Typ
     (Id : W_Tagged_Id)
     return W_Type_OId;

   function Get_Name
     (Id : W_Call_Id)
     return W_Identifier_Id;

   function Get_Args
     (Id : W_Call_Id)
     return W_Expr_OList;

   function Get_Typ
     (Id : W_Call_Id)
     return W_Type_OId;

   function Get_Value
     (Id : W_Literal_Id)
     return EW_Literal;

   function Get_Typ
     (Id : W_Literal_Id)
     return W_Type_OId;

   function Get_Name
     (Id : W_Binding_Id)
     return W_Identifier_Id;

   function Get_Def
     (Id : W_Binding_Id)
     return W_Expr_Id;

   function Get_Context
     (Id : W_Binding_Id)
     return W_Expr_Id;

   function Get_Typ
     (Id : W_Binding_Id)
     return W_Type_OId;

   function Get_Condition
     (Id : W_Elsif_Id)
     return W_Expr_Id;

   function Get_Then_Part
     (Id : W_Elsif_Id)
     return W_Expr_Id;

   function Get_Typ
     (Id : W_Elsif_Id)
     return W_Type_OId;

   function Get_Name
     (Id : W_Epsilon_Id)
     return W_Identifier_Id;

   function Get_Typ
     (Id : W_Epsilon_Id)
     return W_Type_Id;

   function Get_Pred
     (Id : W_Epsilon_Id)
     return W_Pred_Id;

   function Get_Condition
     (Id : W_Conditional_Id)
     return W_Expr_Id;

   function Get_Then_Part
     (Id : W_Conditional_Id)
     return W_Expr_Id;

   function Get_Elsif_Parts
     (Id : W_Conditional_Id)
     return W_Expr_OList;

   function Get_Else_Part
     (Id : W_Conditional_Id)
     return W_Expr_OId;

   function Get_Typ
     (Id : W_Conditional_Id)
     return W_Type_OId;

   function Get_Value
     (Id : W_Integer_Constant_Id)
     return Uint;

   function Get_Value
     (Id : W_Range_Constant_Id)
     return Uint;

   function Get_Typ
     (Id : W_Range_Constant_Id)
     return W_Type_Id;

   function Get_Value
     (Id : W_Modular_Constant_Id)
     return Uint;

   function Get_Typ
     (Id : W_Modular_Constant_Id)
     return W_Type_Id;

   function Get_Value
     (Id : W_Fixed_Constant_Id)
     return Uint;

   function Get_Typ
     (Id : W_Fixed_Constant_Id)
     return W_Type_Id;

   function Get_Value
     (Id : W_Real_Constant_Id)
     return Ureal;

   function Get_Value
     (Id : W_Float_Constant_Id)
     return Ureal;

   function Get_Typ
     (Id : W_Float_Constant_Id)
     return W_Type_Id;

   function Get_Comment
     (Id : W_Comment_Id)
     return Symbol;

   function Get_Right
     (Id : W_Deref_Id)
     return W_Identifier_Id;

   function Get_Typ
     (Id : W_Deref_Id)
     return W_Type_Id;

   function Get_Name
     (Id : W_Record_Access_Id)
     return W_Expr_Id;

   function Get_Field
     (Id : W_Record_Access_Id)
     return W_Identifier_Id;

   function Get_Typ
     (Id : W_Record_Access_Id)
     return W_Type_OId;

   function Get_Name
     (Id : W_Record_Update_Id)
     return W_Expr_Id;

   function Get_Updates
     (Id : W_Record_Update_Id)
     return W_Field_Association_List;

   function Get_Typ
     (Id : W_Record_Update_Id)
     return W_Type_OId;

   function Get_Associations
     (Id : W_Record_Aggregate_Id)
     return W_Field_Association_List;

   function Get_Typ
     (Id : W_Record_Aggregate_Id)
     return W_Type_OId;

   function Get_Effects
     (Id : W_Any_Expr_Id)
     return W_Effects_OId;

   function Get_Pre
     (Id : W_Any_Expr_Id)
     return W_Pred_OId;

   function Get_Post
     (Id : W_Any_Expr_Id)
     return W_Pred_OId;

   function Get_Return_Type
     (Id : W_Any_Expr_Id)
     return W_Type_Id;

   function Get_Labels
     (Id : W_Any_Expr_Id)
     return Symbol_Set;

   function Get_Name
     (Id : W_Assignment_Id)
     return W_Identifier_Id;

   function Get_Value
     (Id : W_Assignment_Id)
     return W_Prog_Id;

   function Get_Typ
     (Id : W_Assignment_Id)
     return W_Type_Id;

   function Get_Labels
     (Id : W_Assignment_Id)
     return Symbol_Set;

   function Get_Name
     (Id : W_Binding_Ref_Id)
     return W_Identifier_Id;

   function Get_Def
     (Id : W_Binding_Ref_Id)
     return W_Prog_Id;

   function Get_Context
     (Id : W_Binding_Ref_Id)
     return W_Prog_Id;

   function Get_Typ
     (Id : W_Binding_Ref_Id)
     return W_Type_Id;

   function Get_Code_Before
     (Id : W_Loop_Id)
     return W_Prog_Id;

   function Get_Invariants
     (Id : W_Loop_Id)
     return W_Pred_OList;

   function Get_Variants
     (Id : W_Loop_Id)
     return W_Variants_OList;

   function Get_Code_After
     (Id : W_Loop_Id)
     return W_Prog_Id;

   function Get_Statements
     (Id : W_Statement_Sequence_Id)
     return W_Prog_List;

   function Get_Expr
     (Id : W_Abstract_Expr_Id)
     return W_Prog_Id;

   function Get_Post
     (Id : W_Abstract_Expr_Id)
     return W_Pred_Id;

   function Get_Typ
     (Id : W_Abstract_Expr_Id)
     return W_Type_OId;

   function Get_Pred
     (Id : W_Assert_Id)
     return W_Pred_Id;

   function Get_Assert_Kind
     (Id : W_Assert_Id)
     return EW_Assert_Kind;

   function Get_Name
     (Id : W_Raise_Id)
     return W_Name_Id;

   function Get_Arg
     (Id : W_Raise_Id)
     return W_Expr_OId;

   function Get_Typ
     (Id : W_Raise_Id)
     return W_Type_OId;

   function Get_Prog
     (Id : W_Try_Block_Id)
     return W_Prog_Id;

   function Get_Handler
     (Id : W_Try_Block_Id)
     return W_Handler_List;

   function Get_Typ
     (Id : W_Try_Block_Id)
     return W_Type_OId;

   function Get_Name
     (Id : W_Function_Decl_Id)
     return W_Identifier_Id;

   function Get_Binders
     (Id : W_Function_Decl_Id)
     return W_Binder_OList;

   function Get_Effects
     (Id : W_Function_Decl_Id)
     return W_Effects_OId;

   function Get_Pre
     (Id : W_Function_Decl_Id)
     return W_Pred_OId;

   function Get_Post
     (Id : W_Function_Decl_Id)
     return W_Pred_OId;

   function Get_Return_Type
     (Id : W_Function_Decl_Id)
     return W_Type_OId;

   function Get_Def
     (Id : W_Function_Decl_Id)
     return W_Expr_OId;

   function Get_Labels
     (Id : W_Function_Decl_Id)
     return Symbol_Set;

   function Get_Location
     (Id : W_Function_Decl_Id)
     return Source_Ptr;

   function Get_Name
     (Id : W_Axiom_Id)
     return Symbol;

   function Get_Def
     (Id : W_Axiom_Id)
     return W_Pred_Id;

   function Get_Dep
     (Id : W_Axiom_Id)
     return W_Axiom_Dep_OId;

   function Get_Name
     (Id : W_Goal_Id)
     return Symbol;

   function Get_Def
     (Id : W_Goal_Id)
     return W_Pred_Id;

   function Get_Args
     (Id : W_Type_Decl_Id)
     return W_Identifier_OList;

   function Get_Name
     (Id : W_Type_Decl_Id)
     return W_Name_Id;

   function Get_Labels
     (Id : W_Type_Decl_Id)
     return Symbol_Set;

   function Get_Definition
     (Id : W_Type_Decl_Id)
     return W_Type_Definition_OId;

   function Get_Name
     (Id : W_Global_Ref_Declaration_Id)
     return W_Identifier_Id;

   function Get_Ref_Type
     (Id : W_Global_Ref_Declaration_Id)
     return W_Type_Id;

   function Get_Labels
     (Id : W_Global_Ref_Declaration_Id)
     return Symbol_Set;

   function Get_Location
     (Id : W_Global_Ref_Declaration_Id)
     return Source_Ptr;

   function Get_Declarations
     (Id : W_Namespace_Declaration_Id)
     return W_Declaration_OList;

   function Get_Name
     (Id : W_Namespace_Declaration_Id)
     return Symbol;

   function Get_Name
     (Id : W_Exception_Declaration_Id)
     return W_Name_Id;

   function Get_Arg
     (Id : W_Exception_Declaration_Id)
     return W_Type_OId;

   function Get_Name
     (Id : W_Meta_Declaration_Id)
     return Symbol;

   function Get_Parameter
     (Id : W_Meta_Declaration_Id)
     return Symbol;

   function Get_Origin
     (Id : W_Clone_Declaration_Id)
     return W_Module_Id;

   function Get_As_Name
     (Id : W_Clone_Declaration_Id)
     return Symbol;

   function Get_Clone_Kind
     (Id : W_Clone_Declaration_Id)
     return EW_Clone_Type;

   function Get_Substitutions
     (Id : W_Clone_Declaration_Id)
     return W_Clone_Substitution_OList;

   function Get_Theory_Kind
     (Id : W_Clone_Declaration_Id)
     return EW_Theory_Type;

   function Get_Kind
     (Id : W_Clone_Substitution_Id)
     return EW_Subst_Type;

   function Get_Orig_Name
     (Id : W_Clone_Substitution_Id)
     return W_Name_Id;

   function Get_Image
     (Id : W_Clone_Substitution_Id)
     return W_Name_Id;

   function Get_Module
     (Id : W_Include_Declaration_Id)
     return W_Module_Id;

   function Get_Kind
     (Id : W_Include_Declaration_Id)
     return EW_Theory_Type;

   function Get_Use_Kind
     (Id : W_Include_Declaration_Id)
     return EW_Clone_Type;

   function Get_Declarations
     (Id : W_Theory_Declaration_Id)
     return W_Declaration_OList;

   function Get_Name
     (Id : W_Theory_Declaration_Id)
     return Symbol;

   function Get_Kind
     (Id : W_Theory_Declaration_Id)
     return EW_Theory_Type;

   function Get_Includes
     (Id : W_Theory_Declaration_Id)
     return W_Include_Declaration_OList;

   function Get_Comment
     (Id : W_Theory_Declaration_Id)
     return Symbol;

   function Get_File
     (Id : W_Module_Id)
     return Symbol;

   function Get_Name
     (Id : W_Module_Id)
     return Symbol;

private

   function Get_Ada_Node
     (Id : Why_Node_Id)
     return Node_Id is
     (Node_Table (+Id).Ada_Node);

   function Get_Domain
     (Id : Why_Node_Id)
     return EW_Domain is
     (Node_Table (+Id).Domain);

   function Type_Get_Type_Kind
     (Id : W_Type_Unchecked_Id)
     return EW_Type is
     (Node_Table (+Id).K1_Type_Kind);

   function Type_Get_Name
     (Id : W_Type_Unchecked_Id)
     return W_Name_Unchecked_Id is
     (W_Name_Unchecked_OId
       (Node_Table (+Id).K1_Name))
     ;

   function Type_Get_Is_Mutable
     (Id : W_Type_Unchecked_Id)
     return Boolean is
     (Node_Table (+Id).K1_Is_Mutable);

   function Type_Get_Relaxed_Init
     (Id : W_Type_Unchecked_Id)
     return Boolean is
     (Node_Table (+Id).K1_Relaxed_Init);

   function Name_Get_Symb
     (Id : W_Name_Unchecked_Id)
     return Symbol is
     (Node_Table (+Id).K2_Symb);

   function Name_Get_Namespace
     (Id : W_Name_Unchecked_Id)
     return Symbol is
     (Node_Table (+Id).K2_Namespace);

   function Name_Get_Module
     (Id : W_Name_Unchecked_Id)
     return W_Module_Unchecked_OId is
     (W_Module_Unchecked_OId
       (Node_Table (+Id).K2_Module))
     ;

   function Name_Get_Infix
     (Id : W_Name_Unchecked_Id)
     return Boolean is
     (Node_Table (+Id).K2_Infix);

   function Effects_Get_Reads
     (Id : W_Effects_Unchecked_Id)
     return W_Identifier_Unchecked_OList is
     (W_Identifier_Unchecked_OList
       (Node_Table (+Id).K3_Reads))
     ;

   function Effects_Get_Writes
     (Id : W_Effects_Unchecked_Id)
     return W_Identifier_Unchecked_OList is
     (W_Identifier_Unchecked_OList
       (Node_Table (+Id).K3_Writes))
     ;

   function Effects_Get_Raises
     (Id : W_Effects_Unchecked_Id)
     return W_Raise_Effect_Unchecked_OList is
     (W_Raise_Effect_Unchecked_OList
       (Node_Table (+Id).K3_Raises))
     ;

   function Raise_Effect_Get_Name
     (Id : W_Raise_Effect_Unchecked_Id)
     return W_Name_Unchecked_Id is
     (W_Name_Unchecked_OId
       (Node_Table (+Id).K4_Name))
     ;

   function Raise_Effect_Get_Arg_Id
     (Id : W_Raise_Effect_Unchecked_Id)
     return W_Identifier_Unchecked_OId is
     (W_Identifier_Unchecked_OId
       (Node_Table (+Id).K4_Arg_Id))
     ;

   function Raise_Effect_Get_Post
     (Id : W_Raise_Effect_Unchecked_Id)
     return W_Pred_Unchecked_OId is
     (W_Pred_Unchecked_OId
       (Node_Table (+Id).K4_Post))
     ;

   function Binder_Get_Name
     (Id : W_Binder_Unchecked_Id)
     return W_Identifier_Unchecked_OId is
     (W_Identifier_Unchecked_OId
       (Node_Table (+Id).K5_Name))
     ;

   function Binder_Get_Arg_Type
     (Id : W_Binder_Unchecked_Id)
     return W_Type_Unchecked_Id is
     (W_Type_Unchecked_OId
       (Node_Table (+Id).K5_Arg_Type))
     ;

   function Transparent_Type_Definition_Get_Type_Definition
     (Id : W_Transparent_Type_Definition_Unchecked_Id)
     return W_Type_Unchecked_Id is
     (W_Type_Unchecked_OId
       (Node_Table (+Id).K6_Type_Definition))
     ;

   function Record_Binder_Get_Name
     (Id : W_Record_Binder_Unchecked_Id)
     return W_Identifier_Unchecked_OId is
     (W_Identifier_Unchecked_OId
       (Node_Table (+Id).K7_Name))
     ;

   function Record_Binder_Get_Arg_Type
     (Id : W_Record_Binder_Unchecked_Id)
     return W_Type_Unchecked_Id is
     (W_Type_Unchecked_OId
       (Node_Table (+Id).K7_Arg_Type))
     ;

   function Record_Binder_Get_Labels
     (Id : W_Record_Binder_Unchecked_Id)
     return Symbol_Set is
     (Node_Table (+Id).K7_Labels);

   function Record_Binder_Get_Is_Mutable
     (Id : W_Record_Binder_Unchecked_Id)
     return Boolean is
     (Node_Table (+Id).K7_Is_Mutable);

   function Record_Definition_Get_Fields
     (Id : W_Record_Definition_Unchecked_Id)
     return W_Record_Binder_Unchecked_List is
     (W_Record_Binder_Unchecked_OList
       (Node_Table (+Id).K8_Fields))
     ;

   function Range_Type_Definition_Get_First
     (Id : W_Range_Type_Definition_Unchecked_Id)
     return Uint is
     (Node_Table (+Id).K9_First);

   function Range_Type_Definition_Get_Last
     (Id : W_Range_Type_Definition_Unchecked_Id)
     return Uint is
     (Node_Table (+Id).K9_Last);

   function Triggers_Get_Triggers
     (Id : W_Triggers_Unchecked_Id)
     return W_Trigger_Unchecked_List is
     (W_Trigger_Unchecked_OList
       (Node_Table (+Id).K10_Triggers))
     ;

   function Trigger_Get_Terms
     (Id : W_Trigger_Unchecked_Id)
     return W_Expr_Unchecked_List is
     (W_Expr_Unchecked_OList
       (Node_Table (+Id).K11_Terms))
     ;

   function Axiom_Dep_Get_Name
     (Id : W_Axiom_Dep_Unchecked_Id)
     return W_Identifier_Unchecked_Id is
     (W_Identifier_Unchecked_OId
       (Node_Table (+Id).K12_Name))
     ;

   function Axiom_Dep_Get_Kind
     (Id : W_Axiom_Dep_Unchecked_Id)
     return EW_Axiom_Dep_Kind is
     (Node_Table (+Id).K12_Kind);

   function Handler_Get_Name
     (Id : W_Handler_Unchecked_Id)
     return W_Name_Unchecked_Id is
     (W_Name_Unchecked_OId
       (Node_Table (+Id).K13_Name))
     ;

   function Handler_Get_Arg_Id
     (Id : W_Handler_Unchecked_Id)
     return W_Identifier_Unchecked_OId is
     (W_Identifier_Unchecked_OId
       (Node_Table (+Id).K13_Arg_Id))
     ;

   function Handler_Get_Def
     (Id : W_Handler_Unchecked_Id)
     return W_Prog_Unchecked_Id is
     (W_Prog_Unchecked_OId
       (Node_Table (+Id).K13_Def))
     ;

   function Field_Association_Get_Field
     (Id : W_Field_Association_Unchecked_Id)
     return W_Identifier_Unchecked_Id is
     (W_Identifier_Unchecked_OId
       (Node_Table (+Id).K14_Field))
     ;

   function Field_Association_Get_Value
     (Id : W_Field_Association_Unchecked_Id)
     return W_Expr_Unchecked_Id is
     (W_Expr_Unchecked_OId
       (Node_Table (+Id).K14_Value))
     ;

   function Variant_Get_Cmp_Op
     (Id : W_Variant_Unchecked_Id)
     return W_Identifier_Unchecked_Id is
     (W_Identifier_Unchecked_OId
       (Node_Table (+Id).K15_Cmp_Op))
     ;

   function Variant_Get_Labels
     (Id : W_Variant_Unchecked_Id)
     return Symbol_Set is
     (Node_Table (+Id).K15_Labels);

   function Variant_Get_Expr
     (Id : W_Variant_Unchecked_Id)
     return W_Term_Unchecked_Id is
     (W_Term_Unchecked_OId
       (Node_Table (+Id).K15_Expr))
     ;

   function Variants_Get_Variants
     (Id : W_Variants_Unchecked_Id)
     return W_Variant_Unchecked_List is
     (W_Variant_Unchecked_OList
       (Node_Table (+Id).K16_Variants))
     ;

   function Universal_Quantif_Get_Variables
     (Id : W_Universal_Quantif_Unchecked_Id)
     return W_Identifier_Unchecked_List is
     (W_Identifier_Unchecked_OList
       (Node_Table (+Id).K17_Variables))
     ;

   function Universal_Quantif_Get_Labels
     (Id : W_Universal_Quantif_Unchecked_Id)
     return Symbol_Set is
     (Node_Table (+Id).K17_Labels);

   function Universal_Quantif_Get_Var_Type
     (Id : W_Universal_Quantif_Unchecked_Id)
     return W_Type_Unchecked_Id is
     (W_Type_Unchecked_OId
       (Node_Table (+Id).K17_Var_Type))
     ;

   function Universal_Quantif_Get_Triggers
     (Id : W_Universal_Quantif_Unchecked_Id)
     return W_Triggers_Unchecked_OId is
     (W_Triggers_Unchecked_OId
       (Node_Table (+Id).K17_Triggers))
     ;

   function Universal_Quantif_Get_Pred
     (Id : W_Universal_Quantif_Unchecked_Id)
     return W_Pred_Unchecked_Id is
     (W_Pred_Unchecked_OId
       (Node_Table (+Id).K17_Pred))
     ;

   function Existential_Quantif_Get_Variables
     (Id : W_Existential_Quantif_Unchecked_Id)
     return W_Identifier_Unchecked_List is
     (W_Identifier_Unchecked_OList
       (Node_Table (+Id).K18_Variables))
     ;

   function Existential_Quantif_Get_Labels
     (Id : W_Existential_Quantif_Unchecked_Id)
     return Symbol_Set is
     (Node_Table (+Id).K18_Labels);

   function Existential_Quantif_Get_Var_Type
     (Id : W_Existential_Quantif_Unchecked_Id)
     return W_Type_Unchecked_Id is
     (W_Type_Unchecked_OId
       (Node_Table (+Id).K18_Var_Type))
     ;

   function Existential_Quantif_Get_Pred
     (Id : W_Existential_Quantif_Unchecked_Id)
     return W_Pred_Unchecked_Id is
     (W_Pred_Unchecked_OId
       (Node_Table (+Id).K18_Pred))
     ;

   function Not_Get_Right
     (Id : W_Not_Unchecked_Id)
     return W_Expr_Unchecked_Id is
     (W_Expr_Unchecked_OId
       (Node_Table (+Id).K19_Right))
     ;

   function Connection_Get_Left
     (Id : W_Connection_Unchecked_Id)
     return W_Expr_Unchecked_Id is
     (W_Expr_Unchecked_OId
       (Node_Table (+Id).K20_Left))
     ;

   function Connection_Get_Op
     (Id : W_Connection_Unchecked_Id)
     return EW_Connector is
     (Node_Table (+Id).K20_Op);

   function Connection_Get_Right
     (Id : W_Connection_Unchecked_Id)
     return W_Expr_Unchecked_Id is
     (W_Expr_Unchecked_OId
       (Node_Table (+Id).K20_Right))
     ;

   function Connection_Get_More_Right
     (Id : W_Connection_Unchecked_Id)
     return W_Expr_Unchecked_OList is
     (W_Expr_Unchecked_OList
       (Node_Table (+Id).K20_More_Right))
     ;

   function Label_Get_Labels
     (Id : W_Label_Unchecked_Id)
     return Symbol_Set is
     (Node_Table (+Id).K21_Labels);

   function Label_Get_Def
     (Id : W_Label_Unchecked_Id)
     return W_Expr_Unchecked_Id is
     (W_Expr_Unchecked_OId
       (Node_Table (+Id).K21_Def))
     ;

   function Label_Get_Typ
     (Id : W_Label_Unchecked_Id)
     return W_Type_Unchecked_OId is
     (W_Type_Unchecked_OId
       (Node_Table (+Id).K21_Typ))
     ;

   function Loc_Label_Get_Sloc
     (Id : W_Loc_Label_Unchecked_Id)
     return Source_Ptr is
     (Node_Table (+Id).K22_Sloc);

   function Loc_Label_Get_Def
     (Id : W_Loc_Label_Unchecked_Id)
     return W_Expr_Unchecked_Id is
     (W_Expr_Unchecked_OId
       (Node_Table (+Id).K22_Def))
     ;

   function Loc_Label_Get_Marker
     (Id : W_Loc_Label_Unchecked_Id)
     return Symbol is
     (Node_Table (+Id).K22_Marker);

   function Identifier_Get_Name
     (Id : W_Identifier_Unchecked_Id)
     return W_Name_Unchecked_Id is
     (W_Name_Unchecked_OId
       (Node_Table (+Id).K23_Name))
     ;

   function Identifier_Get_Typ
     (Id : W_Identifier_Unchecked_Id)
     return W_Type_Unchecked_OId is
     (W_Type_Unchecked_OId
       (Node_Table (+Id).K23_Typ))
     ;

   function Identifier_Get_Labels
     (Id : W_Identifier_Unchecked_Id)
     return String_Sets.Set is
     (Node_Table (+Id).K23_Labels);

   function Tagged_Get_Tag
     (Id : W_Tagged_Unchecked_Id)
     return Symbol is
     (Node_Table (+Id).K24_Tag);

   function Tagged_Get_Def
     (Id : W_Tagged_Unchecked_Id)
     return W_Expr_Unchecked_Id is
     (W_Expr_Unchecked_OId
       (Node_Table (+Id).K24_Def))
     ;

   function Tagged_Get_Typ
     (Id : W_Tagged_Unchecked_Id)
     return W_Type_Unchecked_OId is
     (W_Type_Unchecked_OId
       (Node_Table (+Id).K24_Typ))
     ;

   function Call_Get_Name
     (Id : W_Call_Unchecked_Id)
     return W_Identifier_Unchecked_Id is
     (W_Identifier_Unchecked_OId
       (Node_Table (+Id).K25_Name))
     ;

   function Call_Get_Args
     (Id : W_Call_Unchecked_Id)
     return W_Expr_Unchecked_OList is
     (W_Expr_Unchecked_OList
       (Node_Table (+Id).K25_Args))
     ;

   function Call_Get_Typ
     (Id : W_Call_Unchecked_Id)
     return W_Type_Unchecked_OId is
     (W_Type_Unchecked_OId
       (Node_Table (+Id).K25_Typ))
     ;

   function Literal_Get_Value
     (Id : W_Literal_Unchecked_Id)
     return EW_Literal is
     (Node_Table (+Id).K26_Value);

   function Literal_Get_Typ
     (Id : W_Literal_Unchecked_Id)
     return W_Type_Unchecked_OId is
     (W_Type_Unchecked_OId
       (Node_Table (+Id).K26_Typ))
     ;

   function Binding_Get_Name
     (Id : W_Binding_Unchecked_Id)
     return W_Identifier_Unchecked_Id is
     (W_Identifier_Unchecked_OId
       (Node_Table (+Id).K27_Name))
     ;

   function Binding_Get_Def
     (Id : W_Binding_Unchecked_Id)
     return W_Expr_Unchecked_Id is
     (W_Expr_Unchecked_OId
       (Node_Table (+Id).K27_Def))
     ;

   function Binding_Get_Context
     (Id : W_Binding_Unchecked_Id)
     return W_Expr_Unchecked_Id is
     (W_Expr_Unchecked_OId
       (Node_Table (+Id).K27_Context))
     ;

   function Binding_Get_Typ
     (Id : W_Binding_Unchecked_Id)
     return W_Type_Unchecked_OId is
     (W_Type_Unchecked_OId
       (Node_Table (+Id).K27_Typ))
     ;

   function Elsif_Get_Condition
     (Id : W_Elsif_Unchecked_Id)
     return W_Expr_Unchecked_Id is
     (W_Expr_Unchecked_OId
       (Node_Table (+Id).K28_Condition))
     ;

   function Elsif_Get_Then_Part
     (Id : W_Elsif_Unchecked_Id)
     return W_Expr_Unchecked_Id is
     (W_Expr_Unchecked_OId
       (Node_Table (+Id).K28_Then_Part))
     ;

   function Elsif_Get_Typ
     (Id : W_Elsif_Unchecked_Id)
     return W_Type_Unchecked_OId is
     (W_Type_Unchecked_OId
       (Node_Table (+Id).K28_Typ))
     ;

   function Epsilon_Get_Name
     (Id : W_Epsilon_Unchecked_Id)
     return W_Identifier_Unchecked_Id is
     (W_Identifier_Unchecked_OId
       (Node_Table (+Id).K29_Name))
     ;

   function Epsilon_Get_Typ
     (Id : W_Epsilon_Unchecked_Id)
     return W_Type_Unchecked_Id is
     (W_Type_Unchecked_OId
       (Node_Table (+Id).K29_Typ))
     ;

   function Epsilon_Get_Pred
     (Id : W_Epsilon_Unchecked_Id)
     return W_Pred_Unchecked_Id is
     (W_Pred_Unchecked_OId
       (Node_Table (+Id).K29_Pred))
     ;

   function Conditional_Get_Condition
     (Id : W_Conditional_Unchecked_Id)
     return W_Expr_Unchecked_Id is
     (W_Expr_Unchecked_OId
       (Node_Table (+Id).K30_Condition))
     ;

   function Conditional_Get_Then_Part
     (Id : W_Conditional_Unchecked_Id)
     return W_Expr_Unchecked_Id is
     (W_Expr_Unchecked_OId
       (Node_Table (+Id).K30_Then_Part))
     ;

   function Conditional_Get_Elsif_Parts
     (Id : W_Conditional_Unchecked_Id)
     return W_Expr_Unchecked_OList is
     (W_Expr_Unchecked_OList
       (Node_Table (+Id).K30_Elsif_Parts))
     ;

   function Conditional_Get_Else_Part
     (Id : W_Conditional_Unchecked_Id)
     return W_Expr_Unchecked_OId is
     (W_Expr_Unchecked_OId
       (Node_Table (+Id).K30_Else_Part))
     ;

   function Conditional_Get_Typ
     (Id : W_Conditional_Unchecked_Id)
     return W_Type_Unchecked_OId is
     (W_Type_Unchecked_OId
       (Node_Table (+Id).K30_Typ))
     ;

   function Integer_Constant_Get_Value
     (Id : W_Integer_Constant_Unchecked_Id)
     return Uint is
     (Node_Table (+Id).K31_Value);

   function Range_Constant_Get_Value
     (Id : W_Range_Constant_Unchecked_Id)
     return Uint is
     (Node_Table (+Id).K32_Value);

   function Range_Constant_Get_Typ
     (Id : W_Range_Constant_Unchecked_Id)
     return W_Type_Unchecked_Id is
     (W_Type_Unchecked_OId
       (Node_Table (+Id).K32_Typ))
     ;

   function Modular_Constant_Get_Value
     (Id : W_Modular_Constant_Unchecked_Id)
     return Uint is
     (Node_Table (+Id).K33_Value);

   function Modular_Constant_Get_Typ
     (Id : W_Modular_Constant_Unchecked_Id)
     return W_Type_Unchecked_Id is
     (W_Type_Unchecked_OId
       (Node_Table (+Id).K33_Typ))
     ;

   function Fixed_Constant_Get_Value
     (Id : W_Fixed_Constant_Unchecked_Id)
     return Uint is
     (Node_Table (+Id).K34_Value);

   function Fixed_Constant_Get_Typ
     (Id : W_Fixed_Constant_Unchecked_Id)
     return W_Type_Unchecked_Id is
     (W_Type_Unchecked_OId
       (Node_Table (+Id).K34_Typ))
     ;

   function Real_Constant_Get_Value
     (Id : W_Real_Constant_Unchecked_Id)
     return Ureal is
     (Node_Table (+Id).K35_Value);

   function Float_Constant_Get_Value
     (Id : W_Float_Constant_Unchecked_Id)
     return Ureal is
     (Node_Table (+Id).K36_Value);

   function Float_Constant_Get_Typ
     (Id : W_Float_Constant_Unchecked_Id)
     return W_Type_Unchecked_Id is
     (W_Type_Unchecked_OId
       (Node_Table (+Id).K36_Typ))
     ;

   function Comment_Get_Comment
     (Id : W_Comment_Unchecked_Id)
     return Symbol is
     (Node_Table (+Id).K37_Comment);

   function Deref_Get_Right
     (Id : W_Deref_Unchecked_Id)
     return W_Identifier_Unchecked_Id is
     (W_Identifier_Unchecked_OId
       (Node_Table (+Id).K38_Right))
     ;

   function Deref_Get_Typ
     (Id : W_Deref_Unchecked_Id)
     return W_Type_Unchecked_Id is
     (W_Type_Unchecked_OId
       (Node_Table (+Id).K38_Typ))
     ;

   function Record_Access_Get_Name
     (Id : W_Record_Access_Unchecked_Id)
     return W_Expr_Unchecked_Id is
     (W_Expr_Unchecked_OId
       (Node_Table (+Id).K39_Name))
     ;

   function Record_Access_Get_Field
     (Id : W_Record_Access_Unchecked_Id)
     return W_Identifier_Unchecked_Id is
     (W_Identifier_Unchecked_OId
       (Node_Table (+Id).K39_Field))
     ;

   function Record_Access_Get_Typ
     (Id : W_Record_Access_Unchecked_Id)
     return W_Type_Unchecked_OId is
     (W_Type_Unchecked_OId
       (Node_Table (+Id).K39_Typ))
     ;

   function Record_Update_Get_Name
     (Id : W_Record_Update_Unchecked_Id)
     return W_Expr_Unchecked_Id is
     (W_Expr_Unchecked_OId
       (Node_Table (+Id).K40_Name))
     ;

   function Record_Update_Get_Updates
     (Id : W_Record_Update_Unchecked_Id)
     return W_Field_Association_Unchecked_List is
     (W_Field_Association_Unchecked_OList
       (Node_Table (+Id).K40_Updates))
     ;

   function Record_Update_Get_Typ
     (Id : W_Record_Update_Unchecked_Id)
     return W_Type_Unchecked_OId is
     (W_Type_Unchecked_OId
       (Node_Table (+Id).K40_Typ))
     ;

   function Record_Aggregate_Get_Associations
     (Id : W_Record_Aggregate_Unchecked_Id)
     return W_Field_Association_Unchecked_List is
     (W_Field_Association_Unchecked_OList
       (Node_Table (+Id).K41_Associations))
     ;

   function Record_Aggregate_Get_Typ
     (Id : W_Record_Aggregate_Unchecked_Id)
     return W_Type_Unchecked_OId is
     (W_Type_Unchecked_OId
       (Node_Table (+Id).K41_Typ))
     ;

   function Any_Expr_Get_Effects
     (Id : W_Any_Expr_Unchecked_Id)
     return W_Effects_Unchecked_OId is
     (W_Effects_Unchecked_OId
       (Node_Table (+Id).K42_Effects))
     ;

   function Any_Expr_Get_Pre
     (Id : W_Any_Expr_Unchecked_Id)
     return W_Pred_Unchecked_OId is
     (W_Pred_Unchecked_OId
       (Node_Table (+Id).K42_Pre))
     ;

   function Any_Expr_Get_Post
     (Id : W_Any_Expr_Unchecked_Id)
     return W_Pred_Unchecked_OId is
     (W_Pred_Unchecked_OId
       (Node_Table (+Id).K42_Post))
     ;

   function Any_Expr_Get_Return_Type
     (Id : W_Any_Expr_Unchecked_Id)
     return W_Type_Unchecked_Id is
     (W_Type_Unchecked_OId
       (Node_Table (+Id).K42_Return_Type))
     ;

   function Any_Expr_Get_Labels
     (Id : W_Any_Expr_Unchecked_Id)
     return Symbol_Set is
     (Node_Table (+Id).K42_Labels);

   function Assignment_Get_Name
     (Id : W_Assignment_Unchecked_Id)
     return W_Identifier_Unchecked_Id is
     (W_Identifier_Unchecked_OId
       (Node_Table (+Id).K43_Name))
     ;

   function Assignment_Get_Value
     (Id : W_Assignment_Unchecked_Id)
     return W_Prog_Unchecked_Id is
     (W_Prog_Unchecked_OId
       (Node_Table (+Id).K43_Value))
     ;

   function Assignment_Get_Typ
     (Id : W_Assignment_Unchecked_Id)
     return W_Type_Unchecked_Id is
     (W_Type_Unchecked_OId
       (Node_Table (+Id).K43_Typ))
     ;

   function Assignment_Get_Labels
     (Id : W_Assignment_Unchecked_Id)
     return Symbol_Set is
     (Node_Table (+Id).K43_Labels);

   function Binding_Ref_Get_Name
     (Id : W_Binding_Ref_Unchecked_Id)
     return W_Identifier_Unchecked_Id is
     (W_Identifier_Unchecked_OId
       (Node_Table (+Id).K44_Name))
     ;

   function Binding_Ref_Get_Def
     (Id : W_Binding_Ref_Unchecked_Id)
     return W_Prog_Unchecked_Id is
     (W_Prog_Unchecked_OId
       (Node_Table (+Id).K44_Def))
     ;

   function Binding_Ref_Get_Context
     (Id : W_Binding_Ref_Unchecked_Id)
     return W_Prog_Unchecked_Id is
     (W_Prog_Unchecked_OId
       (Node_Table (+Id).K44_Context))
     ;

   function Binding_Ref_Get_Typ
     (Id : W_Binding_Ref_Unchecked_Id)
     return W_Type_Unchecked_Id is
     (W_Type_Unchecked_OId
       (Node_Table (+Id).K44_Typ))
     ;

   function Loop_Get_Code_Before
     (Id : W_Loop_Unchecked_Id)
     return W_Prog_Unchecked_Id is
     (W_Prog_Unchecked_OId
       (Node_Table (+Id).K45_Code_Before))
     ;

   function Loop_Get_Invariants
     (Id : W_Loop_Unchecked_Id)
     return W_Pred_Unchecked_OList is
     (W_Pred_Unchecked_OList
       (Node_Table (+Id).K45_Invariants))
     ;

   function Loop_Get_Variants
     (Id : W_Loop_Unchecked_Id)
     return W_Variants_Unchecked_OList is
     (W_Variants_Unchecked_OList
       (Node_Table (+Id).K45_Variants))
     ;

   function Loop_Get_Code_After
     (Id : W_Loop_Unchecked_Id)
     return W_Prog_Unchecked_Id is
     (W_Prog_Unchecked_OId
       (Node_Table (+Id).K45_Code_After))
     ;

   function Statement_Sequence_Get_Statements
     (Id : W_Statement_Sequence_Unchecked_Id)
     return W_Prog_Unchecked_List is
     (W_Prog_Unchecked_OList
       (Node_Table (+Id).K46_Statements))
     ;

   function Abstract_Expr_Get_Expr
     (Id : W_Abstract_Expr_Unchecked_Id)
     return W_Prog_Unchecked_Id is
     (W_Prog_Unchecked_OId
       (Node_Table (+Id).K47_Expr))
     ;

   function Abstract_Expr_Get_Post
     (Id : W_Abstract_Expr_Unchecked_Id)
     return W_Pred_Unchecked_Id is
     (W_Pred_Unchecked_OId
       (Node_Table (+Id).K47_Post))
     ;

   function Abstract_Expr_Get_Typ
     (Id : W_Abstract_Expr_Unchecked_Id)
     return W_Type_Unchecked_OId is
     (W_Type_Unchecked_OId
       (Node_Table (+Id).K47_Typ))
     ;

   function Assert_Get_Pred
     (Id : W_Assert_Unchecked_Id)
     return W_Pred_Unchecked_Id is
     (W_Pred_Unchecked_OId
       (Node_Table (+Id).K48_Pred))
     ;

   function Assert_Get_Assert_Kind
     (Id : W_Assert_Unchecked_Id)
     return EW_Assert_Kind is
     (Node_Table (+Id).K48_Assert_Kind);

   function Raise_Get_Name
     (Id : W_Raise_Unchecked_Id)
     return W_Name_Unchecked_Id is
     (W_Name_Unchecked_OId
       (Node_Table (+Id).K49_Name))
     ;

   function Raise_Get_Arg
     (Id : W_Raise_Unchecked_Id)
     return W_Expr_Unchecked_OId is
     (W_Expr_Unchecked_OId
       (Node_Table (+Id).K49_Arg))
     ;

   function Raise_Get_Typ
     (Id : W_Raise_Unchecked_Id)
     return W_Type_Unchecked_OId is
     (W_Type_Unchecked_OId
       (Node_Table (+Id).K49_Typ))
     ;

   function Try_Block_Get_Prog
     (Id : W_Try_Block_Unchecked_Id)
     return W_Prog_Unchecked_Id is
     (W_Prog_Unchecked_OId
       (Node_Table (+Id).K50_Prog))
     ;

   function Try_Block_Get_Handler
     (Id : W_Try_Block_Unchecked_Id)
     return W_Handler_Unchecked_List is
     (W_Handler_Unchecked_OList
       (Node_Table (+Id).K50_Handler))
     ;

   function Try_Block_Get_Typ
     (Id : W_Try_Block_Unchecked_Id)
     return W_Type_Unchecked_OId is
     (W_Type_Unchecked_OId
       (Node_Table (+Id).K50_Typ))
     ;

   function Function_Decl_Get_Name
     (Id : W_Function_Decl_Unchecked_Id)
     return W_Identifier_Unchecked_Id is
     (W_Identifier_Unchecked_OId
       (Node_Table (+Id).K51_Name))
     ;

   function Function_Decl_Get_Binders
     (Id : W_Function_Decl_Unchecked_Id)
     return W_Binder_Unchecked_OList is
     (W_Binder_Unchecked_OList
       (Node_Table (+Id).K51_Binders))
     ;

   function Function_Decl_Get_Effects
     (Id : W_Function_Decl_Unchecked_Id)
     return W_Effects_Unchecked_OId is
     (W_Effects_Unchecked_OId
       (Node_Table (+Id).K51_Effects))
     ;

   function Function_Decl_Get_Pre
     (Id : W_Function_Decl_Unchecked_Id)
     return W_Pred_Unchecked_OId is
     (W_Pred_Unchecked_OId
       (Node_Table (+Id).K51_Pre))
     ;

   function Function_Decl_Get_Post
     (Id : W_Function_Decl_Unchecked_Id)
     return W_Pred_Unchecked_OId is
     (W_Pred_Unchecked_OId
       (Node_Table (+Id).K51_Post))
     ;

   function Function_Decl_Get_Return_Type
     (Id : W_Function_Decl_Unchecked_Id)
     return W_Type_Unchecked_OId is
     (W_Type_Unchecked_OId
       (Node_Table (+Id).K51_Return_Type))
     ;

   function Function_Decl_Get_Def
     (Id : W_Function_Decl_Unchecked_Id)
     return W_Expr_Unchecked_OId is
     (W_Expr_Unchecked_OId
       (Node_Table (+Id).K51_Def))
     ;

   function Function_Decl_Get_Labels
     (Id : W_Function_Decl_Unchecked_Id)
     return Symbol_Set is
     (Node_Table (+Id).K51_Labels);

   function Function_Decl_Get_Location
     (Id : W_Function_Decl_Unchecked_Id)
     return Source_Ptr is
     (Node_Table (+Id).K51_Location);

   function Axiom_Get_Name
     (Id : W_Axiom_Unchecked_Id)
     return Symbol is
     (Node_Table (+Id).K52_Name);

   function Axiom_Get_Def
     (Id : W_Axiom_Unchecked_Id)
     return W_Pred_Unchecked_Id is
     (W_Pred_Unchecked_OId
       (Node_Table (+Id).K52_Def))
     ;

   function Axiom_Get_Dep
     (Id : W_Axiom_Unchecked_Id)
     return W_Axiom_Dep_Unchecked_OId is
     (W_Axiom_Dep_Unchecked_OId
       (Node_Table (+Id).K52_Dep))
     ;

   function Goal_Get_Name
     (Id : W_Goal_Unchecked_Id)
     return Symbol is
     (Node_Table (+Id).K53_Name);

   function Goal_Get_Def
     (Id : W_Goal_Unchecked_Id)
     return W_Pred_Unchecked_Id is
     (W_Pred_Unchecked_OId
       (Node_Table (+Id).K53_Def))
     ;

   function Type_Decl_Get_Args
     (Id : W_Type_Decl_Unchecked_Id)
     return W_Identifier_Unchecked_OList is
     (W_Identifier_Unchecked_OList
       (Node_Table (+Id).K54_Args))
     ;

   function Type_Decl_Get_Name
     (Id : W_Type_Decl_Unchecked_Id)
     return W_Name_Unchecked_Id is
     (W_Name_Unchecked_OId
       (Node_Table (+Id).K54_Name))
     ;

   function Type_Decl_Get_Labels
     (Id : W_Type_Decl_Unchecked_Id)
     return Symbol_Set is
     (Node_Table (+Id).K54_Labels);

   function Type_Decl_Get_Definition
     (Id : W_Type_Decl_Unchecked_Id)
     return W_Type_Definition_Unchecked_OId is
     (W_Type_Definition_Unchecked_OId
       (Node_Table (+Id).K54_Definition))
     ;

   function Global_Ref_Declaration_Get_Name
     (Id : W_Global_Ref_Declaration_Unchecked_Id)
     return W_Identifier_Unchecked_Id is
     (W_Identifier_Unchecked_OId
       (Node_Table (+Id).K55_Name))
     ;

   function Global_Ref_Declaration_Get_Ref_Type
     (Id : W_Global_Ref_Declaration_Unchecked_Id)
     return W_Type_Unchecked_Id is
     (W_Type_Unchecked_OId
       (Node_Table (+Id).K55_Ref_Type))
     ;

   function Global_Ref_Declaration_Get_Labels
     (Id : W_Global_Ref_Declaration_Unchecked_Id)
     return Symbol_Set is
     (Node_Table (+Id).K55_Labels);

   function Global_Ref_Declaration_Get_Location
     (Id : W_Global_Ref_Declaration_Unchecked_Id)
     return Source_Ptr is
     (Node_Table (+Id).K55_Location);

   function Namespace_Declaration_Get_Declarations
     (Id : W_Namespace_Declaration_Unchecked_Id)
     return W_Declaration_Unchecked_OList is
     (W_Declaration_Unchecked_OList
       (Node_Table (+Id).K56_Declarations))
     ;

   function Namespace_Declaration_Get_Name
     (Id : W_Namespace_Declaration_Unchecked_Id)
     return Symbol is
     (Node_Table (+Id).K56_Name);

   function Exception_Declaration_Get_Name
     (Id : W_Exception_Declaration_Unchecked_Id)
     return W_Name_Unchecked_Id is
     (W_Name_Unchecked_OId
       (Node_Table (+Id).K57_Name))
     ;

   function Exception_Declaration_Get_Arg
     (Id : W_Exception_Declaration_Unchecked_Id)
     return W_Type_Unchecked_OId is
     (W_Type_Unchecked_OId
       (Node_Table (+Id).K57_Arg))
     ;

   function Meta_Declaration_Get_Name
     (Id : W_Meta_Declaration_Unchecked_Id)
     return Symbol is
     (Node_Table (+Id).K58_Name);

   function Meta_Declaration_Get_Parameter
     (Id : W_Meta_Declaration_Unchecked_Id)
     return Symbol is
     (Node_Table (+Id).K58_Parameter);

   function Clone_Declaration_Get_Origin
     (Id : W_Clone_Declaration_Unchecked_Id)
     return W_Module_Unchecked_Id is
     (W_Module_Unchecked_OId
       (Node_Table (+Id).K59_Origin))
     ;

   function Clone_Declaration_Get_As_Name
     (Id : W_Clone_Declaration_Unchecked_Id)
     return Symbol is
     (Node_Table (+Id).K59_As_Name);

   function Clone_Declaration_Get_Clone_Kind
     (Id : W_Clone_Declaration_Unchecked_Id)
     return EW_Clone_Type is
     (Node_Table (+Id).K59_Clone_Kind);

   function Clone_Declaration_Get_Substitutions
     (Id : W_Clone_Declaration_Unchecked_Id)
     return W_Clone_Substitution_Unchecked_OList is
     (W_Clone_Substitution_Unchecked_OList
       (Node_Table (+Id).K59_Substitutions))
     ;

   function Clone_Declaration_Get_Theory_Kind
     (Id : W_Clone_Declaration_Unchecked_Id)
     return EW_Theory_Type is
     (Node_Table (+Id).K59_Theory_Kind);

   function Clone_Substitution_Get_Kind
     (Id : W_Clone_Substitution_Unchecked_Id)
     return EW_Subst_Type is
     (Node_Table (+Id).K60_Kind);

   function Clone_Substitution_Get_Orig_Name
     (Id : W_Clone_Substitution_Unchecked_Id)
     return W_Name_Unchecked_Id is
     (W_Name_Unchecked_OId
       (Node_Table (+Id).K60_Orig_Name))
     ;

   function Clone_Substitution_Get_Image
     (Id : W_Clone_Substitution_Unchecked_Id)
     return W_Name_Unchecked_Id is
     (W_Name_Unchecked_OId
       (Node_Table (+Id).K60_Image))
     ;

   function Include_Declaration_Get_Module
     (Id : W_Include_Declaration_Unchecked_Id)
     return W_Module_Unchecked_Id is
     (W_Module_Unchecked_OId
       (Node_Table (+Id).K61_Module))
     ;

   function Include_Declaration_Get_Kind
     (Id : W_Include_Declaration_Unchecked_Id)
     return EW_Theory_Type is
     (Node_Table (+Id).K61_Kind);

   function Include_Declaration_Get_Use_Kind
     (Id : W_Include_Declaration_Unchecked_Id)
     return EW_Clone_Type is
     (Node_Table (+Id).K61_Use_Kind);

   function Theory_Declaration_Get_Declarations
     (Id : W_Theory_Declaration_Unchecked_Id)
     return W_Declaration_Unchecked_OList is
     (W_Declaration_Unchecked_OList
       (Node_Table (+Id).K62_Declarations))
     ;

   function Theory_Declaration_Get_Name
     (Id : W_Theory_Declaration_Unchecked_Id)
     return Symbol is
     (Node_Table (+Id).K62_Name);

   function Theory_Declaration_Get_Kind
     (Id : W_Theory_Declaration_Unchecked_Id)
     return EW_Theory_Type is
     (Node_Table (+Id).K62_Kind);

   function Theory_Declaration_Get_Includes
     (Id : W_Theory_Declaration_Unchecked_Id)
     return W_Include_Declaration_Unchecked_OList is
     (W_Include_Declaration_Unchecked_OList
       (Node_Table (+Id).K62_Includes))
     ;

   function Theory_Declaration_Get_Comment
     (Id : W_Theory_Declaration_Unchecked_Id)
     return Symbol is
     (Node_Table (+Id).K62_Comment);

   function Module_Get_File
     (Id : W_Module_Unchecked_Id)
     return Symbol is
     (Node_Table (+Id).K63_File);

   function Module_Get_Name
     (Id : W_Module_Unchecked_Id)
     return Symbol is
     (Node_Table (+Id).K63_Name);

   function Get_Type_Kind
     (Id : W_Type_Id)
     return EW_Type is
     (Node_Table (+Id).K1_Type_Kind);

   function Get_Name
     (Id : W_Type_Id)
     return W_Name_Id is
     (W_Name_Id
       (Node_Table (+Id).K1_Name))
     ;

   function Get_Is_Mutable
     (Id : W_Type_Id)
     return Boolean is
     (Node_Table (+Id).K1_Is_Mutable);

   function Get_Relaxed_Init
     (Id : W_Type_Id)
     return Boolean is
     (Node_Table (+Id).K1_Relaxed_Init);

   function Get_Symb
     (Id : W_Name_Id)
     return Symbol is
     (Node_Table (+Id).K2_Symb);

   function Get_Namespace
     (Id : W_Name_Id)
     return Symbol is
     (Node_Table (+Id).K2_Namespace);

   function Get_Module
     (Id : W_Name_Id)
     return W_Module_OId is
     (W_Module_OId
       (Node_Table (+Id).K2_Module))
     ;

   function Get_Infix
     (Id : W_Name_Id)
     return Boolean is
     (Node_Table (+Id).K2_Infix);

   function Get_Reads
     (Id : W_Effects_Id)
     return W_Identifier_OList is
     (W_Identifier_OList
       (Node_Table (+Id).K3_Reads))
     ;

   function Get_Writes
     (Id : W_Effects_Id)
     return W_Identifier_OList is
     (W_Identifier_OList
       (Node_Table (+Id).K3_Writes))
     ;

   function Get_Raises
     (Id : W_Effects_Id)
     return W_Raise_Effect_OList is
     (W_Raise_Effect_OList
       (Node_Table (+Id).K3_Raises))
     ;

   function Get_Name
     (Id : W_Raise_Effect_Id)
     return W_Name_Id is
     (W_Name_Id
       (Node_Table (+Id).K4_Name))
     ;

   function Get_Arg_Id
     (Id : W_Raise_Effect_Id)
     return W_Identifier_OId is
     (W_Identifier_OId
       (Node_Table (+Id).K4_Arg_Id))
     ;

   function Get_Post
     (Id : W_Raise_Effect_Id)
     return W_Pred_OId is
     (W_Pred_OId
       (Node_Table (+Id).K4_Post))
     ;

   function Get_Name
     (Id : W_Binder_Id)
     return W_Identifier_OId is
     (W_Identifier_OId
       (Node_Table (+Id).K5_Name))
     ;

   function Get_Arg_Type
     (Id : W_Binder_Id)
     return W_Type_Id is
     (W_Type_Id
       (Node_Table (+Id).K5_Arg_Type))
     ;

   function Get_Type_Definition
     (Id : W_Transparent_Type_Definition_Id)
     return W_Type_Id is
     (W_Type_Id
       (Node_Table (+Id).K6_Type_Definition))
     ;

   function Get_Name
     (Id : W_Record_Binder_Id)
     return W_Identifier_OId is
     (W_Identifier_OId
       (Node_Table (+Id).K7_Name))
     ;

   function Get_Arg_Type
     (Id : W_Record_Binder_Id)
     return W_Type_Id is
     (W_Type_Id
       (Node_Table (+Id).K7_Arg_Type))
     ;

   function Get_Labels
     (Id : W_Record_Binder_Id)
     return Symbol_Set is
     (Node_Table (+Id).K7_Labels);

   function Get_Is_Mutable
     (Id : W_Record_Binder_Id)
     return Boolean is
     (Node_Table (+Id).K7_Is_Mutable);

   function Get_Fields
     (Id : W_Record_Definition_Id)
     return W_Record_Binder_List is
     (W_Record_Binder_List
       (Node_Table (+Id).K8_Fields))
     ;

   function Get_First
     (Id : W_Range_Type_Definition_Id)
     return Uint is
     (Node_Table (+Id).K9_First);

   function Get_Last
     (Id : W_Range_Type_Definition_Id)
     return Uint is
     (Node_Table (+Id).K9_Last);

   function Get_Triggers
     (Id : W_Triggers_Id)
     return W_Trigger_List is
     (W_Trigger_List
       (Node_Table (+Id).K10_Triggers))
     ;

   function Get_Terms
     (Id : W_Trigger_Id)
     return W_Expr_List is
     (W_Expr_List
       (Node_Table (+Id).K11_Terms))
     ;

   function Get_Name
     (Id : W_Axiom_Dep_Id)
     return W_Identifier_Id is
     (W_Identifier_Id
       (Node_Table (+Id).K12_Name))
     ;

   function Get_Kind
     (Id : W_Axiom_Dep_Id)
     return EW_Axiom_Dep_Kind is
     (Node_Table (+Id).K12_Kind);

   function Get_Name
     (Id : W_Handler_Id)
     return W_Name_Id is
     (W_Name_Id
       (Node_Table (+Id).K13_Name))
     ;

   function Get_Arg_Id
     (Id : W_Handler_Id)
     return W_Identifier_OId is
     (W_Identifier_OId
       (Node_Table (+Id).K13_Arg_Id))
     ;

   function Get_Def
     (Id : W_Handler_Id)
     return W_Prog_Id is
     (W_Prog_Id
       (Node_Table (+Id).K13_Def))
     ;

   function Get_Field
     (Id : W_Field_Association_Id)
     return W_Identifier_Id is
     (W_Identifier_Id
       (Node_Table (+Id).K14_Field))
     ;

   function Get_Value
     (Id : W_Field_Association_Id)
     return W_Expr_Id is
     (W_Expr_Id
       (Node_Table (+Id).K14_Value))
     ;

   function Get_Cmp_Op
     (Id : W_Variant_Id)
     return W_Identifier_Id is
     (W_Identifier_Id
       (Node_Table (+Id).K15_Cmp_Op))
     ;

   function Get_Labels
     (Id : W_Variant_Id)
     return Symbol_Set is
     (Node_Table (+Id).K15_Labels);

   function Get_Expr
     (Id : W_Variant_Id)
     return W_Term_Id is
     (W_Term_Id
       (Node_Table (+Id).K15_Expr))
     ;

   function Get_Variants
     (Id : W_Variants_Id)
     return W_Variant_List is
     (W_Variant_List
       (Node_Table (+Id).K16_Variants))
     ;

   function Get_Variables
     (Id : W_Universal_Quantif_Id)
     return W_Identifier_List is
     (W_Identifier_List
       (Node_Table (+Id).K17_Variables))
     ;

   function Get_Labels
     (Id : W_Universal_Quantif_Id)
     return Symbol_Set is
     (Node_Table (+Id).K17_Labels);

   function Get_Var_Type
     (Id : W_Universal_Quantif_Id)
     return W_Type_Id is
     (W_Type_Id
       (Node_Table (+Id).K17_Var_Type))
     ;

   function Get_Triggers
     (Id : W_Universal_Quantif_Id)
     return W_Triggers_OId is
     (W_Triggers_OId
       (Node_Table (+Id).K17_Triggers))
     ;

   function Get_Pred
     (Id : W_Universal_Quantif_Id)
     return W_Pred_Id is
     (W_Pred_Id
       (Node_Table (+Id).K17_Pred))
     ;

   function Get_Variables
     (Id : W_Existential_Quantif_Id)
     return W_Identifier_List is
     (W_Identifier_List
       (Node_Table (+Id).K18_Variables))
     ;

   function Get_Labels
     (Id : W_Existential_Quantif_Id)
     return Symbol_Set is
     (Node_Table (+Id).K18_Labels);

   function Get_Var_Type
     (Id : W_Existential_Quantif_Id)
     return W_Type_Id is
     (W_Type_Id
       (Node_Table (+Id).K18_Var_Type))
     ;

   function Get_Pred
     (Id : W_Existential_Quantif_Id)
     return W_Pred_Id is
     (W_Pred_Id
       (Node_Table (+Id).K18_Pred))
     ;

   function Get_Right
     (Id : W_Not_Id)
     return W_Expr_Id is
     (W_Expr_Id
       (Node_Table (+Id).K19_Right))
     ;

   function Get_Left
     (Id : W_Connection_Id)
     return W_Expr_Id is
     (W_Expr_Id
       (Node_Table (+Id).K20_Left))
     ;

   function Get_Op
     (Id : W_Connection_Id)
     return EW_Connector is
     (Node_Table (+Id).K20_Op);

   function Get_Right
     (Id : W_Connection_Id)
     return W_Expr_Id is
     (W_Expr_Id
       (Node_Table (+Id).K20_Right))
     ;

   function Get_More_Right
     (Id : W_Connection_Id)
     return W_Expr_OList is
     (W_Expr_OList
       (Node_Table (+Id).K20_More_Right))
     ;

   function Get_Labels
     (Id : W_Label_Id)
     return Symbol_Set is
     (Node_Table (+Id).K21_Labels);

   function Get_Def
     (Id : W_Label_Id)
     return W_Expr_Id is
     (W_Expr_Id
       (Node_Table (+Id).K21_Def))
     ;

   function Get_Typ
     (Id : W_Label_Id)
     return W_Type_OId is
     (W_Type_OId
       (Node_Table (+Id).K21_Typ))
     ;

   function Get_Sloc
     (Id : W_Loc_Label_Id)
     return Source_Ptr is
     (Node_Table (+Id).K22_Sloc);

   function Get_Def
     (Id : W_Loc_Label_Id)
     return W_Expr_Id is
     (W_Expr_Id
       (Node_Table (+Id).K22_Def))
     ;

   function Get_Marker
     (Id : W_Loc_Label_Id)
     return Symbol is
     (Node_Table (+Id).K22_Marker);

   function Get_Name
     (Id : W_Identifier_Id)
     return W_Name_Id is
     (W_Name_Id
       (Node_Table (+Id).K23_Name))
     ;

   function Get_Typ
     (Id : W_Identifier_Id)
     return W_Type_OId is
     (W_Type_OId
       (Node_Table (+Id).K23_Typ))
     ;

   function Get_Labels
     (Id : W_Identifier_Id)
     return String_Sets.Set is
     (Node_Table (+Id).K23_Labels);

   function Get_Tag
     (Id : W_Tagged_Id)
     return Symbol is
     (Node_Table (+Id).K24_Tag);

   function Get_Def
     (Id : W_Tagged_Id)
     return W_Expr_Id is
     (W_Expr_Id
       (Node_Table (+Id).K24_Def))
     ;

   function Get_Typ
     (Id : W_Tagged_Id)
     return W_Type_OId is
     (W_Type_OId
       (Node_Table (+Id).K24_Typ))
     ;

   function Get_Name
     (Id : W_Call_Id)
     return W_Identifier_Id is
     (W_Identifier_Id
       (Node_Table (+Id).K25_Name))
     ;

   function Get_Args
     (Id : W_Call_Id)
     return W_Expr_OList is
     (W_Expr_OList
       (Node_Table (+Id).K25_Args))
     ;

   function Get_Typ
     (Id : W_Call_Id)
     return W_Type_OId is
     (W_Type_OId
       (Node_Table (+Id).K25_Typ))
     ;

   function Get_Value
     (Id : W_Literal_Id)
     return EW_Literal is
     (Node_Table (+Id).K26_Value);

   function Get_Typ
     (Id : W_Literal_Id)
     return W_Type_OId is
     (W_Type_OId
       (Node_Table (+Id).K26_Typ))
     ;

   function Get_Name
     (Id : W_Binding_Id)
     return W_Identifier_Id is
     (W_Identifier_Id
       (Node_Table (+Id).K27_Name))
     ;

   function Get_Def
     (Id : W_Binding_Id)
     return W_Expr_Id is
     (W_Expr_Id
       (Node_Table (+Id).K27_Def))
     ;

   function Get_Context
     (Id : W_Binding_Id)
     return W_Expr_Id is
     (W_Expr_Id
       (Node_Table (+Id).K27_Context))
     ;

   function Get_Typ
     (Id : W_Binding_Id)
     return W_Type_OId is
     (W_Type_OId
       (Node_Table (+Id).K27_Typ))
     ;

   function Get_Condition
     (Id : W_Elsif_Id)
     return W_Expr_Id is
     (W_Expr_Id
       (Node_Table (+Id).K28_Condition))
     ;

   function Get_Then_Part
     (Id : W_Elsif_Id)
     return W_Expr_Id is
     (W_Expr_Id
       (Node_Table (+Id).K28_Then_Part))
     ;

   function Get_Typ
     (Id : W_Elsif_Id)
     return W_Type_OId is
     (W_Type_OId
       (Node_Table (+Id).K28_Typ))
     ;

   function Get_Name
     (Id : W_Epsilon_Id)
     return W_Identifier_Id is
     (W_Identifier_Id
       (Node_Table (+Id).K29_Name))
     ;

   function Get_Typ
     (Id : W_Epsilon_Id)
     return W_Type_Id is
     (W_Type_Id
       (Node_Table (+Id).K29_Typ))
     ;

   function Get_Pred
     (Id : W_Epsilon_Id)
     return W_Pred_Id is
     (W_Pred_Id
       (Node_Table (+Id).K29_Pred))
     ;

   function Get_Condition
     (Id : W_Conditional_Id)
     return W_Expr_Id is
     (W_Expr_Id
       (Node_Table (+Id).K30_Condition))
     ;

   function Get_Then_Part
     (Id : W_Conditional_Id)
     return W_Expr_Id is
     (W_Expr_Id
       (Node_Table (+Id).K30_Then_Part))
     ;

   function Get_Elsif_Parts
     (Id : W_Conditional_Id)
     return W_Expr_OList is
     (W_Expr_OList
       (Node_Table (+Id).K30_Elsif_Parts))
     ;

   function Get_Else_Part
     (Id : W_Conditional_Id)
     return W_Expr_OId is
     (W_Expr_OId
       (Node_Table (+Id).K30_Else_Part))
     ;

   function Get_Typ
     (Id : W_Conditional_Id)
     return W_Type_OId is
     (W_Type_OId
       (Node_Table (+Id).K30_Typ))
     ;

   function Get_Value
     (Id : W_Integer_Constant_Id)
     return Uint is
     (Node_Table (+Id).K31_Value);

   function Get_Value
     (Id : W_Range_Constant_Id)
     return Uint is
     (Node_Table (+Id).K32_Value);

   function Get_Typ
     (Id : W_Range_Constant_Id)
     return W_Type_Id is
     (W_Type_Id
       (Node_Table (+Id).K32_Typ))
     ;

   function Get_Value
     (Id : W_Modular_Constant_Id)
     return Uint is
     (Node_Table (+Id).K33_Value);

   function Get_Typ
     (Id : W_Modular_Constant_Id)
     return W_Type_Id is
     (W_Type_Id
       (Node_Table (+Id).K33_Typ))
     ;

   function Get_Value
     (Id : W_Fixed_Constant_Id)
     return Uint is
     (Node_Table (+Id).K34_Value);

   function Get_Typ
     (Id : W_Fixed_Constant_Id)
     return W_Type_Id is
     (W_Type_Id
       (Node_Table (+Id).K34_Typ))
     ;

   function Get_Value
     (Id : W_Real_Constant_Id)
     return Ureal is
     (Node_Table (+Id).K35_Value);

   function Get_Value
     (Id : W_Float_Constant_Id)
     return Ureal is
     (Node_Table (+Id).K36_Value);

   function Get_Typ
     (Id : W_Float_Constant_Id)
     return W_Type_Id is
     (W_Type_Id
       (Node_Table (+Id).K36_Typ))
     ;

   function Get_Comment
     (Id : W_Comment_Id)
     return Symbol is
     (Node_Table (+Id).K37_Comment);

   function Get_Right
     (Id : W_Deref_Id)
     return W_Identifier_Id is
     (W_Identifier_Id
       (Node_Table (+Id).K38_Right))
     ;

   function Get_Typ
     (Id : W_Deref_Id)
     return W_Type_Id is
     (W_Type_Id
       (Node_Table (+Id).K38_Typ))
     ;

   function Get_Name
     (Id : W_Record_Access_Id)
     return W_Expr_Id is
     (W_Expr_Id
       (Node_Table (+Id).K39_Name))
     ;

   function Get_Field
     (Id : W_Record_Access_Id)
     return W_Identifier_Id is
     (W_Identifier_Id
       (Node_Table (+Id).K39_Field))
     ;

   function Get_Typ
     (Id : W_Record_Access_Id)
     return W_Type_OId is
     (W_Type_OId
       (Node_Table (+Id).K39_Typ))
     ;

   function Get_Name
     (Id : W_Record_Update_Id)
     return W_Expr_Id is
     (W_Expr_Id
       (Node_Table (+Id).K40_Name))
     ;

   function Get_Updates
     (Id : W_Record_Update_Id)
     return W_Field_Association_List is
     (W_Field_Association_List
       (Node_Table (+Id).K40_Updates))
     ;

   function Get_Typ
     (Id : W_Record_Update_Id)
     return W_Type_OId is
     (W_Type_OId
       (Node_Table (+Id).K40_Typ))
     ;

   function Get_Associations
     (Id : W_Record_Aggregate_Id)
     return W_Field_Association_List is
     (W_Field_Association_List
       (Node_Table (+Id).K41_Associations))
     ;

   function Get_Typ
     (Id : W_Record_Aggregate_Id)
     return W_Type_OId is
     (W_Type_OId
       (Node_Table (+Id).K41_Typ))
     ;

   function Get_Effects
     (Id : W_Any_Expr_Id)
     return W_Effects_OId is
     (W_Effects_OId
       (Node_Table (+Id).K42_Effects))
     ;

   function Get_Pre
     (Id : W_Any_Expr_Id)
     return W_Pred_OId is
     (W_Pred_OId
       (Node_Table (+Id).K42_Pre))
     ;

   function Get_Post
     (Id : W_Any_Expr_Id)
     return W_Pred_OId is
     (W_Pred_OId
       (Node_Table (+Id).K42_Post))
     ;

   function Get_Return_Type
     (Id : W_Any_Expr_Id)
     return W_Type_Id is
     (W_Type_Id
       (Node_Table (+Id).K42_Return_Type))
     ;

   function Get_Labels
     (Id : W_Any_Expr_Id)
     return Symbol_Set is
     (Node_Table (+Id).K42_Labels);

   function Get_Name
     (Id : W_Assignment_Id)
     return W_Identifier_Id is
     (W_Identifier_Id
       (Node_Table (+Id).K43_Name))
     ;

   function Get_Value
     (Id : W_Assignment_Id)
     return W_Prog_Id is
     (W_Prog_Id
       (Node_Table (+Id).K43_Value))
     ;

   function Get_Typ
     (Id : W_Assignment_Id)
     return W_Type_Id is
     (W_Type_Id
       (Node_Table (+Id).K43_Typ))
     ;

   function Get_Labels
     (Id : W_Assignment_Id)
     return Symbol_Set is
     (Node_Table (+Id).K43_Labels);

   function Get_Name
     (Id : W_Binding_Ref_Id)
     return W_Identifier_Id is
     (W_Identifier_Id
       (Node_Table (+Id).K44_Name))
     ;

   function Get_Def
     (Id : W_Binding_Ref_Id)
     return W_Prog_Id is
     (W_Prog_Id
       (Node_Table (+Id).K44_Def))
     ;

   function Get_Context
     (Id : W_Binding_Ref_Id)
     return W_Prog_Id is
     (W_Prog_Id
       (Node_Table (+Id).K44_Context))
     ;

   function Get_Typ
     (Id : W_Binding_Ref_Id)
     return W_Type_Id is
     (W_Type_Id
       (Node_Table (+Id).K44_Typ))
     ;

   function Get_Code_Before
     (Id : W_Loop_Id)
     return W_Prog_Id is
     (W_Prog_Id
       (Node_Table (+Id).K45_Code_Before))
     ;

   function Get_Invariants
     (Id : W_Loop_Id)
     return W_Pred_OList is
     (W_Pred_OList
       (Node_Table (+Id).K45_Invariants))
     ;

   function Get_Variants
     (Id : W_Loop_Id)
     return W_Variants_OList is
     (W_Variants_OList
       (Node_Table (+Id).K45_Variants))
     ;

   function Get_Code_After
     (Id : W_Loop_Id)
     return W_Prog_Id is
     (W_Prog_Id
       (Node_Table (+Id).K45_Code_After))
     ;

   function Get_Statements
     (Id : W_Statement_Sequence_Id)
     return W_Prog_List is
     (W_Prog_List
       (Node_Table (+Id).K46_Statements))
     ;

   function Get_Expr
     (Id : W_Abstract_Expr_Id)
     return W_Prog_Id is
     (W_Prog_Id
       (Node_Table (+Id).K47_Expr))
     ;

   function Get_Post
     (Id : W_Abstract_Expr_Id)
     return W_Pred_Id is
     (W_Pred_Id
       (Node_Table (+Id).K47_Post))
     ;

   function Get_Typ
     (Id : W_Abstract_Expr_Id)
     return W_Type_OId is
     (W_Type_OId
       (Node_Table (+Id).K47_Typ))
     ;

   function Get_Pred
     (Id : W_Assert_Id)
     return W_Pred_Id is
     (W_Pred_Id
       (Node_Table (+Id).K48_Pred))
     ;

   function Get_Assert_Kind
     (Id : W_Assert_Id)
     return EW_Assert_Kind is
     (Node_Table (+Id).K48_Assert_Kind);

   function Get_Name
     (Id : W_Raise_Id)
     return W_Name_Id is
     (W_Name_Id
       (Node_Table (+Id).K49_Name))
     ;

   function Get_Arg
     (Id : W_Raise_Id)
     return W_Expr_OId is
     (W_Expr_OId
       (Node_Table (+Id).K49_Arg))
     ;

   function Get_Typ
     (Id : W_Raise_Id)
     return W_Type_OId is
     (W_Type_OId
       (Node_Table (+Id).K49_Typ))
     ;

   function Get_Prog
     (Id : W_Try_Block_Id)
     return W_Prog_Id is
     (W_Prog_Id
       (Node_Table (+Id).K50_Prog))
     ;

   function Get_Handler
     (Id : W_Try_Block_Id)
     return W_Handler_List is
     (W_Handler_List
       (Node_Table (+Id).K50_Handler))
     ;

   function Get_Typ
     (Id : W_Try_Block_Id)
     return W_Type_OId is
     (W_Type_OId
       (Node_Table (+Id).K50_Typ))
     ;

   function Get_Name
     (Id : W_Function_Decl_Id)
     return W_Identifier_Id is
     (W_Identifier_Id
       (Node_Table (+Id).K51_Name))
     ;

   function Get_Binders
     (Id : W_Function_Decl_Id)
     return W_Binder_OList is
     (W_Binder_OList
       (Node_Table (+Id).K51_Binders))
     ;

   function Get_Effects
     (Id : W_Function_Decl_Id)
     return W_Effects_OId is
     (W_Effects_OId
       (Node_Table (+Id).K51_Effects))
     ;

   function Get_Pre
     (Id : W_Function_Decl_Id)
     return W_Pred_OId is
     (W_Pred_OId
       (Node_Table (+Id).K51_Pre))
     ;

   function Get_Post
     (Id : W_Function_Decl_Id)
     return W_Pred_OId is
     (W_Pred_OId
       (Node_Table (+Id).K51_Post))
     ;

   function Get_Return_Type
     (Id : W_Function_Decl_Id)
     return W_Type_OId is
     (W_Type_OId
       (Node_Table (+Id).K51_Return_Type))
     ;

   function Get_Def
     (Id : W_Function_Decl_Id)
     return W_Expr_OId is
     (W_Expr_OId
       (Node_Table (+Id).K51_Def))
     ;

   function Get_Labels
     (Id : W_Function_Decl_Id)
     return Symbol_Set is
     (Node_Table (+Id).K51_Labels);

   function Get_Location
     (Id : W_Function_Decl_Id)
     return Source_Ptr is
     (Node_Table (+Id).K51_Location);

   function Get_Name
     (Id : W_Axiom_Id)
     return Symbol is
     (Node_Table (+Id).K52_Name);

   function Get_Def
     (Id : W_Axiom_Id)
     return W_Pred_Id is
     (W_Pred_Id
       (Node_Table (+Id).K52_Def))
     ;

   function Get_Dep
     (Id : W_Axiom_Id)
     return W_Axiom_Dep_OId is
     (W_Axiom_Dep_OId
       (Node_Table (+Id).K52_Dep))
     ;

   function Get_Name
     (Id : W_Goal_Id)
     return Symbol is
     (Node_Table (+Id).K53_Name);

   function Get_Def
     (Id : W_Goal_Id)
     return W_Pred_Id is
     (W_Pred_Id
       (Node_Table (+Id).K53_Def))
     ;

   function Get_Args
     (Id : W_Type_Decl_Id)
     return W_Identifier_OList is
     (W_Identifier_OList
       (Node_Table (+Id).K54_Args))
     ;

   function Get_Name
     (Id : W_Type_Decl_Id)
     return W_Name_Id is
     (W_Name_Id
       (Node_Table (+Id).K54_Name))
     ;

   function Get_Labels
     (Id : W_Type_Decl_Id)
     return Symbol_Set is
     (Node_Table (+Id).K54_Labels);

   function Get_Definition
     (Id : W_Type_Decl_Id)
     return W_Type_Definition_OId is
     (W_Type_Definition_OId
       (Node_Table (+Id).K54_Definition))
     ;

   function Get_Name
     (Id : W_Global_Ref_Declaration_Id)
     return W_Identifier_Id is
     (W_Identifier_Id
       (Node_Table (+Id).K55_Name))
     ;

   function Get_Ref_Type
     (Id : W_Global_Ref_Declaration_Id)
     return W_Type_Id is
     (W_Type_Id
       (Node_Table (+Id).K55_Ref_Type))
     ;

   function Get_Labels
     (Id : W_Global_Ref_Declaration_Id)
     return Symbol_Set is
     (Node_Table (+Id).K55_Labels);

   function Get_Location
     (Id : W_Global_Ref_Declaration_Id)
     return Source_Ptr is
     (Node_Table (+Id).K55_Location);

   function Get_Declarations
     (Id : W_Namespace_Declaration_Id)
     return W_Declaration_OList is
     (W_Declaration_OList
       (Node_Table (+Id).K56_Declarations))
     ;

   function Get_Name
     (Id : W_Namespace_Declaration_Id)
     return Symbol is
     (Node_Table (+Id).K56_Name);

   function Get_Name
     (Id : W_Exception_Declaration_Id)
     return W_Name_Id is
     (W_Name_Id
       (Node_Table (+Id).K57_Name))
     ;

   function Get_Arg
     (Id : W_Exception_Declaration_Id)
     return W_Type_OId is
     (W_Type_OId
       (Node_Table (+Id).K57_Arg))
     ;

   function Get_Name
     (Id : W_Meta_Declaration_Id)
     return Symbol is
     (Node_Table (+Id).K58_Name);

   function Get_Parameter
     (Id : W_Meta_Declaration_Id)
     return Symbol is
     (Node_Table (+Id).K58_Parameter);

   function Get_Origin
     (Id : W_Clone_Declaration_Id)
     return W_Module_Id is
     (W_Module_Id
       (Node_Table (+Id).K59_Origin))
     ;

   function Get_As_Name
     (Id : W_Clone_Declaration_Id)
     return Symbol is
     (Node_Table (+Id).K59_As_Name);

   function Get_Clone_Kind
     (Id : W_Clone_Declaration_Id)
     return EW_Clone_Type is
     (Node_Table (+Id).K59_Clone_Kind);

   function Get_Substitutions
     (Id : W_Clone_Declaration_Id)
     return W_Clone_Substitution_OList is
     (W_Clone_Substitution_OList
       (Node_Table (+Id).K59_Substitutions))
     ;

   function Get_Theory_Kind
     (Id : W_Clone_Declaration_Id)
     return EW_Theory_Type is
     (Node_Table (+Id).K59_Theory_Kind);

   function Get_Kind
     (Id : W_Clone_Substitution_Id)
     return EW_Subst_Type is
     (Node_Table (+Id).K60_Kind);

   function Get_Orig_Name
     (Id : W_Clone_Substitution_Id)
     return W_Name_Id is
     (W_Name_Id
       (Node_Table (+Id).K60_Orig_Name))
     ;

   function Get_Image
     (Id : W_Clone_Substitution_Id)
     return W_Name_Id is
     (W_Name_Id
       (Node_Table (+Id).K60_Image))
     ;

   function Get_Module
     (Id : W_Include_Declaration_Id)
     return W_Module_Id is
     (W_Module_Id
       (Node_Table (+Id).K61_Module))
     ;

   function Get_Kind
     (Id : W_Include_Declaration_Id)
     return EW_Theory_Type is
     (Node_Table (+Id).K61_Kind);

   function Get_Use_Kind
     (Id : W_Include_Declaration_Id)
     return EW_Clone_Type is
     (Node_Table (+Id).K61_Use_Kind);

   function Get_Declarations
     (Id : W_Theory_Declaration_Id)
     return W_Declaration_OList is
     (W_Declaration_OList
       (Node_Table (+Id).K62_Declarations))
     ;

   function Get_Name
     (Id : W_Theory_Declaration_Id)
     return Symbol is
     (Node_Table (+Id).K62_Name);

   function Get_Kind
     (Id : W_Theory_Declaration_Id)
     return EW_Theory_Type is
     (Node_Table (+Id).K62_Kind);

   function Get_Includes
     (Id : W_Theory_Declaration_Id)
     return W_Include_Declaration_OList is
     (W_Include_Declaration_OList
       (Node_Table (+Id).K62_Includes))
     ;

   function Get_Comment
     (Id : W_Theory_Declaration_Id)
     return Symbol is
     (Node_Table (+Id).K62_Comment);

   function Get_File
     (Id : W_Module_Id)
     return Symbol is
     (Node_Table (+Id).K63_File);

   function Get_Name
     (Id : W_Module_Id)
     return Symbol is
     (Node_Table (+Id).K63_Name);

end Why.Atree.Accessors;