------------------------------------------------------------------------------
--                                                                          --
--                            GNAT2WHY COMPONENTS                           --
--                                                                          --
--                   W H Y - A T R E E - B U I L D E R S                    --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--                       Copyright (C) 2010-2025, AdaCore                   --
--                                                                          --
-- gnat2why is  free  software;  you can redistribute  it and/or  modify it --
-- under terms of the  GNU General Public License as published  by the Free --
-- Software  Foundation;  either version 3,  or (at your option)  any later --
-- version.  gnat2why is distributed  in the hope that  it will be  useful, --
-- but WITHOUT ANY WARRANTY; without even the implied warranty of  MERCHAN- --
-- TABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public --
-- License for  more details.  You should have  received  a copy of the GNU --
-- General  Public License  distributed with  gnat2why;  see file COPYING3. --
-- If not,  go to  http://www.gnu.org/licenses  for a complete  copy of the --
-- license.                                                                 --
--                                                                          --
-- gnat2why is maintained by AdaCore (http://www.adacore.com)               --
--                                                                          --
------------------------------------------------------------------------------
--  This package is automatically generated by xtree. Do not edit manually.

with Why.Ids; use Why.Ids;

package Why.Atree.Builders is
   --  This package provides a set of unchecked builders, generated
   --  automatically from Why.Atree.Why_Node using an ASIS tool

   function New_Type
     (Ada_Node     : Node_Id := Empty;
      Type_Kind    : EW_Type;
      Name         : W_Name_Id;
      Is_Mutable   : Boolean := False;
      Relaxed_Init : Boolean := False)
     return W_Type_Id;

   function New_Name
     (Ada_Node  : Node_Id := Empty;
      Symb      : Symbol;
      Namespace : Symbol := No_Symbol;
      Module    : W_Module_OId := Why_Empty;
      Infix     : Boolean := False)
     return W_Name_Id;

   function New_Effects
     (Ada_Node : Node_Id := Empty;
      Reads    : W_Identifier_Array := (2 .. 1 => <>);
      Writes   : W_Identifier_Array := (2 .. 1 => <>);
      Raises   : W_Raise_Effect_Array := (2 .. 1 => <>))
     return W_Effects_Id;

   function New_Raise_Effect
     (Ada_Node : Node_Id := Empty;
      Domain   : EW_Domain;
      Name     : W_Name_Id;
      Arg_Id   : W_Identifier_OId := Why_Empty;
      Post     : W_Pred_OId := Why_Empty)
     return W_Raise_Effect_Id;

   function New_Binder
     (Ada_Node : Node_Id := Empty;
      Domain   : EW_Domain;
      Name     : W_Identifier_OId := Why_Empty;
      Arg_Type : W_Type_Id)
     return W_Binder_Id;

   function New_Transparent_Type_Definition
     (Ada_Node        : Node_Id := Empty;
      Domain          : EW_Domain;
      Type_Definition : W_Type_Id)
     return W_Transparent_Type_Definition_Id;

   function New_Transparent_Type_Definition
     (Ada_Node        : Node_Id := Empty;
      Domain          : EW_Domain;
      Type_Definition : W_Type_Id)
     return W_Type_Definition_Id;

   function New_Record_Binder
     (Ada_Node   : Node_Id := Empty;
      Domain     : EW_Domain;
      Name       : W_Identifier_OId := Why_Empty;
      Arg_Type   : W_Type_Id;
      Labels     : Symbol_Set;
      Is_Mutable : Boolean := False)
     return W_Record_Binder_Id;

   function New_Record_Binder
     (Ada_Node   : Node_Id := Empty;
      Domain     : EW_Domain;
      Name       : W_Identifier_OId := Why_Empty;
      Arg_Type   : W_Type_Id;
      Labels     : Symbol_Set;
      Is_Mutable : Boolean := False)
     return W_Type_Definition_Id;

   function New_Record_Definition
     (Ada_Node : Node_Id := Empty;
      Fields   : W_Record_Binder_Array)
     return W_Record_Definition_Id;

   function New_Record_Definition
     (Ada_Node : Node_Id := Empty;
      Fields   : W_Record_Binder_Array)
     return W_Type_Definition_Id;

   function New_Range_Type_Definition
     (Ada_Node : Node_Id := Empty;
      First    : Uint;
      Last     : Uint)
     return W_Range_Type_Definition_Id;

   function New_Range_Type_Definition
     (Ada_Node : Node_Id := Empty;
      First    : Uint;
      Last     : Uint)
     return W_Type_Definition_Id;

   function New_Triggers
     (Ada_Node : Node_Id := Empty;
      Triggers : W_Trigger_Array)
     return W_Triggers_Id;

   function New_Trigger
     (Ada_Node : Node_Id := Empty;
      Terms    : W_Expr_Array)
     return W_Trigger_Id;

   function New_Axiom_Dep
     (Ada_Node : Node_Id := Empty;
      Name     : W_Identifier_Id;
      Kind     : EW_Axiom_Dep_Kind)
     return W_Axiom_Dep_Id;

   function New_Handler
     (Ada_Node : Node_Id := Empty;
      Name     : W_Name_Id;
      Arg_Id   : W_Identifier_OId := Why_Empty;
      Def      : W_Prog_Id)
     return W_Handler_Id;

   function New_Field_Association
     (Ada_Node : Node_Id := Empty;
      Domain   : EW_Domain;
      Field    : W_Identifier_Id;
      Value    : W_Expr_Id)
     return W_Field_Association_Id;

   function New_Variant
     (Ada_Node : Node_Id := Empty;
      Cmp_Op   : W_Identifier_Id;
      Labels   : Symbol_Set;
      Expr     : W_Term_Id)
     return W_Variant_Id;

   function New_Variants
     (Ada_Node : Node_Id := Empty;
      Variants : W_Variant_Array)
     return W_Variants_Id;

   function New_Universal_Quantif
     (Ada_Node  : Node_Id := Empty;
      Variables : W_Identifier_Array;
      Labels    : Symbol_Set;
      Var_Type  : W_Type_Id;
      Triggers  : W_Triggers_OId := Why_Empty;
      Pred      : W_Pred_Id)
     return W_Universal_Quantif_Id;

   function New_Universal_Quantif
     (Ada_Node  : Node_Id := Empty;
      Variables : W_Identifier_Array;
      Labels    : Symbol_Set;
      Var_Type  : W_Type_Id;
      Triggers  : W_Triggers_OId := Why_Empty;
      Pred      : W_Pred_Id)
     return W_Expr_Id;

   function New_Universal_Quantif
     (Ada_Node  : Node_Id := Empty;
      Variables : W_Identifier_Array;
      Labels    : Symbol_Set;
      Var_Type  : W_Type_Id;
      Triggers  : W_Triggers_OId := Why_Empty;
      Pred      : W_Pred_Id)
     return W_Pred_Id;

   function New_Existential_Quantif
     (Ada_Node  : Node_Id := Empty;
      Variables : W_Identifier_Array;
      Labels    : Symbol_Set;
      Var_Type  : W_Type_Id;
      Pred      : W_Pred_Id)
     return W_Existential_Quantif_Id;

   function New_Existential_Quantif
     (Ada_Node  : Node_Id := Empty;
      Variables : W_Identifier_Array;
      Labels    : Symbol_Set;
      Var_Type  : W_Type_Id;
      Pred      : W_Pred_Id)
     return W_Expr_Id;

   function New_Existential_Quantif
     (Ada_Node  : Node_Id := Empty;
      Variables : W_Identifier_Array;
      Labels    : Symbol_Set;
      Var_Type  : W_Type_Id;
      Pred      : W_Pred_Id)
     return W_Pred_Id;

   function New_Not
     (Ada_Node : Node_Id := Empty;
      Domain   : EW_Domain;
      Right    : W_Expr_Id)
     return W_Not_Id;

   function New_Not
     (Ada_Node : Node_Id := Empty;
      Domain   : EW_Domain;
      Right    : W_Expr_Id)
     return W_Expr_Id;

   function New_Not
     (Ada_Node : Node_Id := Empty;
      Right    : W_Pred_Id)
     return W_Pred_Id;

   function New_Not
     (Ada_Node : Node_Id := Empty;
      Right    : W_Prog_Id)
     return W_Prog_Id;

   function New_Connection
     (Ada_Node   : Node_Id := Empty;
      Domain     : EW_Domain;
      Left       : W_Expr_Id;
      Op         : EW_Connector;
      Right      : W_Expr_Id;
      More_Right : W_Expr_Array := (2 .. 1 => <>))
     return W_Connection_Id;

   function New_Connection
     (Ada_Node   : Node_Id := Empty;
      Domain     : EW_Domain;
      Left       : W_Expr_Id;
      Op         : EW_Connector;
      Right      : W_Expr_Id;
      More_Right : W_Expr_Array := (2 .. 1 => <>))
     return W_Expr_Id;

   function New_Connection
     (Ada_Node   : Node_Id := Empty;
      Left       : W_Pred_Id;
      Op         : EW_Connector;
      Right      : W_Pred_Id;
      More_Right : W_Pred_Array := (2 .. 1 => <>))
     return W_Pred_Id;

   function New_Connection
     (Ada_Node   : Node_Id := Empty;
      Left       : W_Prog_Id;
      Op         : EW_Connector;
      Right      : W_Prog_Id;
      More_Right : W_Prog_Array := (2 .. 1 => <>))
     return W_Prog_Id;

   function New_Label
     (Ada_Node : Node_Id := Empty;
      Domain   : EW_Domain;
      Labels   : Symbol_Set;
      Def      : W_Expr_Id;
      Typ      : W_Type_OId := Why_Empty)
     return W_Label_Id;

   function New_Label
     (Ada_Node : Node_Id := Empty;
      Domain   : EW_Domain;
      Labels   : Symbol_Set;
      Def      : W_Expr_Id;
      Typ      : W_Type_OId := Why_Empty)
     return W_Expr_Id;

   function New_Label
     (Ada_Node : Node_Id := Empty;
      Labels   : Symbol_Set;
      Def      : W_Pred_Id;
      Typ      : W_Type_OId := Why_Empty)
     return W_Pred_Id;

   function New_Label
     (Ada_Node : Node_Id := Empty;
      Labels   : Symbol_Set;
      Def      : W_Term_Id;
      Typ      : W_Type_OId := Why_Empty)
     return W_Term_Id;

   function New_Label
     (Ada_Node : Node_Id := Empty;
      Labels   : Symbol_Set;
      Def      : W_Prog_Id;
      Typ      : W_Type_OId := Why_Empty)
     return W_Prog_Id;

   function New_Loc_Label
     (Ada_Node : Node_Id := Empty;
      Domain   : EW_Domain;
      Sloc     : Source_Ptr;
      Def      : W_Expr_Id;
      Marker   : Symbol := No_Symbol)
     return W_Loc_Label_Id;

   function New_Loc_Label
     (Ada_Node : Node_Id := Empty;
      Domain   : EW_Domain;
      Sloc     : Source_Ptr;
      Def      : W_Expr_Id;
      Marker   : Symbol := No_Symbol)
     return W_Expr_Id;

   function New_Loc_Label
     (Ada_Node : Node_Id := Empty;
      Sloc     : Source_Ptr;
      Def      : W_Pred_Id;
      Marker   : Symbol := No_Symbol)
     return W_Pred_Id;

   function New_Loc_Label
     (Ada_Node : Node_Id := Empty;
      Sloc     : Source_Ptr;
      Def      : W_Term_Id;
      Marker   : Symbol := No_Symbol)
     return W_Term_Id;

   function New_Loc_Label
     (Ada_Node : Node_Id := Empty;
      Sloc     : Source_Ptr;
      Def      : W_Prog_Id;
      Marker   : Symbol := No_Symbol)
     return W_Prog_Id;

   function New_Identifier
     (Ada_Node : Node_Id := Empty;
      Domain   : EW_Domain;
      Name     : W_Name_Id;
      Typ      : W_Type_OId := Why_Empty;
      Labels   : String_Sets.Set := String_Sets.Empty_Set)
     return W_Identifier_Id;

   function New_Identifier
     (Ada_Node : Node_Id := Empty;
      Domain   : EW_Domain;
      Name     : W_Name_Id;
      Typ      : W_Type_OId := Why_Empty;
      Labels   : String_Sets.Set := String_Sets.Empty_Set)
     return W_Expr_Id;

   function New_Identifier
     (Ada_Node : Node_Id := Empty;
      Name     : W_Name_Id;
      Typ      : W_Type_OId := Why_Empty;
      Labels   : String_Sets.Set := String_Sets.Empty_Set)
     return W_Pred_Id;

   function New_Identifier
     (Ada_Node : Node_Id := Empty;
      Name     : W_Name_Id;
      Typ      : W_Type_OId := Why_Empty;
      Labels   : String_Sets.Set := String_Sets.Empty_Set)
     return W_Term_Id;

   function New_Identifier
     (Ada_Node : Node_Id := Empty;
      Name     : W_Name_Id;
      Typ      : W_Type_OId := Why_Empty;
      Labels   : String_Sets.Set := String_Sets.Empty_Set)
     return W_Prog_Id;

   function New_Tagged
     (Ada_Node : Node_Id := Empty;
      Domain   : EW_Domain;
      Tag      : Symbol;
      Def      : W_Expr_Id;
      Typ      : W_Type_OId := Why_Empty)
     return W_Tagged_Id;

   function New_Tagged
     (Ada_Node : Node_Id := Empty;
      Domain   : EW_Domain;
      Tag      : Symbol;
      Def      : W_Expr_Id;
      Typ      : W_Type_OId := Why_Empty)
     return W_Expr_Id;

   function New_Tagged
     (Ada_Node : Node_Id := Empty;
      Tag      : Symbol;
      Def      : W_Pred_Id;
      Typ      : W_Type_OId := Why_Empty)
     return W_Pred_Id;

   function New_Tagged
     (Ada_Node : Node_Id := Empty;
      Tag      : Symbol;
      Def      : W_Term_Id;
      Typ      : W_Type_OId := Why_Empty)
     return W_Term_Id;

   function New_Tagged
     (Ada_Node : Node_Id := Empty;
      Tag      : Symbol;
      Def      : W_Prog_Id;
      Typ      : W_Type_OId := Why_Empty)
     return W_Prog_Id;

   function New_Call
     (Ada_Node : Node_Id := Empty;
      Domain   : EW_Domain;
      Name     : W_Identifier_Id;
      Args     : W_Expr_Array := (2 .. 1 => <>);
      Typ      : W_Type_OId := Why_Empty)
     return W_Call_Id;

   function New_Call
     (Ada_Node : Node_Id := Empty;
      Domain   : EW_Domain;
      Name     : W_Identifier_Id;
      Args     : W_Expr_Array := (2 .. 1 => <>);
      Typ      : W_Type_OId := Why_Empty)
     return W_Expr_Id;

   function New_Call
     (Ada_Node : Node_Id := Empty;
      Name     : W_Identifier_Id;
      Args     : W_Expr_Array := (2 .. 1 => <>);
      Typ      : W_Type_OId := Why_Empty)
     return W_Pred_Id;

   function New_Call
     (Ada_Node : Node_Id := Empty;
      Name     : W_Identifier_Id;
      Args     : W_Expr_Array := (2 .. 1 => <>);
      Typ      : W_Type_OId := Why_Empty)
     return W_Term_Id;

   function New_Call
     (Ada_Node : Node_Id := Empty;
      Name     : W_Identifier_Id;
      Args     : W_Expr_Array := (2 .. 1 => <>);
      Typ      : W_Type_OId := Why_Empty)
     return W_Prog_Id;

   function New_Literal
     (Ada_Node : Node_Id := Empty;
      Domain   : EW_Domain;
      Value    : EW_Literal;
      Typ      : W_Type_OId := Why_Empty)
     return W_Literal_Id;

   function New_Literal
     (Ada_Node : Node_Id := Empty;
      Domain   : EW_Domain;
      Value    : EW_Literal;
      Typ      : W_Type_OId := Why_Empty)
     return W_Expr_Id;

   function New_Literal
     (Ada_Node : Node_Id := Empty;
      Value    : EW_Literal;
      Typ      : W_Type_OId := Why_Empty)
     return W_Pred_Id;

   function New_Literal
     (Ada_Node : Node_Id := Empty;
      Value    : EW_Literal;
      Typ      : W_Type_OId := Why_Empty)
     return W_Term_Id;

   function New_Literal
     (Ada_Node : Node_Id := Empty;
      Value    : EW_Literal;
      Typ      : W_Type_OId := Why_Empty)
     return W_Prog_Id;

   function New_Binding
     (Ada_Node : Node_Id := Empty;
      Domain   : EW_Domain;
      Name     : W_Identifier_Id;
      Def      : W_Expr_Id;
      Context  : W_Expr_Id;
      Typ      : W_Type_OId := Why_Empty)
     return W_Binding_Id;

   function New_Binding
     (Ada_Node : Node_Id := Empty;
      Domain   : EW_Domain;
      Name     : W_Identifier_Id;
      Def      : W_Expr_Id;
      Context  : W_Expr_Id;
      Typ      : W_Type_OId := Why_Empty)
     return W_Expr_Id;

   function New_Binding
     (Ada_Node : Node_Id := Empty;
      Name     : W_Identifier_Id;
      Def      : W_Term_Id;
      Context  : W_Pred_Id;
      Typ      : W_Type_OId := Why_Empty)
     return W_Pred_Id;

   function New_Binding
     (Ada_Node : Node_Id := Empty;
      Name     : W_Identifier_Id;
      Def      : W_Term_Id;
      Context  : W_Term_Id;
      Typ      : W_Type_OId := Why_Empty)
     return W_Term_Id;

   function New_Binding
     (Ada_Node : Node_Id := Empty;
      Name     : W_Identifier_Id;
      Def      : W_Prog_Id;
      Context  : W_Prog_Id;
      Typ      : W_Type_OId := Why_Empty)
     return W_Prog_Id;

   function New_Elsif
     (Ada_Node  : Node_Id := Empty;
      Domain    : EW_Domain;
      Condition : W_Expr_Id;
      Then_Part : W_Expr_Id;
      Typ       : W_Type_OId := Why_Empty)
     return W_Elsif_Id;

   function New_Elsif
     (Ada_Node  : Node_Id := Empty;
      Domain    : EW_Domain;
      Condition : W_Expr_Id;
      Then_Part : W_Expr_Id;
      Typ       : W_Type_OId := Why_Empty)
     return W_Expr_Id;

   function New_Elsif
     (Ada_Node  : Node_Id := Empty;
      Condition : W_Pred_Id;
      Then_Part : W_Pred_Id;
      Typ       : W_Type_OId := Why_Empty)
     return W_Pred_Id;

   function New_Elsif
     (Ada_Node  : Node_Id := Empty;
      Condition : W_Term_Id;
      Then_Part : W_Term_Id;
      Typ       : W_Type_OId := Why_Empty)
     return W_Term_Id;

   function New_Elsif
     (Ada_Node  : Node_Id := Empty;
      Condition : W_Prog_Id;
      Then_Part : W_Prog_Id;
      Typ       : W_Type_OId := Why_Empty)
     return W_Prog_Id;

   function New_Epsilon
     (Ada_Node : Node_Id := Empty;
      Domain   : EW_Domain;
      Name     : W_Identifier_Id;
      Typ      : W_Type_Id;
      Pred     : W_Pred_Id)
     return W_Epsilon_Id;

   function New_Epsilon
     (Ada_Node : Node_Id := Empty;
      Domain   : EW_Domain;
      Name     : W_Identifier_Id;
      Typ      : W_Type_Id;
      Pred     : W_Pred_Id)
     return W_Expr_Id;

   function New_Epsilon
     (Ada_Node : Node_Id := Empty;
      Name     : W_Identifier_Id;
      Typ      : W_Type_Id;
      Pred     : W_Pred_Id)
     return W_Pred_Id;

   function New_Epsilon
     (Ada_Node : Node_Id := Empty;
      Name     : W_Identifier_Id;
      Typ      : W_Type_Id;
      Pred     : W_Pred_Id)
     return W_Term_Id;

   function New_Epsilon
     (Ada_Node : Node_Id := Empty;
      Name     : W_Identifier_Id;
      Typ      : W_Type_Id;
      Pred     : W_Pred_Id)
     return W_Prog_Id;

   function New_Conditional
     (Ada_Node    : Node_Id := Empty;
      Domain      : EW_Domain;
      Condition   : W_Expr_Id;
      Then_Part   : W_Expr_Id;
      Elsif_Parts : W_Expr_Array := (2 .. 1 => <>);
      Else_Part   : W_Expr_OId := Why_Empty;
      Typ         : W_Type_OId := Why_Empty)
     return W_Conditional_Id;

   function New_Conditional
     (Ada_Node    : Node_Id := Empty;
      Domain      : EW_Domain;
      Condition   : W_Expr_Id;
      Then_Part   : W_Expr_Id;
      Elsif_Parts : W_Expr_Array := (2 .. 1 => <>);
      Else_Part   : W_Expr_OId := Why_Empty;
      Typ         : W_Type_OId := Why_Empty)
     return W_Expr_Id;

   function New_Conditional
     (Ada_Node    : Node_Id := Empty;
      Condition   : W_Pred_Id;
      Then_Part   : W_Pred_Id;
      Elsif_Parts : W_Pred_Array := (2 .. 1 => <>);
      Else_Part   : W_Pred_OId := Why_Empty;
      Typ         : W_Type_OId := Why_Empty)
     return W_Pred_Id;

   function New_Conditional
     (Ada_Node    : Node_Id := Empty;
      Condition   : W_Term_Id;
      Then_Part   : W_Term_Id;
      Elsif_Parts : W_Expr_Array := (2 .. 1 => <>);
      Else_Part   : W_Term_OId := Why_Empty;
      Typ         : W_Type_OId := Why_Empty)
     return W_Term_Id;

   function New_Conditional
     (Ada_Node    : Node_Id := Empty;
      Condition   : W_Prog_Id;
      Then_Part   : W_Prog_Id;
      Elsif_Parts : W_Prog_Array := (2 .. 1 => <>);
      Else_Part   : W_Prog_OId := Why_Empty;
      Typ         : W_Type_OId := Why_Empty)
     return W_Prog_Id;

   function New_Integer_Constant
     (Ada_Node : Node_Id := Empty;
      Value    : Uint)
     return W_Integer_Constant_Id;

   function New_Integer_Constant
     (Ada_Node : Node_Id := Empty;
      Value    : Uint)
     return W_Expr_Id;

   function New_Integer_Constant
     (Ada_Node : Node_Id := Empty;
      Value    : Uint)
     return W_Term_Id;

   function New_Integer_Constant
     (Ada_Node : Node_Id := Empty;
      Value    : Uint)
     return W_Prog_Id;

   function New_Range_Constant
     (Ada_Node : Node_Id := Empty;
      Value    : Uint;
      Typ      : W_Type_Id)
     return W_Range_Constant_Id;

   function New_Range_Constant
     (Ada_Node : Node_Id := Empty;
      Value    : Uint;
      Typ      : W_Type_Id)
     return W_Expr_Id;

   function New_Range_Constant
     (Ada_Node : Node_Id := Empty;
      Value    : Uint;
      Typ      : W_Type_Id)
     return W_Term_Id;

   function New_Range_Constant
     (Ada_Node : Node_Id := Empty;
      Value    : Uint;
      Typ      : W_Type_Id)
     return W_Prog_Id;

   function New_Modular_Constant
     (Ada_Node : Node_Id := Empty;
      Value    : Uint;
      Typ      : W_Type_Id)
     return W_Modular_Constant_Id;

   function New_Modular_Constant
     (Ada_Node : Node_Id := Empty;
      Value    : Uint;
      Typ      : W_Type_Id)
     return W_Expr_Id;

   function New_Modular_Constant
     (Ada_Node : Node_Id := Empty;
      Value    : Uint;
      Typ      : W_Type_Id)
     return W_Term_Id;

   function New_Modular_Constant
     (Ada_Node : Node_Id := Empty;
      Value    : Uint;
      Typ      : W_Type_Id)
     return W_Prog_Id;

   function New_Fixed_Constant
     (Ada_Node : Node_Id := Empty;
      Value    : Uint;
      Typ      : W_Type_Id)
     return W_Fixed_Constant_Id;

   function New_Fixed_Constant
     (Ada_Node : Node_Id := Empty;
      Value    : Uint;
      Typ      : W_Type_Id)
     return W_Expr_Id;

   function New_Fixed_Constant
     (Ada_Node : Node_Id := Empty;
      Value    : Uint;
      Typ      : W_Type_Id)
     return W_Term_Id;

   function New_Fixed_Constant
     (Ada_Node : Node_Id := Empty;
      Value    : Uint;
      Typ      : W_Type_Id)
     return W_Prog_Id;

   function New_Real_Constant
     (Ada_Node : Node_Id := Empty;
      Value    : Ureal)
     return W_Real_Constant_Id;

   function New_Real_Constant
     (Ada_Node : Node_Id := Empty;
      Value    : Ureal)
     return W_Expr_Id;

   function New_Real_Constant
     (Ada_Node : Node_Id := Empty;
      Value    : Ureal)
     return W_Term_Id;

   function New_Real_Constant
     (Ada_Node : Node_Id := Empty;
      Value    : Ureal)
     return W_Prog_Id;

   function New_Float_Constant
     (Ada_Node : Node_Id := Empty;
      Value    : Ureal;
      Typ      : W_Type_Id)
     return W_Float_Constant_Id;

   function New_Float_Constant
     (Ada_Node : Node_Id := Empty;
      Value    : Ureal;
      Typ      : W_Type_Id)
     return W_Expr_Id;

   function New_Float_Constant
     (Ada_Node : Node_Id := Empty;
      Value    : Ureal;
      Typ      : W_Type_Id)
     return W_Term_Id;

   function New_Float_Constant
     (Ada_Node : Node_Id := Empty;
      Value    : Ureal;
      Typ      : W_Type_Id)
     return W_Prog_Id;

   function New_Comment
     (Ada_Node : Node_Id := Empty;
      Comment  : Symbol)
     return W_Comment_Id;

   function New_Comment
     (Ada_Node : Node_Id := Empty;
      Comment  : Symbol)
     return W_Expr_Id;

   function New_Comment
     (Ada_Node : Node_Id := Empty;
      Comment  : Symbol)
     return W_Term_Id;

   function New_Comment
     (Ada_Node : Node_Id := Empty;
      Comment  : Symbol)
     return W_Prog_Id;

   function New_Deref
     (Ada_Node : Node_Id := Empty;
      Right    : W_Identifier_Id;
      Typ      : W_Type_Id)
     return W_Deref_Id;

   function New_Deref
     (Ada_Node : Node_Id := Empty;
      Right    : W_Identifier_Id;
      Typ      : W_Type_Id)
     return W_Expr_Id;

   function New_Deref
     (Ada_Node : Node_Id := Empty;
      Right    : W_Identifier_Id;
      Typ      : W_Type_Id)
     return W_Term_Id;

   function New_Deref
     (Ada_Node : Node_Id := Empty;
      Right    : W_Identifier_Id;
      Typ      : W_Type_Id)
     return W_Prog_Id;

   function New_Record_Access
     (Ada_Node : Node_Id := Empty;
      Name     : W_Expr_Id;
      Field    : W_Identifier_Id;
      Typ      : W_Type_OId := Why_Empty)
     return W_Record_Access_Id;

   function New_Record_Access
     (Ada_Node : Node_Id := Empty;
      Name     : W_Expr_Id;
      Field    : W_Identifier_Id;
      Typ      : W_Type_OId := Why_Empty)
     return W_Expr_Id;

   function New_Record_Access
     (Ada_Node : Node_Id := Empty;
      Name     : W_Term_Id;
      Field    : W_Identifier_Id;
      Typ      : W_Type_OId := Why_Empty)
     return W_Term_Id;

   function New_Record_Access
     (Ada_Node : Node_Id := Empty;
      Name     : W_Prog_Id;
      Field    : W_Identifier_Id;
      Typ      : W_Type_OId := Why_Empty)
     return W_Prog_Id;

   function New_Record_Update
     (Ada_Node : Node_Id := Empty;
      Name     : W_Expr_Id;
      Updates  : W_Field_Association_Array;
      Typ      : W_Type_OId := Why_Empty)
     return W_Record_Update_Id;

   function New_Record_Update
     (Ada_Node : Node_Id := Empty;
      Name     : W_Expr_Id;
      Updates  : W_Field_Association_Array;
      Typ      : W_Type_OId := Why_Empty)
     return W_Expr_Id;

   function New_Record_Update
     (Ada_Node : Node_Id := Empty;
      Name     : W_Term_Id;
      Updates  : W_Field_Association_Array;
      Typ      : W_Type_OId := Why_Empty)
     return W_Term_Id;

   function New_Record_Update
     (Ada_Node : Node_Id := Empty;
      Name     : W_Prog_Id;
      Updates  : W_Field_Association_Array;
      Typ      : W_Type_OId := Why_Empty)
     return W_Prog_Id;

   function New_Record_Aggregate
     (Ada_Node     : Node_Id := Empty;
      Associations : W_Field_Association_Array;
      Typ          : W_Type_OId := Why_Empty)
     return W_Record_Aggregate_Id;

   function New_Record_Aggregate
     (Ada_Node     : Node_Id := Empty;
      Associations : W_Field_Association_Array;
      Typ          : W_Type_OId := Why_Empty)
     return W_Expr_Id;

   function New_Record_Aggregate
     (Ada_Node     : Node_Id := Empty;
      Associations : W_Field_Association_Array;
      Typ          : W_Type_OId := Why_Empty)
     return W_Term_Id;

   function New_Record_Aggregate
     (Ada_Node     : Node_Id := Empty;
      Associations : W_Field_Association_Array;
      Typ          : W_Type_OId := Why_Empty)
     return W_Prog_Id;

   function New_Any_Expr
     (Ada_Node    : Node_Id := Empty;
      Effects     : W_Effects_OId := Why_Empty;
      Pre         : W_Pred_OId := Why_Empty;
      Post        : W_Pred_OId := Why_Empty;
      Return_Type : W_Type_Id;
      Labels      : Symbol_Set)
     return W_Any_Expr_Id;

   function New_Any_Expr
     (Ada_Node    : Node_Id := Empty;
      Effects     : W_Effects_OId := Why_Empty;
      Pre         : W_Pred_OId := Why_Empty;
      Post        : W_Pred_OId := Why_Empty;
      Return_Type : W_Type_Id;
      Labels      : Symbol_Set)
     return W_Expr_Id;

   function New_Any_Expr
     (Ada_Node    : Node_Id := Empty;
      Effects     : W_Effects_OId := Why_Empty;
      Pre         : W_Pred_OId := Why_Empty;
      Post        : W_Pred_OId := Why_Empty;
      Return_Type : W_Type_Id;
      Labels      : Symbol_Set)
     return W_Prog_Id;

   function New_Assignment
     (Ada_Node : Node_Id := Empty;
      Name     : W_Identifier_Id;
      Value    : W_Prog_Id;
      Typ      : W_Type_Id;
      Labels   : Symbol_Set)
     return W_Assignment_Id;

   function New_Assignment
     (Ada_Node : Node_Id := Empty;
      Name     : W_Identifier_Id;
      Value    : W_Prog_Id;
      Typ      : W_Type_Id;
      Labels   : Symbol_Set)
     return W_Expr_Id;

   function New_Assignment
     (Ada_Node : Node_Id := Empty;
      Name     : W_Identifier_Id;
      Value    : W_Prog_Id;
      Typ      : W_Type_Id;
      Labels   : Symbol_Set)
     return W_Prog_Id;

   function New_Binding_Ref
     (Ada_Node : Node_Id := Empty;
      Name     : W_Identifier_Id;
      Def      : W_Prog_Id;
      Context  : W_Prog_Id;
      Typ      : W_Type_Id)
     return W_Binding_Ref_Id;

   function New_Binding_Ref
     (Ada_Node : Node_Id := Empty;
      Name     : W_Identifier_Id;
      Def      : W_Prog_Id;
      Context  : W_Prog_Id;
      Typ      : W_Type_Id)
     return W_Expr_Id;

   function New_Binding_Ref
     (Ada_Node : Node_Id := Empty;
      Name     : W_Identifier_Id;
      Def      : W_Prog_Id;
      Context  : W_Prog_Id;
      Typ      : W_Type_Id)
     return W_Prog_Id;

   function New_Loop
     (Ada_Node    : Node_Id := Empty;
      Code_Before : W_Prog_Id;
      Invariants  : W_Pred_Array := (2 .. 1 => <>);
      Variants    : W_Variants_Array := (2 .. 1 => <>);
      Code_After  : W_Prog_Id)
     return W_Loop_Id;

   function New_Loop
     (Ada_Node    : Node_Id := Empty;
      Code_Before : W_Prog_Id;
      Invariants  : W_Pred_Array := (2 .. 1 => <>);
      Variants    : W_Variants_Array := (2 .. 1 => <>);
      Code_After  : W_Prog_Id)
     return W_Expr_Id;

   function New_Loop
     (Ada_Node    : Node_Id := Empty;
      Code_Before : W_Prog_Id;
      Invariants  : W_Pred_Array := (2 .. 1 => <>);
      Variants    : W_Variants_Array := (2 .. 1 => <>);
      Code_After  : W_Prog_Id)
     return W_Prog_Id;

   function New_Statement_Sequence
     (Ada_Node   : Node_Id := Empty;
      Statements : W_Prog_Array)
     return W_Statement_Sequence_Id;

   function New_Statement_Sequence
     (Ada_Node   : Node_Id := Empty;
      Statements : W_Prog_Array)
     return W_Expr_Id;

   function New_Statement_Sequence
     (Ada_Node   : Node_Id := Empty;
      Statements : W_Prog_Array)
     return W_Prog_Id;

   function New_Abstract_Expr
     (Ada_Node : Node_Id := Empty;
      Expr     : W_Prog_Id;
      Post     : W_Pred_Id;
      Typ      : W_Type_OId := Why_Empty)
     return W_Abstract_Expr_Id;

   function New_Abstract_Expr
     (Ada_Node : Node_Id := Empty;
      Expr     : W_Prog_Id;
      Post     : W_Pred_Id;
      Typ      : W_Type_OId := Why_Empty)
     return W_Expr_Id;

   function New_Abstract_Expr
     (Ada_Node : Node_Id := Empty;
      Expr     : W_Prog_Id;
      Post     : W_Pred_Id;
      Typ      : W_Type_OId := Why_Empty)
     return W_Prog_Id;

   function New_Assert
     (Ada_Node    : Node_Id := Empty;
      Pred        : W_Pred_Id;
      Assert_Kind : EW_Assert_Kind)
     return W_Assert_Id;

   function New_Assert
     (Ada_Node    : Node_Id := Empty;
      Pred        : W_Pred_Id;
      Assert_Kind : EW_Assert_Kind)
     return W_Expr_Id;

   function New_Assert
     (Ada_Node    : Node_Id := Empty;
      Pred        : W_Pred_Id;
      Assert_Kind : EW_Assert_Kind)
     return W_Prog_Id;

   function New_Raise
     (Ada_Node : Node_Id := Empty;
      Name     : W_Name_Id;
      Arg      : W_Expr_OId := Why_Empty;
      Typ      : W_Type_OId := Why_Empty)
     return W_Raise_Id;

   function New_Raise
     (Ada_Node : Node_Id := Empty;
      Name     : W_Name_Id;
      Arg      : W_Expr_OId := Why_Empty;
      Typ      : W_Type_OId := Why_Empty)
     return W_Expr_Id;

   function New_Raise
     (Ada_Node : Node_Id := Empty;
      Name     : W_Name_Id;
      Arg      : W_Prog_OId := Why_Empty;
      Typ      : W_Type_OId := Why_Empty)
     return W_Prog_Id;

   function New_Try_Block
     (Ada_Node : Node_Id := Empty;
      Prog     : W_Prog_Id;
      Handler  : W_Handler_Array;
      Typ      : W_Type_OId := Why_Empty)
     return W_Try_Block_Id;

   function New_Try_Block
     (Ada_Node : Node_Id := Empty;
      Prog     : W_Prog_Id;
      Handler  : W_Handler_Array;
      Typ      : W_Type_OId := Why_Empty)
     return W_Expr_Id;

   function New_Try_Block
     (Ada_Node : Node_Id := Empty;
      Prog     : W_Prog_Id;
      Handler  : W_Handler_Array;
      Typ      : W_Type_OId := Why_Empty)
     return W_Prog_Id;

   function New_Function_Decl
     (Ada_Node    : Node_Id := Empty;
      Domain      : EW_Domain;
      Name        : W_Identifier_Id;
      Binders     : W_Binder_Array := (2 .. 1 => <>);
      Effects     : W_Effects_OId := Why_Empty;
      Pre         : W_Pred_OId := Why_Empty;
      Post        : W_Pred_OId := Why_Empty;
      Return_Type : W_Type_OId := Why_Empty;
      Def         : W_Expr_OId := Why_Empty;
      Labels      : Symbol_Set;
      Location    : Source_Ptr)
     return W_Function_Decl_Id;

   function New_Function_Decl
     (Ada_Node    : Node_Id := Empty;
      Domain      : EW_Domain;
      Name        : W_Identifier_Id;
      Binders     : W_Binder_Array := (2 .. 1 => <>);
      Effects     : W_Effects_OId := Why_Empty;
      Pre         : W_Pred_OId := Why_Empty;
      Post        : W_Pred_OId := Why_Empty;
      Return_Type : W_Type_OId := Why_Empty;
      Def         : W_Expr_OId := Why_Empty;
      Labels      : Symbol_Set;
      Location    : Source_Ptr)
     return W_Declaration_Id;

   function New_Axiom
     (Ada_Node : Node_Id := Empty;
      Name     : Symbol;
      Def      : W_Pred_Id;
      Dep      : W_Axiom_Dep_OId := Why_Empty)
     return W_Axiom_Id;

   function New_Axiom
     (Ada_Node : Node_Id := Empty;
      Name     : Symbol;
      Def      : W_Pred_Id;
      Dep      : W_Axiom_Dep_OId := Why_Empty)
     return W_Declaration_Id;

   function New_Goal
     (Ada_Node : Node_Id := Empty;
      Name     : Symbol;
      Def      : W_Pred_Id)
     return W_Goal_Id;

   function New_Goal
     (Ada_Node : Node_Id := Empty;
      Name     : Symbol;
      Def      : W_Pred_Id)
     return W_Declaration_Id;

   function New_Type_Decl
     (Ada_Node   : Node_Id := Empty;
      Args       : W_Identifier_Array := (2 .. 1 => <>);
      Name       : W_Name_Id;
      Labels     : Symbol_Set;
      Definition : W_Type_Definition_OId := Why_Empty)
     return W_Type_Decl_Id;

   function New_Type_Decl
     (Ada_Node   : Node_Id := Empty;
      Args       : W_Identifier_Array := (2 .. 1 => <>);
      Name       : W_Name_Id;
      Labels     : Symbol_Set;
      Definition : W_Type_Definition_OId := Why_Empty)
     return W_Declaration_Id;

   function New_Global_Ref_Declaration
     (Ada_Node : Node_Id := Empty;
      Name     : W_Identifier_Id;
      Ref_Type : W_Type_Id;
      Labels   : Symbol_Set;
      Location : Source_Ptr)
     return W_Global_Ref_Declaration_Id;

   function New_Global_Ref_Declaration
     (Ada_Node : Node_Id := Empty;
      Name     : W_Identifier_Id;
      Ref_Type : W_Type_Id;
      Labels   : Symbol_Set;
      Location : Source_Ptr)
     return W_Declaration_Id;

   function New_Namespace_Declaration
     (Ada_Node     : Node_Id := Empty;
      Declarations : W_Declaration_Array := (2 .. 1 => <>);
      Name         : Symbol)
     return W_Namespace_Declaration_Id;

   function New_Namespace_Declaration
     (Ada_Node     : Node_Id := Empty;
      Declarations : W_Declaration_Array := (2 .. 1 => <>);
      Name         : Symbol)
     return W_Declaration_Id;

   function New_Exception_Declaration
     (Ada_Node : Node_Id := Empty;
      Name     : W_Name_Id;
      Arg      : W_Type_OId := Why_Empty)
     return W_Exception_Declaration_Id;

   function New_Exception_Declaration
     (Ada_Node : Node_Id := Empty;
      Name     : W_Name_Id;
      Arg      : W_Type_OId := Why_Empty)
     return W_Declaration_Id;

   function New_Meta_Declaration
     (Ada_Node  : Node_Id := Empty;
      Name      : Symbol;
      Parameter : Symbol)
     return W_Meta_Declaration_Id;

   function New_Meta_Declaration
     (Ada_Node  : Node_Id := Empty;
      Name      : Symbol;
      Parameter : Symbol)
     return W_Declaration_Id;

   function New_Clone_Declaration
     (Ada_Node      : Node_Id := Empty;
      Origin        : W_Module_Id;
      As_Name       : Symbol;
      Clone_Kind    : EW_Clone_Type;
      Substitutions : W_Clone_Substitution_Array := (2 .. 1 => <>);
      Theory_Kind   : EW_Theory_Type)
     return W_Clone_Declaration_Id;

   function New_Clone_Declaration
     (Ada_Node      : Node_Id := Empty;
      Origin        : W_Module_Id;
      As_Name       : Symbol;
      Clone_Kind    : EW_Clone_Type;
      Substitutions : W_Clone_Substitution_Array := (2 .. 1 => <>);
      Theory_Kind   : EW_Theory_Type)
     return W_Declaration_Id;

   function New_Clone_Substitution
     (Ada_Node  : Node_Id := Empty;
      Kind      : EW_Subst_Type;
      Orig_Name : W_Name_Id;
      Image     : W_Name_Id)
     return W_Clone_Substitution_Id;

   function New_Include_Declaration
     (Ada_Node : Node_Id := Empty;
      Module   : W_Module_Id;
      Kind     : EW_Theory_Type;
      Use_Kind : EW_Clone_Type)
     return W_Include_Declaration_Id;

   function New_Theory_Declaration
     (Ada_Node     : Node_Id := Empty;
      Declarations : W_Declaration_Array := (2 .. 1 => <>);
      Name         : Symbol;
      Kind         : EW_Theory_Type;
      Includes     : W_Include_Declaration_Array := (2 .. 1 => <>);
      Comment      : Symbol)
     return W_Theory_Declaration_Id;

   function New_Module
     (Ada_Node : Node_Id := Empty;
      File     : Symbol;
      Name     : Symbol)
     return W_Module_Id;

end Why.Atree.Builders;