------------------------------------------------------------------------------
--                                                                          --
--                            GNAT2WHY COMPONENTS                           --
--                                                                          --
--                   W H Y - A T R E E - M U T A T O R S                    --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--                       Copyright (C) 2010-2025, AdaCore                   --
--                                                                          --
-- gnat2why is  free  software;  you can redistribute  it and/or  modify it --
-- under terms of the  GNU General Public License as published  by the Free --
-- Software  Foundation;  either version 3,  or (at your option)  any later --
-- version.  gnat2why is distributed  in the hope that  it will be  useful, --
-- but WITHOUT ANY WARRANTY; without even the implied warranty of  MERCHAN- --
-- TABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public --
-- License for  more details.  You should have  received  a copy of the GNU --
-- General  Public License  distributed with  gnat2why;  see file COPYING3. --
-- If not,  go to  http://www.gnu.org/licenses  for a complete  copy of the --
-- license.                                                                 --
--                                                                          --
-- gnat2why is maintained by AdaCore (http://www.adacore.com)               --
--                                                                          --
------------------------------------------------------------------------------
--  This package is automatically generated by xtree. Do not edit manually.

with Why.Unchecked_Ids;    use Why.Unchecked_Ids;
with Why.Ids;              use Why.Ids;

package Why.Atree.Mutators is
   --  This package provides a set of mutators on unchecked ids

   procedure Effects_Append_To_Reads
     (Id       : W_Effects_Unchecked_Id;
      New_Item : W_Identifier_Id);

   procedure Effects_Prepend_To_Reads
     (Id       : W_Effects_Unchecked_Id;
      New_Item : W_Identifier_Id);

   procedure Effects_Append_To_Reads
     (Id       : W_Effects_Id;
      New_Item : W_Identifier_Id);

   procedure Effects_Prepend_To_Reads
     (Id       : W_Effects_Id;
      New_Item : W_Identifier_Id);

   procedure Effects_Append_To_Writes
     (Id       : W_Effects_Unchecked_Id;
      New_Item : W_Identifier_Id);

   procedure Effects_Prepend_To_Writes
     (Id       : W_Effects_Unchecked_Id;
      New_Item : W_Identifier_Id);

   procedure Effects_Append_To_Writes
     (Id       : W_Effects_Id;
      New_Item : W_Identifier_Id);

   procedure Effects_Prepend_To_Writes
     (Id       : W_Effects_Id;
      New_Item : W_Identifier_Id);

   procedure Effects_Append_To_Raises
     (Id       : W_Effects_Unchecked_Id;
      New_Item : W_Raise_Effect_Id);

   procedure Effects_Prepend_To_Raises
     (Id       : W_Effects_Unchecked_Id;
      New_Item : W_Raise_Effect_Id);

   procedure Effects_Append_To_Raises
     (Id       : W_Effects_Id;
      New_Item : W_Raise_Effect_Id);

   procedure Effects_Prepend_To_Raises
     (Id       : W_Effects_Id;
      New_Item : W_Raise_Effect_Id);

   procedure Statement_Sequence_Append_To_Statements
     (Id       : W_Statement_Sequence_Unchecked_Id;
      New_Item : W_Prog_Id);

   procedure Statement_Sequence_Prepend_To_Statements
     (Id       : W_Statement_Sequence_Unchecked_Id;
      New_Item : W_Prog_Id);

   procedure Statement_Sequence_Append_To_Statements
     (Id       : W_Statement_Sequence_Id;
      New_Item : W_Prog_Id);

   procedure Statement_Sequence_Prepend_To_Statements
     (Id       : W_Statement_Sequence_Id;
      New_Item : W_Prog_Id);

   procedure Theory_Declaration_Append_To_Declarations
     (Id       : W_Theory_Declaration_Unchecked_Id;
      New_Item : W_Declaration_Id);

   procedure Theory_Declaration_Prepend_To_Declarations
     (Id       : W_Theory_Declaration_Unchecked_Id;
      New_Item : W_Declaration_Id);

   procedure Theory_Declaration_Append_To_Declarations
     (Id       : W_Theory_Declaration_Id;
      New_Item : W_Declaration_Id);

   procedure Theory_Declaration_Prepend_To_Declarations
     (Id       : W_Theory_Declaration_Id;
      New_Item : W_Declaration_Id);

   procedure Theory_Declaration_Set_Name
     (Id   : W_Theory_Declaration_Unchecked_Id;
      Name : Symbol);

   procedure Theory_Declaration_Set_Name
     (Id   : W_Theory_Declaration_Id;
      Name : Symbol);

   procedure Theory_Declaration_Set_Kind
     (Id   : W_Theory_Declaration_Unchecked_Id;
      Kind : EW_Theory_Type);

   procedure Theory_Declaration_Set_Kind
     (Id   : W_Theory_Declaration_Id;
      Kind : EW_Theory_Type);

   procedure Theory_Declaration_Append_To_Includes
     (Id       : W_Theory_Declaration_Unchecked_Id;
      New_Item : W_Include_Declaration_Id);

   procedure Theory_Declaration_Prepend_To_Includes
     (Id       : W_Theory_Declaration_Unchecked_Id;
      New_Item : W_Include_Declaration_Id);

   procedure Theory_Declaration_Append_To_Includes
     (Id       : W_Theory_Declaration_Id;
      New_Item : W_Include_Declaration_Id);

   procedure Theory_Declaration_Prepend_To_Includes
     (Id       : W_Theory_Declaration_Id;
      New_Item : W_Include_Declaration_Id);

   procedure Theory_Declaration_Set_Comment
     (Id      : W_Theory_Declaration_Unchecked_Id;
      Comment : Symbol);

   procedure Theory_Declaration_Set_Comment
     (Id      : W_Theory_Declaration_Id;
      Comment : Symbol);

end Why.Atree.Mutators;