------------------------------------------------------------------------------
--                                                                          --
--                            GNAT2WHY COMPONENTS                           --
--                                                                          --
--                     W H Y - A T R E E - T R E E P R                      --
--                                                                          --
--                                 B o d y                                  --
--                                                                          --
--                       Copyright (C) 2010-2025, AdaCore                   --
--                                                                          --
-- gnat2why is  free  software;  you can redistribute  it and/or  modify it --
-- under terms of the  GNU General Public License as published  by the Free --
-- Software  Foundation;  either version 3,  or (at your option)  any later --
-- version.  gnat2why is distributed  in the hope that  it will be  useful, --
-- but WITHOUT ANY WARRANTY; without even the implied warranty of  MERCHAN- --
-- TABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public --
-- License for  more details.  You should have  received  a copy of the GNU --
-- General  Public License  distributed with  gnat2why;  see file COPYING3. --
-- If not,  go to  http://www.gnu.org/licenses  for a complete  copy of the --
-- license.                                                                 --
--                                                                          --
-- gnat2why is maintained by AdaCore (http://www.adacore.com)               --
--                                                                          --
------------------------------------------------------------------------------
--  This package is automatically generated by xtree. Do not edit manually.

with Outputs;             use Outputs;
with Why.Atree.Accessors; use Why.Atree.Accessors;
with Why.Conversions;     use Why.Conversions;
with Why.Images;          use Why.Images;

package body Why.Atree.Treepr is

   O : constant Output_Id := Stdout;

   ---------
   -- wpn --
   ---------

   procedure wpn (Node : Why_Node_Id) is
   begin
      wpt (Node, 1);
   end wpn;

   ---------
   -- wpt --
   ---------

   procedure wpt (Node : Why_Node_Id; Depth : Nat) is
      TPS : Tree_Printer_State := (Control => Continue, Depth => Depth);
   begin
      Traverse (TPS, Node);
   end wpt;

   -----------------
   -- Type_Pre_Op --
   -----------------

   procedure Type_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Type_Id)
   is
   begin
      P (O, "W_Type");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Type_Kind: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K1_Type_Kind);
         NL (O);
         Relative_Indent (O, -1);
         P (O, "Name: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K1_Name);
         Relative_Indent (O, -1);
         P (O, "Is_Mutable: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K1_Is_Mutable);
         NL (O);
         Relative_Indent (O, -1);
         P (O, "Relaxed_Init: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K1_Relaxed_Init);
         NL (O);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Type_Pre_Op;

   ------------------
   -- Type_Post_Op --
   ------------------

   procedure Type_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Type_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Type_Post_Op;

   -----------------
   -- Name_Pre_Op --
   -----------------

   procedure Name_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Name_Id)
   is
   begin
      P (O, "W_Name");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Symb: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K2_Symb);
         NL (O);
         Relative_Indent (O, -1);
         P (O, "Namespace: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K2_Namespace);
         NL (O);
         Relative_Indent (O, -1);
         if Node_Table (+Node).K2_Module /= Why_Empty then
            P (O, "Module: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K2_Module);
            Relative_Indent (O, -1);
         end if;
         P (O, "Infix: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K2_Infix);
         NL (O);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Name_Pre_Op;

   ------------------
   -- Name_Post_Op --
   ------------------

   procedure Name_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Name_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Name_Post_Op;

   --------------------
   -- Effects_Pre_Op --
   --------------------

   procedure Effects_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Effects_Id)
   is
   begin
      P (O, "W_Effects");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         if not Is_Empty (Node_Table (+Node).K3_Reads) then
            P (O, "Reads: ");
            Relative_Indent (O, 1);
            Traverse_List
              (State,
               Node_Table (+Node).K3_Reads);
            Relative_Indent (O, -1);
         end if;
         if not Is_Empty (Node_Table (+Node).K3_Writes) then
            P (O, "Writes: ");
            Relative_Indent (O, 1);
            Traverse_List
              (State,
               Node_Table (+Node).K3_Writes);
            Relative_Indent (O, -1);
         end if;
         if not Is_Empty (Node_Table (+Node).K3_Raises) then
            P (O, "Raises: ");
            Relative_Indent (O, 1);
            Traverse_List
              (State,
               Node_Table (+Node).K3_Raises);
            Relative_Indent (O, -1);
         end if;
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Effects_Pre_Op;

   ---------------------
   -- Effects_Post_Op --
   ---------------------

   procedure Effects_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Effects_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Effects_Post_Op;

   -------------------------
   -- Raise_Effect_Pre_Op --
   -------------------------

   procedure Raise_Effect_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Raise_Effect_Id)
   is
   begin
      P (O, "W_Raise_Effect");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Name: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K4_Name);
         Relative_Indent (O, -1);
         if Node_Table (+Node).K4_Arg_Id /= Why_Empty then
            P (O, "Arg_Id: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K4_Arg_Id);
            Relative_Indent (O, -1);
         end if;
         if Node_Table (+Node).K4_Post /= Why_Empty then
            P (O, "Post: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K4_Post);
            Relative_Indent (O, -1);
         end if;
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Raise_Effect_Pre_Op;

   --------------------------
   -- Raise_Effect_Post_Op --
   --------------------------

   procedure Raise_Effect_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Raise_Effect_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Raise_Effect_Post_Op;

   -------------------
   -- Binder_Pre_Op --
   -------------------

   procedure Binder_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Binder_Id)
   is
   begin
      P (O, "W_Binder");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         if Node_Table (+Node).K5_Name /= Why_Empty then
            P (O, "Name: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K5_Name);
            Relative_Indent (O, -1);
         end if;
         P (O, "Arg_Type: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K5_Arg_Type);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Binder_Pre_Op;

   --------------------
   -- Binder_Post_Op --
   --------------------

   procedure Binder_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Binder_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Binder_Post_Op;

   ----------------------------------------
   -- Transparent_Type_Definition_Pre_Op --
   ----------------------------------------

   procedure Transparent_Type_Definition_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Transparent_Type_Definition_Id)
   is
   begin
      P (O, "W_Transparent_Type_Definition");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Type_Definition: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K6_Type_Definition);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Transparent_Type_Definition_Pre_Op;

   -----------------------------------------
   -- Transparent_Type_Definition_Post_Op --
   -----------------------------------------

   procedure Transparent_Type_Definition_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Transparent_Type_Definition_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Transparent_Type_Definition_Post_Op;

   --------------------------
   -- Record_Binder_Pre_Op --
   --------------------------

   procedure Record_Binder_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Record_Binder_Id)
   is
   begin
      P (O, "W_Record_Binder");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         if Node_Table (+Node).K7_Name /= Why_Empty then
            P (O, "Name: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K7_Name);
            Relative_Indent (O, -1);
         end if;
         P (O, "Arg_Type: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K7_Arg_Type);
         Relative_Indent (O, -1);
         P (O, "Labels: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K7_Labels);
         NL (O);
         Relative_Indent (O, -1);
         P (O, "Is_Mutable: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K7_Is_Mutable);
         NL (O);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Record_Binder_Pre_Op;

   ---------------------------
   -- Record_Binder_Post_Op --
   ---------------------------

   procedure Record_Binder_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Record_Binder_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Record_Binder_Post_Op;

   ------------------------------
   -- Record_Definition_Pre_Op --
   ------------------------------

   procedure Record_Definition_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Record_Definition_Id)
   is
   begin
      P (O, "W_Record_Definition");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Fields: ");
         Relative_Indent (O, 1);
         Traverse_List
           (State,
            Node_Table (+Node).K8_Fields);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Record_Definition_Pre_Op;

   -------------------------------
   -- Record_Definition_Post_Op --
   -------------------------------

   procedure Record_Definition_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Record_Definition_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Record_Definition_Post_Op;

   ----------------------------------
   -- Range_Type_Definition_Pre_Op --
   ----------------------------------

   procedure Range_Type_Definition_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Range_Type_Definition_Id)
   is
   begin
      P (O, "W_Range_Type_Definition");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "First: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K9_First);
         NL (O);
         Relative_Indent (O, -1);
         P (O, "Last: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K9_Last);
         NL (O);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Range_Type_Definition_Pre_Op;

   -----------------------------------
   -- Range_Type_Definition_Post_Op --
   -----------------------------------

   procedure Range_Type_Definition_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Range_Type_Definition_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Range_Type_Definition_Post_Op;

   ---------------------
   -- Triggers_Pre_Op --
   ---------------------

   procedure Triggers_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Triggers_Id)
   is
   begin
      P (O, "W_Triggers");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Triggers: ");
         Relative_Indent (O, 1);
         Traverse_List
           (State,
            Node_Table (+Node).K10_Triggers);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Triggers_Pre_Op;

   ----------------------
   -- Triggers_Post_Op --
   ----------------------

   procedure Triggers_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Triggers_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Triggers_Post_Op;

   --------------------
   -- Trigger_Pre_Op --
   --------------------

   procedure Trigger_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Trigger_Id)
   is
   begin
      P (O, "W_Trigger");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Terms: ");
         Relative_Indent (O, 1);
         Traverse_List
           (State,
            Node_Table (+Node).K11_Terms);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Trigger_Pre_Op;

   ---------------------
   -- Trigger_Post_Op --
   ---------------------

   procedure Trigger_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Trigger_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Trigger_Post_Op;

   ----------------------
   -- Axiom_Dep_Pre_Op --
   ----------------------

   procedure Axiom_Dep_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Axiom_Dep_Id)
   is
   begin
      P (O, "W_Axiom_Dep");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Name: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K12_Name);
         Relative_Indent (O, -1);
         P (O, "Kind: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K12_Kind);
         NL (O);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Axiom_Dep_Pre_Op;

   -----------------------
   -- Axiom_Dep_Post_Op --
   -----------------------

   procedure Axiom_Dep_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Axiom_Dep_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Axiom_Dep_Post_Op;

   --------------------
   -- Handler_Pre_Op --
   --------------------

   procedure Handler_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Handler_Id)
   is
   begin
      P (O, "W_Handler");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Name: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K13_Name);
         Relative_Indent (O, -1);
         if Node_Table (+Node).K13_Arg_Id /= Why_Empty then
            P (O, "Arg_Id: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K13_Arg_Id);
            Relative_Indent (O, -1);
         end if;
         P (O, "Def: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K13_Def);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Handler_Pre_Op;

   ---------------------
   -- Handler_Post_Op --
   ---------------------

   procedure Handler_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Handler_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Handler_Post_Op;

   ------------------------------
   -- Field_Association_Pre_Op --
   ------------------------------

   procedure Field_Association_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Field_Association_Id)
   is
   begin
      P (O, "W_Field_Association");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Field: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K14_Field);
         Relative_Indent (O, -1);
         P (O, "Value: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K14_Value);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Field_Association_Pre_Op;

   -------------------------------
   -- Field_Association_Post_Op --
   -------------------------------

   procedure Field_Association_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Field_Association_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Field_Association_Post_Op;

   --------------------
   -- Variant_Pre_Op --
   --------------------

   procedure Variant_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Variant_Id)
   is
   begin
      P (O, "W_Variant");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Cmp_Op: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K15_Cmp_Op);
         Relative_Indent (O, -1);
         P (O, "Labels: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K15_Labels);
         NL (O);
         Relative_Indent (O, -1);
         P (O, "Expr: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K15_Expr);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Variant_Pre_Op;

   ---------------------
   -- Variant_Post_Op --
   ---------------------

   procedure Variant_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Variant_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Variant_Post_Op;

   ---------------------
   -- Variants_Pre_Op --
   ---------------------

   procedure Variants_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Variants_Id)
   is
   begin
      P (O, "W_Variants");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Variants: ");
         Relative_Indent (O, 1);
         Traverse_List
           (State,
            Node_Table (+Node).K16_Variants);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Variants_Pre_Op;

   ----------------------
   -- Variants_Post_Op --
   ----------------------

   procedure Variants_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Variants_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Variants_Post_Op;

   ------------------------------
   -- Universal_Quantif_Pre_Op --
   ------------------------------

   procedure Universal_Quantif_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Universal_Quantif_Id)
   is
   begin
      P (O, "W_Universal_Quantif");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Variables: ");
         Relative_Indent (O, 1);
         Traverse_List
           (State,
            Node_Table (+Node).K17_Variables);
         Relative_Indent (O, -1);
         P (O, "Labels: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K17_Labels);
         NL (O);
         Relative_Indent (O, -1);
         P (O, "Var_Type: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K17_Var_Type);
         Relative_Indent (O, -1);
         if Node_Table (+Node).K17_Triggers /= Why_Empty then
            P (O, "Triggers: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K17_Triggers);
            Relative_Indent (O, -1);
         end if;
         P (O, "Pred: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K17_Pred);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Universal_Quantif_Pre_Op;

   -------------------------------
   -- Universal_Quantif_Post_Op --
   -------------------------------

   procedure Universal_Quantif_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Universal_Quantif_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Universal_Quantif_Post_Op;

   --------------------------------
   -- Existential_Quantif_Pre_Op --
   --------------------------------

   procedure Existential_Quantif_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Existential_Quantif_Id)
   is
   begin
      P (O, "W_Existential_Quantif");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Variables: ");
         Relative_Indent (O, 1);
         Traverse_List
           (State,
            Node_Table (+Node).K18_Variables);
         Relative_Indent (O, -1);
         P (O, "Labels: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K18_Labels);
         NL (O);
         Relative_Indent (O, -1);
         P (O, "Var_Type: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K18_Var_Type);
         Relative_Indent (O, -1);
         P (O, "Pred: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K18_Pred);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Existential_Quantif_Pre_Op;

   ---------------------------------
   -- Existential_Quantif_Post_Op --
   ---------------------------------

   procedure Existential_Quantif_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Existential_Quantif_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Existential_Quantif_Post_Op;

   ----------------
   -- Not_Pre_Op --
   ----------------

   procedure Not_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Not_Id)
   is
   begin
      P (O, "W_Not");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Right: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K19_Right);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Not_Pre_Op;

   -----------------
   -- Not_Post_Op --
   -----------------

   procedure Not_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Not_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Not_Post_Op;

   -----------------------
   -- Connection_Pre_Op --
   -----------------------

   procedure Connection_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Connection_Id)
   is
   begin
      P (O, "W_Connection");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Left: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K20_Left);
         Relative_Indent (O, -1);
         P (O, "Op: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K20_Op);
         NL (O);
         Relative_Indent (O, -1);
         P (O, "Right: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K20_Right);
         Relative_Indent (O, -1);
         if not Is_Empty (Node_Table (+Node).K20_More_Right) then
            P (O, "More_Right: ");
            Relative_Indent (O, 1);
            Traverse_List
              (State,
               Node_Table (+Node).K20_More_Right);
            Relative_Indent (O, -1);
         end if;
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Connection_Pre_Op;

   ------------------------
   -- Connection_Post_Op --
   ------------------------

   procedure Connection_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Connection_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Connection_Post_Op;

   ------------------
   -- Label_Pre_Op --
   ------------------

   procedure Label_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Label_Id)
   is
   begin
      P (O, "W_Label");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Labels: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K21_Labels);
         NL (O);
         Relative_Indent (O, -1);
         P (O, "Def: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K21_Def);
         Relative_Indent (O, -1);
         if Node_Table (+Node).K21_Typ /= Why_Empty then
            P (O, "Typ: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K21_Typ);
            Relative_Indent (O, -1);
         end if;
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Label_Pre_Op;

   -------------------
   -- Label_Post_Op --
   -------------------

   procedure Label_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Label_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Label_Post_Op;

   ----------------------
   -- Loc_Label_Pre_Op --
   ----------------------

   procedure Loc_Label_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Loc_Label_Id)
   is
   begin
      P (O, "W_Loc_Label");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Sloc: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K22_Sloc);
         NL (O);
         Relative_Indent (O, -1);
         P (O, "Def: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K22_Def);
         Relative_Indent (O, -1);
         P (O, "Marker: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K22_Marker);
         NL (O);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Loc_Label_Pre_Op;

   -----------------------
   -- Loc_Label_Post_Op --
   -----------------------

   procedure Loc_Label_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Loc_Label_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Loc_Label_Post_Op;

   -----------------------
   -- Identifier_Pre_Op --
   -----------------------

   procedure Identifier_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Identifier_Id)
   is
   begin
      P (O, "W_Identifier");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Name: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K23_Name);
         Relative_Indent (O, -1);
         if Node_Table (+Node).K23_Typ /= Why_Empty then
            P (O, "Typ: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K23_Typ);
            Relative_Indent (O, -1);
         end if;
         P (O, "Labels: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K23_Labels);
         NL (O);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Identifier_Pre_Op;

   ------------------------
   -- Identifier_Post_Op --
   ------------------------

   procedure Identifier_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Identifier_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Identifier_Post_Op;

   -------------------
   -- Tagged_Pre_Op --
   -------------------

   procedure Tagged_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Tagged_Id)
   is
   begin
      P (O, "W_Tagged");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Tag: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K24_Tag);
         NL (O);
         Relative_Indent (O, -1);
         P (O, "Def: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K24_Def);
         Relative_Indent (O, -1);
         if Node_Table (+Node).K24_Typ /= Why_Empty then
            P (O, "Typ: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K24_Typ);
            Relative_Indent (O, -1);
         end if;
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Tagged_Pre_Op;

   --------------------
   -- Tagged_Post_Op --
   --------------------

   procedure Tagged_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Tagged_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Tagged_Post_Op;

   -----------------
   -- Call_Pre_Op --
   -----------------

   procedure Call_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Call_Id)
   is
   begin
      P (O, "W_Call");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Name: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K25_Name);
         Relative_Indent (O, -1);
         if not Is_Empty (Node_Table (+Node).K25_Args) then
            P (O, "Args: ");
            Relative_Indent (O, 1);
            Traverse_List
              (State,
               Node_Table (+Node).K25_Args);
            Relative_Indent (O, -1);
         end if;
         if Node_Table (+Node).K25_Typ /= Why_Empty then
            P (O, "Typ: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K25_Typ);
            Relative_Indent (O, -1);
         end if;
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Call_Pre_Op;

   ------------------
   -- Call_Post_Op --
   ------------------

   procedure Call_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Call_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Call_Post_Op;

   --------------------
   -- Literal_Pre_Op --
   --------------------

   procedure Literal_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Literal_Id)
   is
   begin
      P (O, "W_Literal");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Value: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K26_Value);
         NL (O);
         Relative_Indent (O, -1);
         if Node_Table (+Node).K26_Typ /= Why_Empty then
            P (O, "Typ: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K26_Typ);
            Relative_Indent (O, -1);
         end if;
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Literal_Pre_Op;

   ---------------------
   -- Literal_Post_Op --
   ---------------------

   procedure Literal_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Literal_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Literal_Post_Op;

   --------------------
   -- Binding_Pre_Op --
   --------------------

   procedure Binding_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Binding_Id)
   is
   begin
      P (O, "W_Binding");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Name: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K27_Name);
         Relative_Indent (O, -1);
         P (O, "Def: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K27_Def);
         Relative_Indent (O, -1);
         P (O, "Context: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K27_Context);
         Relative_Indent (O, -1);
         if Node_Table (+Node).K27_Typ /= Why_Empty then
            P (O, "Typ: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K27_Typ);
            Relative_Indent (O, -1);
         end if;
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Binding_Pre_Op;

   ---------------------
   -- Binding_Post_Op --
   ---------------------

   procedure Binding_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Binding_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Binding_Post_Op;

   ------------------
   -- Elsif_Pre_Op --
   ------------------

   procedure Elsif_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Elsif_Id)
   is
   begin
      P (O, "W_Elsif");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Condition: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K28_Condition);
         Relative_Indent (O, -1);
         P (O, "Then_Part: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K28_Then_Part);
         Relative_Indent (O, -1);
         if Node_Table (+Node).K28_Typ /= Why_Empty then
            P (O, "Typ: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K28_Typ);
            Relative_Indent (O, -1);
         end if;
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Elsif_Pre_Op;

   -------------------
   -- Elsif_Post_Op --
   -------------------

   procedure Elsif_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Elsif_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Elsif_Post_Op;

   --------------------
   -- Epsilon_Pre_Op --
   --------------------

   procedure Epsilon_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Epsilon_Id)
   is
   begin
      P (O, "W_Epsilon");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Name: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K29_Name);
         Relative_Indent (O, -1);
         P (O, "Typ: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K29_Typ);
         Relative_Indent (O, -1);
         P (O, "Pred: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K29_Pred);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Epsilon_Pre_Op;

   ---------------------
   -- Epsilon_Post_Op --
   ---------------------

   procedure Epsilon_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Epsilon_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Epsilon_Post_Op;

   ------------------------
   -- Conditional_Pre_Op --
   ------------------------

   procedure Conditional_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Conditional_Id)
   is
   begin
      P (O, "W_Conditional");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Condition: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K30_Condition);
         Relative_Indent (O, -1);
         P (O, "Then_Part: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K30_Then_Part);
         Relative_Indent (O, -1);
         if not Is_Empty (Node_Table (+Node).K30_Elsif_Parts) then
            P (O, "Elsif_Parts: ");
            Relative_Indent (O, 1);
            Traverse_List
              (State,
               Node_Table (+Node).K30_Elsif_Parts);
            Relative_Indent (O, -1);
         end if;
         if Node_Table (+Node).K30_Else_Part /= Why_Empty then
            P (O, "Else_Part: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K30_Else_Part);
            Relative_Indent (O, -1);
         end if;
         if Node_Table (+Node).K30_Typ /= Why_Empty then
            P (O, "Typ: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K30_Typ);
            Relative_Indent (O, -1);
         end if;
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Conditional_Pre_Op;

   -------------------------
   -- Conditional_Post_Op --
   -------------------------

   procedure Conditional_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Conditional_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Conditional_Post_Op;

   -----------------------------
   -- Integer_Constant_Pre_Op --
   -----------------------------

   procedure Integer_Constant_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Integer_Constant_Id)
   is
   begin
      P (O, "W_Integer_Constant");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Value: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K31_Value);
         NL (O);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Integer_Constant_Pre_Op;

   ------------------------------
   -- Integer_Constant_Post_Op --
   ------------------------------

   procedure Integer_Constant_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Integer_Constant_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Integer_Constant_Post_Op;

   ---------------------------
   -- Range_Constant_Pre_Op --
   ---------------------------

   procedure Range_Constant_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Range_Constant_Id)
   is
   begin
      P (O, "W_Range_Constant");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Value: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K32_Value);
         NL (O);
         Relative_Indent (O, -1);
         P (O, "Typ: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K32_Typ);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Range_Constant_Pre_Op;

   ----------------------------
   -- Range_Constant_Post_Op --
   ----------------------------

   procedure Range_Constant_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Range_Constant_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Range_Constant_Post_Op;

   -----------------------------
   -- Modular_Constant_Pre_Op --
   -----------------------------

   procedure Modular_Constant_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Modular_Constant_Id)
   is
   begin
      P (O, "W_Modular_Constant");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Value: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K33_Value);
         NL (O);
         Relative_Indent (O, -1);
         P (O, "Typ: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K33_Typ);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Modular_Constant_Pre_Op;

   ------------------------------
   -- Modular_Constant_Post_Op --
   ------------------------------

   procedure Modular_Constant_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Modular_Constant_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Modular_Constant_Post_Op;

   ---------------------------
   -- Fixed_Constant_Pre_Op --
   ---------------------------

   procedure Fixed_Constant_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Fixed_Constant_Id)
   is
   begin
      P (O, "W_Fixed_Constant");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Value: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K34_Value);
         NL (O);
         Relative_Indent (O, -1);
         P (O, "Typ: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K34_Typ);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Fixed_Constant_Pre_Op;

   ----------------------------
   -- Fixed_Constant_Post_Op --
   ----------------------------

   procedure Fixed_Constant_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Fixed_Constant_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Fixed_Constant_Post_Op;

   --------------------------
   -- Real_Constant_Pre_Op --
   --------------------------

   procedure Real_Constant_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Real_Constant_Id)
   is
   begin
      P (O, "W_Real_Constant");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Value: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K35_Value);
         NL (O);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Real_Constant_Pre_Op;

   ---------------------------
   -- Real_Constant_Post_Op --
   ---------------------------

   procedure Real_Constant_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Real_Constant_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Real_Constant_Post_Op;

   ---------------------------
   -- Float_Constant_Pre_Op --
   ---------------------------

   procedure Float_Constant_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Float_Constant_Id)
   is
   begin
      P (O, "W_Float_Constant");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Value: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K36_Value);
         NL (O);
         Relative_Indent (O, -1);
         P (O, "Typ: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K36_Typ);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Float_Constant_Pre_Op;

   ----------------------------
   -- Float_Constant_Post_Op --
   ----------------------------

   procedure Float_Constant_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Float_Constant_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Float_Constant_Post_Op;

   --------------------
   -- Comment_Pre_Op --
   --------------------

   procedure Comment_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Comment_Id)
   is
   begin
      P (O, "W_Comment");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Comment: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K37_Comment);
         NL (O);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Comment_Pre_Op;

   ---------------------
   -- Comment_Post_Op --
   ---------------------

   procedure Comment_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Comment_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Comment_Post_Op;

   ------------------
   -- Deref_Pre_Op --
   ------------------

   procedure Deref_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Deref_Id)
   is
   begin
      P (O, "W_Deref");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Right: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K38_Right);
         Relative_Indent (O, -1);
         P (O, "Typ: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K38_Typ);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Deref_Pre_Op;

   -------------------
   -- Deref_Post_Op --
   -------------------

   procedure Deref_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Deref_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Deref_Post_Op;

   --------------------------
   -- Record_Access_Pre_Op --
   --------------------------

   procedure Record_Access_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Record_Access_Id)
   is
   begin
      P (O, "W_Record_Access");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Name: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K39_Name);
         Relative_Indent (O, -1);
         P (O, "Field: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K39_Field);
         Relative_Indent (O, -1);
         if Node_Table (+Node).K39_Typ /= Why_Empty then
            P (O, "Typ: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K39_Typ);
            Relative_Indent (O, -1);
         end if;
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Record_Access_Pre_Op;

   ---------------------------
   -- Record_Access_Post_Op --
   ---------------------------

   procedure Record_Access_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Record_Access_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Record_Access_Post_Op;

   --------------------------
   -- Record_Update_Pre_Op --
   --------------------------

   procedure Record_Update_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Record_Update_Id)
   is
   begin
      P (O, "W_Record_Update");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Name: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K40_Name);
         Relative_Indent (O, -1);
         P (O, "Updates: ");
         Relative_Indent (O, 1);
         Traverse_List
           (State,
            Node_Table (+Node).K40_Updates);
         Relative_Indent (O, -1);
         if Node_Table (+Node).K40_Typ /= Why_Empty then
            P (O, "Typ: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K40_Typ);
            Relative_Indent (O, -1);
         end if;
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Record_Update_Pre_Op;

   ---------------------------
   -- Record_Update_Post_Op --
   ---------------------------

   procedure Record_Update_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Record_Update_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Record_Update_Post_Op;

   -----------------------------
   -- Record_Aggregate_Pre_Op --
   -----------------------------

   procedure Record_Aggregate_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Record_Aggregate_Id)
   is
   begin
      P (O, "W_Record_Aggregate");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Associations: ");
         Relative_Indent (O, 1);
         Traverse_List
           (State,
            Node_Table (+Node).K41_Associations);
         Relative_Indent (O, -1);
         if Node_Table (+Node).K41_Typ /= Why_Empty then
            P (O, "Typ: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K41_Typ);
            Relative_Indent (O, -1);
         end if;
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Record_Aggregate_Pre_Op;

   ------------------------------
   -- Record_Aggregate_Post_Op --
   ------------------------------

   procedure Record_Aggregate_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Record_Aggregate_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Record_Aggregate_Post_Op;

   ---------------------
   -- Any_Expr_Pre_Op --
   ---------------------

   procedure Any_Expr_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Any_Expr_Id)
   is
   begin
      P (O, "W_Any_Expr");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         if Node_Table (+Node).K42_Effects /= Why_Empty then
            P (O, "Effects: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K42_Effects);
            Relative_Indent (O, -1);
         end if;
         if Node_Table (+Node).K42_Pre /= Why_Empty then
            P (O, "Pre: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K42_Pre);
            Relative_Indent (O, -1);
         end if;
         if Node_Table (+Node).K42_Post /= Why_Empty then
            P (O, "Post: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K42_Post);
            Relative_Indent (O, -1);
         end if;
         P (O, "Return_Type: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K42_Return_Type);
         Relative_Indent (O, -1);
         P (O, "Labels: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K42_Labels);
         NL (O);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Any_Expr_Pre_Op;

   ----------------------
   -- Any_Expr_Post_Op --
   ----------------------

   procedure Any_Expr_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Any_Expr_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Any_Expr_Post_Op;

   -----------------------
   -- Assignment_Pre_Op --
   -----------------------

   procedure Assignment_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Assignment_Id)
   is
   begin
      P (O, "W_Assignment");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Name: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K43_Name);
         Relative_Indent (O, -1);
         P (O, "Value: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K43_Value);
         Relative_Indent (O, -1);
         P (O, "Typ: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K43_Typ);
         Relative_Indent (O, -1);
         P (O, "Labels: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K43_Labels);
         NL (O);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Assignment_Pre_Op;

   ------------------------
   -- Assignment_Post_Op --
   ------------------------

   procedure Assignment_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Assignment_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Assignment_Post_Op;

   ------------------------
   -- Binding_Ref_Pre_Op --
   ------------------------

   procedure Binding_Ref_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Binding_Ref_Id)
   is
   begin
      P (O, "W_Binding_Ref");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Name: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K44_Name);
         Relative_Indent (O, -1);
         P (O, "Def: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K44_Def);
         Relative_Indent (O, -1);
         P (O, "Context: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K44_Context);
         Relative_Indent (O, -1);
         P (O, "Typ: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K44_Typ);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Binding_Ref_Pre_Op;

   -------------------------
   -- Binding_Ref_Post_Op --
   -------------------------

   procedure Binding_Ref_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Binding_Ref_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Binding_Ref_Post_Op;

   -----------------
   -- Loop_Pre_Op --
   -----------------

   procedure Loop_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Loop_Id)
   is
   begin
      P (O, "W_Loop");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Code_Before: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K45_Code_Before);
         Relative_Indent (O, -1);
         if not Is_Empty (Node_Table (+Node).K45_Invariants) then
            P (O, "Invariants: ");
            Relative_Indent (O, 1);
            Traverse_List
              (State,
               Node_Table (+Node).K45_Invariants);
            Relative_Indent (O, -1);
         end if;
         if not Is_Empty (Node_Table (+Node).K45_Variants) then
            P (O, "Variants: ");
            Relative_Indent (O, 1);
            Traverse_List
              (State,
               Node_Table (+Node).K45_Variants);
            Relative_Indent (O, -1);
         end if;
         P (O, "Code_After: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K45_Code_After);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Loop_Pre_Op;

   ------------------
   -- Loop_Post_Op --
   ------------------

   procedure Loop_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Loop_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Loop_Post_Op;

   -------------------------------
   -- Statement_Sequence_Pre_Op --
   -------------------------------

   procedure Statement_Sequence_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Statement_Sequence_Id)
   is
   begin
      P (O, "W_Statement_Sequence");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Statements: ");
         Relative_Indent (O, 1);
         Traverse_List
           (State,
            Node_Table (+Node).K46_Statements);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Statement_Sequence_Pre_Op;

   --------------------------------
   -- Statement_Sequence_Post_Op --
   --------------------------------

   procedure Statement_Sequence_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Statement_Sequence_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Statement_Sequence_Post_Op;

   --------------------------
   -- Abstract_Expr_Pre_Op --
   --------------------------

   procedure Abstract_Expr_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Abstract_Expr_Id)
   is
   begin
      P (O, "W_Abstract_Expr");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Expr: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K47_Expr);
         Relative_Indent (O, -1);
         P (O, "Post: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K47_Post);
         Relative_Indent (O, -1);
         if Node_Table (+Node).K47_Typ /= Why_Empty then
            P (O, "Typ: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K47_Typ);
            Relative_Indent (O, -1);
         end if;
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Abstract_Expr_Pre_Op;

   ---------------------------
   -- Abstract_Expr_Post_Op --
   ---------------------------

   procedure Abstract_Expr_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Abstract_Expr_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Abstract_Expr_Post_Op;

   -------------------
   -- Assert_Pre_Op --
   -------------------

   procedure Assert_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Assert_Id)
   is
   begin
      P (O, "W_Assert");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Pred: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K48_Pred);
         Relative_Indent (O, -1);
         P (O, "Assert_Kind: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K48_Assert_Kind);
         NL (O);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Assert_Pre_Op;

   --------------------
   -- Assert_Post_Op --
   --------------------

   procedure Assert_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Assert_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Assert_Post_Op;

   ------------------
   -- Raise_Pre_Op --
   ------------------

   procedure Raise_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Raise_Id)
   is
   begin
      P (O, "W_Raise");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Name: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K49_Name);
         Relative_Indent (O, -1);
         if Node_Table (+Node).K49_Arg /= Why_Empty then
            P (O, "Arg: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K49_Arg);
            Relative_Indent (O, -1);
         end if;
         if Node_Table (+Node).K49_Typ /= Why_Empty then
            P (O, "Typ: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K49_Typ);
            Relative_Indent (O, -1);
         end if;
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Raise_Pre_Op;

   -------------------
   -- Raise_Post_Op --
   -------------------

   procedure Raise_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Raise_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Raise_Post_Op;

   ----------------------
   -- Try_Block_Pre_Op --
   ----------------------

   procedure Try_Block_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Try_Block_Id)
   is
   begin
      P (O, "W_Try_Block");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Prog: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K50_Prog);
         Relative_Indent (O, -1);
         P (O, "Handler: ");
         Relative_Indent (O, 1);
         Traverse_List
           (State,
            Node_Table (+Node).K50_Handler);
         Relative_Indent (O, -1);
         if Node_Table (+Node).K50_Typ /= Why_Empty then
            P (O, "Typ: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K50_Typ);
            Relative_Indent (O, -1);
         end if;
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Try_Block_Pre_Op;

   -----------------------
   -- Try_Block_Post_Op --
   -----------------------

   procedure Try_Block_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Try_Block_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Try_Block_Post_Op;

   --------------------------
   -- Function_Decl_Pre_Op --
   --------------------------

   procedure Function_Decl_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Function_Decl_Id)
   is
   begin
      P (O, "W_Function_Decl");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Name: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K51_Name);
         Relative_Indent (O, -1);
         if not Is_Empty (Node_Table (+Node).K51_Binders) then
            P (O, "Binders: ");
            Relative_Indent (O, 1);
            Traverse_List
              (State,
               Node_Table (+Node).K51_Binders);
            Relative_Indent (O, -1);
         end if;
         if Node_Table (+Node).K51_Effects /= Why_Empty then
            P (O, "Effects: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K51_Effects);
            Relative_Indent (O, -1);
         end if;
         if Node_Table (+Node).K51_Pre /= Why_Empty then
            P (O, "Pre: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K51_Pre);
            Relative_Indent (O, -1);
         end if;
         if Node_Table (+Node).K51_Post /= Why_Empty then
            P (O, "Post: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K51_Post);
            Relative_Indent (O, -1);
         end if;
         if Node_Table (+Node).K51_Return_Type /= Why_Empty then
            P (O, "Return_Type: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K51_Return_Type);
            Relative_Indent (O, -1);
         end if;
         if Node_Table (+Node).K51_Def /= Why_Empty then
            P (O, "Def: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K51_Def);
            Relative_Indent (O, -1);
         end if;
         P (O, "Labels: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K51_Labels);
         NL (O);
         Relative_Indent (O, -1);
         P (O, "Location: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K51_Location);
         NL (O);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Function_Decl_Pre_Op;

   ---------------------------
   -- Function_Decl_Post_Op --
   ---------------------------

   procedure Function_Decl_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Function_Decl_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Function_Decl_Post_Op;

   ------------------
   -- Axiom_Pre_Op --
   ------------------

   procedure Axiom_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Axiom_Id)
   is
   begin
      P (O, "W_Axiom");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Name: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K52_Name);
         NL (O);
         Relative_Indent (O, -1);
         P (O, "Def: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K52_Def);
         Relative_Indent (O, -1);
         if Node_Table (+Node).K52_Dep /= Why_Empty then
            P (O, "Dep: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K52_Dep);
            Relative_Indent (O, -1);
         end if;
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Axiom_Pre_Op;

   -------------------
   -- Axiom_Post_Op --
   -------------------

   procedure Axiom_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Axiom_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Axiom_Post_Op;

   -----------------
   -- Goal_Pre_Op --
   -----------------

   procedure Goal_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Goal_Id)
   is
   begin
      P (O, "W_Goal");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Name: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K53_Name);
         NL (O);
         Relative_Indent (O, -1);
         P (O, "Def: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K53_Def);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Goal_Pre_Op;

   ------------------
   -- Goal_Post_Op --
   ------------------

   procedure Goal_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Goal_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Goal_Post_Op;

   ----------------------
   -- Type_Decl_Pre_Op --
   ----------------------

   procedure Type_Decl_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Type_Decl_Id)
   is
   begin
      P (O, "W_Type_Decl");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         if not Is_Empty (Node_Table (+Node).K54_Args) then
            P (O, "Args: ");
            Relative_Indent (O, 1);
            Traverse_List
              (State,
               Node_Table (+Node).K54_Args);
            Relative_Indent (O, -1);
         end if;
         P (O, "Name: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K54_Name);
         Relative_Indent (O, -1);
         P (O, "Labels: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K54_Labels);
         NL (O);
         Relative_Indent (O, -1);
         if Node_Table (+Node).K54_Definition /= Why_Empty then
            P (O, "Definition: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K54_Definition);
            Relative_Indent (O, -1);
         end if;
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Type_Decl_Pre_Op;

   -----------------------
   -- Type_Decl_Post_Op --
   -----------------------

   procedure Type_Decl_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Type_Decl_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Type_Decl_Post_Op;

   -----------------------------------
   -- Global_Ref_Declaration_Pre_Op --
   -----------------------------------

   procedure Global_Ref_Declaration_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Global_Ref_Declaration_Id)
   is
   begin
      P (O, "W_Global_Ref_Declaration");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Name: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K55_Name);
         Relative_Indent (O, -1);
         P (O, "Ref_Type: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K55_Ref_Type);
         Relative_Indent (O, -1);
         P (O, "Labels: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K55_Labels);
         NL (O);
         Relative_Indent (O, -1);
         P (O, "Location: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K55_Location);
         NL (O);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Global_Ref_Declaration_Pre_Op;

   ------------------------------------
   -- Global_Ref_Declaration_Post_Op --
   ------------------------------------

   procedure Global_Ref_Declaration_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Global_Ref_Declaration_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Global_Ref_Declaration_Post_Op;

   ----------------------------------
   -- Namespace_Declaration_Pre_Op --
   ----------------------------------

   procedure Namespace_Declaration_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Namespace_Declaration_Id)
   is
   begin
      P (O, "W_Namespace_Declaration");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         if not Is_Empty (Node_Table (+Node).K56_Declarations) then
            P (O, "Declarations: ");
            Relative_Indent (O, 1);
            Traverse_List
              (State,
               Node_Table (+Node).K56_Declarations);
            Relative_Indent (O, -1);
         end if;
         P (O, "Name: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K56_Name);
         NL (O);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Namespace_Declaration_Pre_Op;

   -----------------------------------
   -- Namespace_Declaration_Post_Op --
   -----------------------------------

   procedure Namespace_Declaration_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Namespace_Declaration_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Namespace_Declaration_Post_Op;

   ----------------------------------
   -- Exception_Declaration_Pre_Op --
   ----------------------------------

   procedure Exception_Declaration_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Exception_Declaration_Id)
   is
   begin
      P (O, "W_Exception_Declaration");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Name: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K57_Name);
         Relative_Indent (O, -1);
         if Node_Table (+Node).K57_Arg /= Why_Empty then
            P (O, "Arg: ");
            Relative_Indent (O, 1);
            Traverse
              (State,
               Node_Table (+Node).K57_Arg);
            Relative_Indent (O, -1);
         end if;
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Exception_Declaration_Pre_Op;

   -----------------------------------
   -- Exception_Declaration_Post_Op --
   -----------------------------------

   procedure Exception_Declaration_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Exception_Declaration_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Exception_Declaration_Post_Op;

   -----------------------------
   -- Meta_Declaration_Pre_Op --
   -----------------------------

   procedure Meta_Declaration_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Meta_Declaration_Id)
   is
   begin
      P (O, "W_Meta_Declaration");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Name: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K58_Name);
         NL (O);
         Relative_Indent (O, -1);
         P (O, "Parameter: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K58_Parameter);
         NL (O);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Meta_Declaration_Pre_Op;

   ------------------------------
   -- Meta_Declaration_Post_Op --
   ------------------------------

   procedure Meta_Declaration_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Meta_Declaration_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Meta_Declaration_Post_Op;

   ------------------------------
   -- Clone_Declaration_Pre_Op --
   ------------------------------

   procedure Clone_Declaration_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Clone_Declaration_Id)
   is
   begin
      P (O, "W_Clone_Declaration");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Origin: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K59_Origin);
         Relative_Indent (O, -1);
         P (O, "As_Name: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K59_As_Name);
         NL (O);
         Relative_Indent (O, -1);
         P (O, "Clone_Kind: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K59_Clone_Kind);
         NL (O);
         Relative_Indent (O, -1);
         if not Is_Empty (Node_Table (+Node).K59_Substitutions) then
            P (O, "Substitutions: ");
            Relative_Indent (O, 1);
            Traverse_List
              (State,
               Node_Table (+Node).K59_Substitutions);
            Relative_Indent (O, -1);
         end if;
         P (O, "Theory_Kind: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K59_Theory_Kind);
         NL (O);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Clone_Declaration_Pre_Op;

   -------------------------------
   -- Clone_Declaration_Post_Op --
   -------------------------------

   procedure Clone_Declaration_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Clone_Declaration_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Clone_Declaration_Post_Op;

   -------------------------------
   -- Clone_Substitution_Pre_Op --
   -------------------------------

   procedure Clone_Substitution_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Clone_Substitution_Id)
   is
   begin
      P (O, "W_Clone_Substitution");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Kind: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K60_Kind);
         NL (O);
         Relative_Indent (O, -1);
         P (O, "Orig_Name: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K60_Orig_Name);
         Relative_Indent (O, -1);
         P (O, "Image: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K60_Image);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Clone_Substitution_Pre_Op;

   --------------------------------
   -- Clone_Substitution_Post_Op --
   --------------------------------

   procedure Clone_Substitution_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Clone_Substitution_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Clone_Substitution_Post_Op;

   --------------------------------
   -- Include_Declaration_Pre_Op --
   --------------------------------

   procedure Include_Declaration_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Include_Declaration_Id)
   is
   begin
      P (O, "W_Include_Declaration");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "Module: ");
         Relative_Indent (O, 1);
         Traverse
           (State,
            Node_Table (+Node).K61_Module);
         Relative_Indent (O, -1);
         P (O, "Kind: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K61_Kind);
         NL (O);
         Relative_Indent (O, -1);
         P (O, "Use_Kind: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K61_Use_Kind);
         NL (O);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Include_Declaration_Pre_Op;

   ---------------------------------
   -- Include_Declaration_Post_Op --
   ---------------------------------

   procedure Include_Declaration_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Include_Declaration_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Include_Declaration_Post_Op;

   -------------------------------
   -- Theory_Declaration_Pre_Op --
   -------------------------------

   procedure Theory_Declaration_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Theory_Declaration_Id)
   is
   begin
      P (O, "W_Theory_Declaration");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         if not Is_Empty (Node_Table (+Node).K62_Declarations) then
            P (O, "Declarations: ");
            Relative_Indent (O, 1);
            Traverse_List
              (State,
               Node_Table (+Node).K62_Declarations);
            Relative_Indent (O, -1);
         end if;
         P (O, "Name: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K62_Name);
         NL (O);
         Relative_Indent (O, -1);
         P (O, "Kind: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K62_Kind);
         NL (O);
         Relative_Indent (O, -1);
         if not Is_Empty (Node_Table (+Node).K62_Includes) then
            P (O, "Includes: ");
            Relative_Indent (O, 1);
            Traverse_List
              (State,
               Node_Table (+Node).K62_Includes);
            Relative_Indent (O, -1);
         end if;
         P (O, "Comment: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K62_Comment);
         NL (O);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Theory_Declaration_Pre_Op;

   --------------------------------
   -- Theory_Declaration_Post_Op --
   --------------------------------

   procedure Theory_Declaration_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Theory_Declaration_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Theory_Declaration_Post_Op;

   -------------------
   -- Module_Pre_Op --
   -------------------

   procedure Module_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Module_Id)
   is
   begin
      P (O, "W_Module");
      P (O, " (Node_Id=");
      P (O, +Node);
      P (O, ")");
      NL (O);
      if State.Depth /= 0 then
         State.Depth := State.Depth - 1;
         Relative_Indent (O, 1);
         P (O, "Ada_Node: ");
         P (O, Get_Ada_Node (+Node));
         NL (O);
         P (O, "Domain: ");
         P (O, Get_Domain (+Node));
         NL (O);
         P (O, "File: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K63_File);
         NL (O);
         Relative_Indent (O, -1);
         P (O, "Name: ");
         Relative_Indent (O, 1);
         P (O, Node_Table (+Node).K63_Name);
         NL (O);
         Relative_Indent (O, -1);
         Relative_Indent (O, -1);
         State.Depth := State.Depth + 1;
      end if;
      State.Control := Abandon_Children;
   end Module_Pre_Op;

   --------------------
   -- Module_Post_Op --
   --------------------

   procedure Module_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Module_Id)
   is
      pragma Unreferenced (Node);
      pragma Unreferenced (State);
   begin
      null;
   end Module_Post_Op;

end Why.Atree.Treepr;