------------------------------------------------------------------------------
--                                                                          --
--                            GNAT2WHY COMPONENTS                           --
--                                                                          --
--                     W H Y - A T R E E - T R E E P R                      --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--                       Copyright (C) 2010-2025, AdaCore                   --
--                                                                          --
-- gnat2why is  free  software;  you can redistribute  it and/or  modify it --
-- under terms of the  GNU General Public License as published  by the Free --
-- Software  Foundation;  either version 3,  or (at your option)  any later --
-- version.  gnat2why is distributed  in the hope that  it will be  useful, --
-- but WITHOUT ANY WARRANTY; without even the implied warranty of  MERCHAN- --
-- TABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public --
-- License for  more details.  You should have  received  a copy of the GNU --
-- General  Public License  distributed with  gnat2why;  see file COPYING3. --
-- If not,  go to  http://www.gnu.org/licenses  for a complete  copy of the --
-- license.                                                                 --
--                                                                          --
-- gnat2why is maintained by AdaCore (http://www.adacore.com)               --
--                                                                          --
------------------------------------------------------------------------------
--  This package is automatically generated by xtree. Do not edit manually.

with Why.Ids;             use Why.Ids;
with Why.Atree.Traversal; use Why.Atree.Traversal;

package Why.Atree.Treepr is

   procedure wpn (Node : Why_Node_Id);
   pragma Export (Ada, wpn);
   --  Print a single node, without printing the descendants

   procedure wpt (Node : Why_Node_Id; Depth : Nat);
   pragma Export (Ada, wpt);
   --  Print the subtree routed at a specified tree node up to a given depth

private

   type Tree_Printer_State is new Traversal_State with record
      Depth : Nat;
   end record;

   procedure Type_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Type_Id);

   procedure Type_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Type_Id);

   procedure Name_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Name_Id);

   procedure Name_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Name_Id);

   procedure Effects_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Effects_Id);

   procedure Effects_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Effects_Id);

   procedure Raise_Effect_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Raise_Effect_Id);

   procedure Raise_Effect_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Raise_Effect_Id);

   procedure Binder_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Binder_Id);

   procedure Binder_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Binder_Id);

   procedure Transparent_Type_Definition_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Transparent_Type_Definition_Id);

   procedure Transparent_Type_Definition_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Transparent_Type_Definition_Id);

   procedure Record_Binder_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Record_Binder_Id);

   procedure Record_Binder_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Record_Binder_Id);

   procedure Record_Definition_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Record_Definition_Id);

   procedure Record_Definition_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Record_Definition_Id);

   procedure Range_Type_Definition_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Range_Type_Definition_Id);

   procedure Range_Type_Definition_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Range_Type_Definition_Id);

   procedure Triggers_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Triggers_Id);

   procedure Triggers_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Triggers_Id);

   procedure Trigger_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Trigger_Id);

   procedure Trigger_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Trigger_Id);

   procedure Axiom_Dep_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Axiom_Dep_Id);

   procedure Axiom_Dep_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Axiom_Dep_Id);

   procedure Handler_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Handler_Id);

   procedure Handler_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Handler_Id);

   procedure Field_Association_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Field_Association_Id);

   procedure Field_Association_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Field_Association_Id);

   procedure Variant_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Variant_Id);

   procedure Variant_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Variant_Id);

   procedure Variants_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Variants_Id);

   procedure Variants_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Variants_Id);

   procedure Universal_Quantif_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Universal_Quantif_Id);

   procedure Universal_Quantif_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Universal_Quantif_Id);

   procedure Existential_Quantif_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Existential_Quantif_Id);

   procedure Existential_Quantif_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Existential_Quantif_Id);

   procedure Not_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Not_Id);

   procedure Not_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Not_Id);

   procedure Connection_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Connection_Id);

   procedure Connection_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Connection_Id);

   procedure Label_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Label_Id);

   procedure Label_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Label_Id);

   procedure Loc_Label_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Loc_Label_Id);

   procedure Loc_Label_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Loc_Label_Id);

   procedure Identifier_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Identifier_Id);

   procedure Identifier_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Identifier_Id);

   procedure Tagged_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Tagged_Id);

   procedure Tagged_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Tagged_Id);

   procedure Call_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Call_Id);

   procedure Call_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Call_Id);

   procedure Literal_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Literal_Id);

   procedure Literal_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Literal_Id);

   procedure Binding_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Binding_Id);

   procedure Binding_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Binding_Id);

   procedure Elsif_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Elsif_Id);

   procedure Elsif_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Elsif_Id);

   procedure Epsilon_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Epsilon_Id);

   procedure Epsilon_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Epsilon_Id);

   procedure Conditional_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Conditional_Id);

   procedure Conditional_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Conditional_Id);

   procedure Integer_Constant_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Integer_Constant_Id);

   procedure Integer_Constant_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Integer_Constant_Id);

   procedure Range_Constant_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Range_Constant_Id);

   procedure Range_Constant_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Range_Constant_Id);

   procedure Modular_Constant_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Modular_Constant_Id);

   procedure Modular_Constant_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Modular_Constant_Id);

   procedure Fixed_Constant_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Fixed_Constant_Id);

   procedure Fixed_Constant_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Fixed_Constant_Id);

   procedure Real_Constant_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Real_Constant_Id);

   procedure Real_Constant_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Real_Constant_Id);

   procedure Float_Constant_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Float_Constant_Id);

   procedure Float_Constant_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Float_Constant_Id);

   procedure Comment_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Comment_Id);

   procedure Comment_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Comment_Id);

   procedure Deref_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Deref_Id);

   procedure Deref_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Deref_Id);

   procedure Record_Access_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Record_Access_Id);

   procedure Record_Access_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Record_Access_Id);

   procedure Record_Update_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Record_Update_Id);

   procedure Record_Update_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Record_Update_Id);

   procedure Record_Aggregate_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Record_Aggregate_Id);

   procedure Record_Aggregate_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Record_Aggregate_Id);

   procedure Any_Expr_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Any_Expr_Id);

   procedure Any_Expr_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Any_Expr_Id);

   procedure Assignment_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Assignment_Id);

   procedure Assignment_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Assignment_Id);

   procedure Binding_Ref_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Binding_Ref_Id);

   procedure Binding_Ref_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Binding_Ref_Id);

   procedure Loop_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Loop_Id);

   procedure Loop_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Loop_Id);

   procedure Statement_Sequence_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Statement_Sequence_Id);

   procedure Statement_Sequence_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Statement_Sequence_Id);

   procedure Abstract_Expr_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Abstract_Expr_Id);

   procedure Abstract_Expr_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Abstract_Expr_Id);

   procedure Assert_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Assert_Id);

   procedure Assert_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Assert_Id);

   procedure Raise_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Raise_Id);

   procedure Raise_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Raise_Id);

   procedure Try_Block_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Try_Block_Id);

   procedure Try_Block_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Try_Block_Id);

   procedure Function_Decl_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Function_Decl_Id);

   procedure Function_Decl_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Function_Decl_Id);

   procedure Axiom_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Axiom_Id);

   procedure Axiom_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Axiom_Id);

   procedure Goal_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Goal_Id);

   procedure Goal_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Goal_Id);

   procedure Type_Decl_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Type_Decl_Id);

   procedure Type_Decl_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Type_Decl_Id);

   procedure Global_Ref_Declaration_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Global_Ref_Declaration_Id);

   procedure Global_Ref_Declaration_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Global_Ref_Declaration_Id);

   procedure Namespace_Declaration_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Namespace_Declaration_Id);

   procedure Namespace_Declaration_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Namespace_Declaration_Id);

   procedure Exception_Declaration_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Exception_Declaration_Id);

   procedure Exception_Declaration_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Exception_Declaration_Id);

   procedure Meta_Declaration_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Meta_Declaration_Id);

   procedure Meta_Declaration_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Meta_Declaration_Id);

   procedure Clone_Declaration_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Clone_Declaration_Id);

   procedure Clone_Declaration_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Clone_Declaration_Id);

   procedure Clone_Substitution_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Clone_Substitution_Id);

   procedure Clone_Substitution_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Clone_Substitution_Id);

   procedure Include_Declaration_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Include_Declaration_Id);

   procedure Include_Declaration_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Include_Declaration_Id);

   procedure Theory_Declaration_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Theory_Declaration_Id);

   procedure Theory_Declaration_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Theory_Declaration_Id);

   procedure Module_Pre_Op
     (State : in out Tree_Printer_State;
      Node  : W_Module_Id);

   procedure Module_Post_Op
     (State : in out Tree_Printer_State;
      Node  : W_Module_Id);

end Why.Atree.Treepr;