------------------------------------------------------------------------------
--                                                                          --
--                            GNAT2WHY COMPONENTS                           --
--                                                                          --
--                   W H Y - A T R E E - V A L I D I T Y                    --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--                       Copyright (C) 2010-2025, AdaCore                   --
--                                                                          --
-- gnat2why is  free  software;  you can redistribute  it and/or  modify it --
-- under terms of the  GNU General Public License as published  by the Free --
-- Software  Foundation;  either version 3,  or (at your option)  any later --
-- version.  gnat2why is distributed  in the hope that  it will be  useful, --
-- but WITHOUT ANY WARRANTY; without even the implied warranty of  MERCHAN- --
-- TABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public --
-- License for  more details.  You should have  received  a copy of the GNU --
-- General  Public License  distributed with  gnat2why;  see file COPYING3. --
-- If not,  go to  http://www.gnu.org/licenses  for a complete  copy of the --
-- license.                                                                 --
--                                                                          --
-- gnat2why is maintained by AdaCore (http://www.adacore.com)               --
--                                                                          --
------------------------------------------------------------------------------
--  This package is automatically generated by xtree. Do not edit manually.

with Why.Unchecked_Ids;   use Why.Unchecked_Ids;

package Why.Atree.Validity is
   --  Validity checks

   --  Why.Ids defines of the validity of an node id; this package provides an
   --  implementation of validity checks for this property.
   --
   --  Checking the validity of a syntax tree would require to traverse
   --  recursively the whole tree; that would make it harder to use validity
   --  checks in contracts and would introduce a prohibitive cost at execution.
   --  In order to have a reasonable implementation, the validity status of a
   --  subtree is cached in the field Checked of each node.
   --
   --  Each mutator should update this status, and these changes should be
   --  propagated back to the parent (this back-propagation has not been
   --  implemented yet).
   --
   --  In order to use validity checks in contracts, these are defined as
   --  parameterized expressions. The only check for the node validity, and
   --  then for its children validity if needed. In order to implement this,
   --  the validity check is raffined into three different operation:
   --  * a cache check, named <node kind>_Cache_Valid, checks if the node has
   --    already been marked as valid in its field Checked;
   --  * a children check, named <node_kind>_Children_Valid, goes through all
   --    its children and check for their validity; for each children, only a
   --    cache check is done, in order to avoid a full-dept recursive
   --    traversal;
   --  * the regular check, that does first a cache check, then a children
   --    check.
   --
   --  Different checks are provided for each multiplicity "Id", "OId", "List",
   --  "OList" (e.g. depending on whether the empty is OK or not). Some are
   --  also provided for node classes: they dispatch on the "real" check
   --  depending on the actual node kind.

   function Unused_At_Start_OId_Valid
     (Id : W_Unused_At_Start_Unchecked_OId)
     return Boolean;

   function Unused_At_Start_OList_Valid
     (Id : W_Unused_At_Start_Unchecked_OList)
     return Boolean;

   function Unused_At_Start_Id_Valid
     (Id : W_Unused_At_Start_Unchecked_Id)
     return Boolean;

   function Unused_At_Start_List_Valid
     (Id : W_Unused_At_Start_Unchecked_List)
     return Boolean;

   function Type_OId_Valid
     (Id : W_Type_Unchecked_OId)
     return Boolean;

   function Type_OList_Valid
     (Id : W_Type_Unchecked_OList)
     return Boolean;

   function Type_Id_Valid
     (Id : W_Type_Unchecked_Id)
     return Boolean;

   function Type_List_Valid
     (Id : W_Type_Unchecked_List)
     return Boolean;

   function Name_OId_Valid
     (Id : W_Name_Unchecked_OId)
     return Boolean;

   function Name_OList_Valid
     (Id : W_Name_Unchecked_OList)
     return Boolean;

   function Name_Id_Valid
     (Id : W_Name_Unchecked_Id)
     return Boolean;

   function Name_List_Valid
     (Id : W_Name_Unchecked_List)
     return Boolean;

   function Effects_OId_Valid
     (Id : W_Effects_Unchecked_OId)
     return Boolean;

   function Effects_OList_Valid
     (Id : W_Effects_Unchecked_OList)
     return Boolean;

   function Effects_Id_Valid
     (Id : W_Effects_Unchecked_Id)
     return Boolean;

   function Effects_List_Valid
     (Id : W_Effects_Unchecked_List)
     return Boolean;

   function Raise_Effect_OId_Valid
     (Id : W_Raise_Effect_Unchecked_OId)
     return Boolean;

   function Raise_Effect_OList_Valid
     (Id : W_Raise_Effect_Unchecked_OList)
     return Boolean;

   function Raise_Effect_Id_Valid
     (Id : W_Raise_Effect_Unchecked_Id)
     return Boolean;

   function Raise_Effect_List_Valid
     (Id : W_Raise_Effect_Unchecked_List)
     return Boolean;

   function Binder_OId_Valid
     (Id : W_Binder_Unchecked_OId)
     return Boolean;

   function Binder_OList_Valid
     (Id : W_Binder_Unchecked_OList)
     return Boolean;

   function Binder_Id_Valid
     (Id : W_Binder_Unchecked_Id)
     return Boolean;

   function Binder_List_Valid
     (Id : W_Binder_Unchecked_List)
     return Boolean;

   function Transparent_Type_Definition_OId_Valid
     (Id : W_Transparent_Type_Definition_Unchecked_OId)
     return Boolean;

   function Transparent_Type_Definition_OList_Valid
     (Id : W_Transparent_Type_Definition_Unchecked_OList)
     return Boolean;

   function Transparent_Type_Definition_Id_Valid
     (Id : W_Transparent_Type_Definition_Unchecked_Id)
     return Boolean;

   function Transparent_Type_Definition_List_Valid
     (Id : W_Transparent_Type_Definition_Unchecked_List)
     return Boolean;

   function Record_Binder_OId_Valid
     (Id : W_Record_Binder_Unchecked_OId)
     return Boolean;

   function Record_Binder_OList_Valid
     (Id : W_Record_Binder_Unchecked_OList)
     return Boolean;

   function Record_Binder_Id_Valid
     (Id : W_Record_Binder_Unchecked_Id)
     return Boolean;

   function Record_Binder_List_Valid
     (Id : W_Record_Binder_Unchecked_List)
     return Boolean;

   function Record_Definition_OId_Valid
     (Id : W_Record_Definition_Unchecked_OId)
     return Boolean;

   function Record_Definition_OList_Valid
     (Id : W_Record_Definition_Unchecked_OList)
     return Boolean;

   function Record_Definition_Id_Valid
     (Id : W_Record_Definition_Unchecked_Id)
     return Boolean;

   function Record_Definition_List_Valid
     (Id : W_Record_Definition_Unchecked_List)
     return Boolean;

   function Range_Type_Definition_OId_Valid
     (Id : W_Range_Type_Definition_Unchecked_OId)
     return Boolean;

   function Range_Type_Definition_OList_Valid
     (Id : W_Range_Type_Definition_Unchecked_OList)
     return Boolean;

   function Range_Type_Definition_Id_Valid
     (Id : W_Range_Type_Definition_Unchecked_Id)
     return Boolean;

   function Range_Type_Definition_List_Valid
     (Id : W_Range_Type_Definition_Unchecked_List)
     return Boolean;

   function Triggers_OId_Valid
     (Id : W_Triggers_Unchecked_OId)
     return Boolean;

   function Triggers_OList_Valid
     (Id : W_Triggers_Unchecked_OList)
     return Boolean;

   function Triggers_Id_Valid
     (Id : W_Triggers_Unchecked_Id)
     return Boolean;

   function Triggers_List_Valid
     (Id : W_Triggers_Unchecked_List)
     return Boolean;

   function Trigger_OId_Valid
     (Id : W_Trigger_Unchecked_OId)
     return Boolean;

   function Trigger_OList_Valid
     (Id : W_Trigger_Unchecked_OList)
     return Boolean;

   function Trigger_Id_Valid
     (Id : W_Trigger_Unchecked_Id)
     return Boolean;

   function Trigger_List_Valid
     (Id : W_Trigger_Unchecked_List)
     return Boolean;

   function Axiom_Dep_OId_Valid
     (Id : W_Axiom_Dep_Unchecked_OId)
     return Boolean;

   function Axiom_Dep_OList_Valid
     (Id : W_Axiom_Dep_Unchecked_OList)
     return Boolean;

   function Axiom_Dep_Id_Valid
     (Id : W_Axiom_Dep_Unchecked_Id)
     return Boolean;

   function Axiom_Dep_List_Valid
     (Id : W_Axiom_Dep_Unchecked_List)
     return Boolean;

   function Handler_OId_Valid
     (Id : W_Handler_Unchecked_OId)
     return Boolean;

   function Handler_OList_Valid
     (Id : W_Handler_Unchecked_OList)
     return Boolean;

   function Handler_Id_Valid
     (Id : W_Handler_Unchecked_Id)
     return Boolean;

   function Handler_List_Valid
     (Id : W_Handler_Unchecked_List)
     return Boolean;

   function Field_Association_OId_Valid
     (Id : W_Field_Association_Unchecked_OId)
     return Boolean;

   function Field_Association_OList_Valid
     (Id : W_Field_Association_Unchecked_OList)
     return Boolean;

   function Field_Association_Id_Valid
     (Id : W_Field_Association_Unchecked_Id)
     return Boolean;

   function Field_Association_List_Valid
     (Id : W_Field_Association_Unchecked_List)
     return Boolean;

   function Variant_OId_Valid
     (Id : W_Variant_Unchecked_OId)
     return Boolean;

   function Variant_OList_Valid
     (Id : W_Variant_Unchecked_OList)
     return Boolean;

   function Variant_Id_Valid
     (Id : W_Variant_Unchecked_Id)
     return Boolean;

   function Variant_List_Valid
     (Id : W_Variant_Unchecked_List)
     return Boolean;

   function Variants_OId_Valid
     (Id : W_Variants_Unchecked_OId)
     return Boolean;

   function Variants_OList_Valid
     (Id : W_Variants_Unchecked_OList)
     return Boolean;

   function Variants_Id_Valid
     (Id : W_Variants_Unchecked_Id)
     return Boolean;

   function Variants_List_Valid
     (Id : W_Variants_Unchecked_List)
     return Boolean;

   function Universal_Quantif_OId_Valid
     (Id : W_Universal_Quantif_Unchecked_OId)
     return Boolean;

   function Universal_Quantif_OList_Valid
     (Id : W_Universal_Quantif_Unchecked_OList)
     return Boolean;

   function Universal_Quantif_Id_Valid
     (Id : W_Universal_Quantif_Unchecked_Id)
     return Boolean;

   function Universal_Quantif_List_Valid
     (Id : W_Universal_Quantif_Unchecked_List)
     return Boolean;

   function Existential_Quantif_OId_Valid
     (Id : W_Existential_Quantif_Unchecked_OId)
     return Boolean;

   function Existential_Quantif_OList_Valid
     (Id : W_Existential_Quantif_Unchecked_OList)
     return Boolean;

   function Existential_Quantif_Id_Valid
     (Id : W_Existential_Quantif_Unchecked_Id)
     return Boolean;

   function Existential_Quantif_List_Valid
     (Id : W_Existential_Quantif_Unchecked_List)
     return Boolean;

   function Not_OId_Valid
     (Id : W_Not_Unchecked_OId)
     return Boolean;

   function Not_OList_Valid
     (Id : W_Not_Unchecked_OList)
     return Boolean;

   function Not_Id_Valid
     (Id : W_Not_Unchecked_Id)
     return Boolean;

   function Not_List_Valid
     (Id : W_Not_Unchecked_List)
     return Boolean;

   function Connection_OId_Valid
     (Id : W_Connection_Unchecked_OId)
     return Boolean;

   function Connection_OList_Valid
     (Id : W_Connection_Unchecked_OList)
     return Boolean;

   function Connection_Id_Valid
     (Id : W_Connection_Unchecked_Id)
     return Boolean;

   function Connection_List_Valid
     (Id : W_Connection_Unchecked_List)
     return Boolean;

   function Label_OId_Valid
     (Id : W_Label_Unchecked_OId)
     return Boolean;

   function Label_OList_Valid
     (Id : W_Label_Unchecked_OList)
     return Boolean;

   function Label_Id_Valid
     (Id : W_Label_Unchecked_Id)
     return Boolean;

   function Label_List_Valid
     (Id : W_Label_Unchecked_List)
     return Boolean;

   function Loc_Label_OId_Valid
     (Id : W_Loc_Label_Unchecked_OId)
     return Boolean;

   function Loc_Label_OList_Valid
     (Id : W_Loc_Label_Unchecked_OList)
     return Boolean;

   function Loc_Label_Id_Valid
     (Id : W_Loc_Label_Unchecked_Id)
     return Boolean;

   function Loc_Label_List_Valid
     (Id : W_Loc_Label_Unchecked_List)
     return Boolean;

   function Identifier_OId_Valid
     (Id : W_Identifier_Unchecked_OId)
     return Boolean;

   function Identifier_OList_Valid
     (Id : W_Identifier_Unchecked_OList)
     return Boolean;

   function Identifier_Id_Valid
     (Id : W_Identifier_Unchecked_Id)
     return Boolean;

   function Identifier_List_Valid
     (Id : W_Identifier_Unchecked_List)
     return Boolean;

   function Tagged_OId_Valid
     (Id : W_Tagged_Unchecked_OId)
     return Boolean;

   function Tagged_OList_Valid
     (Id : W_Tagged_Unchecked_OList)
     return Boolean;

   function Tagged_Id_Valid
     (Id : W_Tagged_Unchecked_Id)
     return Boolean;

   function Tagged_List_Valid
     (Id : W_Tagged_Unchecked_List)
     return Boolean;

   function Call_OId_Valid
     (Id : W_Call_Unchecked_OId)
     return Boolean;

   function Call_OList_Valid
     (Id : W_Call_Unchecked_OList)
     return Boolean;

   function Call_Id_Valid
     (Id : W_Call_Unchecked_Id)
     return Boolean;

   function Call_List_Valid
     (Id : W_Call_Unchecked_List)
     return Boolean;

   function Literal_OId_Valid
     (Id : W_Literal_Unchecked_OId)
     return Boolean;

   function Literal_OList_Valid
     (Id : W_Literal_Unchecked_OList)
     return Boolean;

   function Literal_Id_Valid
     (Id : W_Literal_Unchecked_Id)
     return Boolean;

   function Literal_List_Valid
     (Id : W_Literal_Unchecked_List)
     return Boolean;

   function Binding_OId_Valid
     (Id : W_Binding_Unchecked_OId)
     return Boolean;

   function Binding_OList_Valid
     (Id : W_Binding_Unchecked_OList)
     return Boolean;

   function Binding_Id_Valid
     (Id : W_Binding_Unchecked_Id)
     return Boolean;

   function Binding_List_Valid
     (Id : W_Binding_Unchecked_List)
     return Boolean;

   function Elsif_OId_Valid
     (Id : W_Elsif_Unchecked_OId)
     return Boolean;

   function Elsif_OList_Valid
     (Id : W_Elsif_Unchecked_OList)
     return Boolean;

   function Elsif_Id_Valid
     (Id : W_Elsif_Unchecked_Id)
     return Boolean;

   function Elsif_List_Valid
     (Id : W_Elsif_Unchecked_List)
     return Boolean;

   function Epsilon_OId_Valid
     (Id : W_Epsilon_Unchecked_OId)
     return Boolean;

   function Epsilon_OList_Valid
     (Id : W_Epsilon_Unchecked_OList)
     return Boolean;

   function Epsilon_Id_Valid
     (Id : W_Epsilon_Unchecked_Id)
     return Boolean;

   function Epsilon_List_Valid
     (Id : W_Epsilon_Unchecked_List)
     return Boolean;

   function Conditional_OId_Valid
     (Id : W_Conditional_Unchecked_OId)
     return Boolean;

   function Conditional_OList_Valid
     (Id : W_Conditional_Unchecked_OList)
     return Boolean;

   function Conditional_Id_Valid
     (Id : W_Conditional_Unchecked_Id)
     return Boolean;

   function Conditional_List_Valid
     (Id : W_Conditional_Unchecked_List)
     return Boolean;

   function Integer_Constant_OId_Valid
     (Id : W_Integer_Constant_Unchecked_OId)
     return Boolean;

   function Integer_Constant_OList_Valid
     (Id : W_Integer_Constant_Unchecked_OList)
     return Boolean;

   function Integer_Constant_Id_Valid
     (Id : W_Integer_Constant_Unchecked_Id)
     return Boolean;

   function Integer_Constant_List_Valid
     (Id : W_Integer_Constant_Unchecked_List)
     return Boolean;

   function Range_Constant_OId_Valid
     (Id : W_Range_Constant_Unchecked_OId)
     return Boolean;

   function Range_Constant_OList_Valid
     (Id : W_Range_Constant_Unchecked_OList)
     return Boolean;

   function Range_Constant_Id_Valid
     (Id : W_Range_Constant_Unchecked_Id)
     return Boolean;

   function Range_Constant_List_Valid
     (Id : W_Range_Constant_Unchecked_List)
     return Boolean;

   function Modular_Constant_OId_Valid
     (Id : W_Modular_Constant_Unchecked_OId)
     return Boolean;

   function Modular_Constant_OList_Valid
     (Id : W_Modular_Constant_Unchecked_OList)
     return Boolean;

   function Modular_Constant_Id_Valid
     (Id : W_Modular_Constant_Unchecked_Id)
     return Boolean;

   function Modular_Constant_List_Valid
     (Id : W_Modular_Constant_Unchecked_List)
     return Boolean;

   function Fixed_Constant_OId_Valid
     (Id : W_Fixed_Constant_Unchecked_OId)
     return Boolean;

   function Fixed_Constant_OList_Valid
     (Id : W_Fixed_Constant_Unchecked_OList)
     return Boolean;

   function Fixed_Constant_Id_Valid
     (Id : W_Fixed_Constant_Unchecked_Id)
     return Boolean;

   function Fixed_Constant_List_Valid
     (Id : W_Fixed_Constant_Unchecked_List)
     return Boolean;

   function Real_Constant_OId_Valid
     (Id : W_Real_Constant_Unchecked_OId)
     return Boolean;

   function Real_Constant_OList_Valid
     (Id : W_Real_Constant_Unchecked_OList)
     return Boolean;

   function Real_Constant_Id_Valid
     (Id : W_Real_Constant_Unchecked_Id)
     return Boolean;

   function Real_Constant_List_Valid
     (Id : W_Real_Constant_Unchecked_List)
     return Boolean;

   function Float_Constant_OId_Valid
     (Id : W_Float_Constant_Unchecked_OId)
     return Boolean;

   function Float_Constant_OList_Valid
     (Id : W_Float_Constant_Unchecked_OList)
     return Boolean;

   function Float_Constant_Id_Valid
     (Id : W_Float_Constant_Unchecked_Id)
     return Boolean;

   function Float_Constant_List_Valid
     (Id : W_Float_Constant_Unchecked_List)
     return Boolean;

   function Comment_OId_Valid
     (Id : W_Comment_Unchecked_OId)
     return Boolean;

   function Comment_OList_Valid
     (Id : W_Comment_Unchecked_OList)
     return Boolean;

   function Comment_Id_Valid
     (Id : W_Comment_Unchecked_Id)
     return Boolean;

   function Comment_List_Valid
     (Id : W_Comment_Unchecked_List)
     return Boolean;

   function Deref_OId_Valid
     (Id : W_Deref_Unchecked_OId)
     return Boolean;

   function Deref_OList_Valid
     (Id : W_Deref_Unchecked_OList)
     return Boolean;

   function Deref_Id_Valid
     (Id : W_Deref_Unchecked_Id)
     return Boolean;

   function Deref_List_Valid
     (Id : W_Deref_Unchecked_List)
     return Boolean;

   function Record_Access_OId_Valid
     (Id : W_Record_Access_Unchecked_OId)
     return Boolean;

   function Record_Access_OList_Valid
     (Id : W_Record_Access_Unchecked_OList)
     return Boolean;

   function Record_Access_Id_Valid
     (Id : W_Record_Access_Unchecked_Id)
     return Boolean;

   function Record_Access_List_Valid
     (Id : W_Record_Access_Unchecked_List)
     return Boolean;

   function Record_Update_OId_Valid
     (Id : W_Record_Update_Unchecked_OId)
     return Boolean;

   function Record_Update_OList_Valid
     (Id : W_Record_Update_Unchecked_OList)
     return Boolean;

   function Record_Update_Id_Valid
     (Id : W_Record_Update_Unchecked_Id)
     return Boolean;

   function Record_Update_List_Valid
     (Id : W_Record_Update_Unchecked_List)
     return Boolean;

   function Record_Aggregate_OId_Valid
     (Id : W_Record_Aggregate_Unchecked_OId)
     return Boolean;

   function Record_Aggregate_OList_Valid
     (Id : W_Record_Aggregate_Unchecked_OList)
     return Boolean;

   function Record_Aggregate_Id_Valid
     (Id : W_Record_Aggregate_Unchecked_Id)
     return Boolean;

   function Record_Aggregate_List_Valid
     (Id : W_Record_Aggregate_Unchecked_List)
     return Boolean;

   function Any_Expr_OId_Valid
     (Id : W_Any_Expr_Unchecked_OId)
     return Boolean;

   function Any_Expr_OList_Valid
     (Id : W_Any_Expr_Unchecked_OList)
     return Boolean;

   function Any_Expr_Id_Valid
     (Id : W_Any_Expr_Unchecked_Id)
     return Boolean;

   function Any_Expr_List_Valid
     (Id : W_Any_Expr_Unchecked_List)
     return Boolean;

   function Assignment_OId_Valid
     (Id : W_Assignment_Unchecked_OId)
     return Boolean;

   function Assignment_OList_Valid
     (Id : W_Assignment_Unchecked_OList)
     return Boolean;

   function Assignment_Id_Valid
     (Id : W_Assignment_Unchecked_Id)
     return Boolean;

   function Assignment_List_Valid
     (Id : W_Assignment_Unchecked_List)
     return Boolean;

   function Binding_Ref_OId_Valid
     (Id : W_Binding_Ref_Unchecked_OId)
     return Boolean;

   function Binding_Ref_OList_Valid
     (Id : W_Binding_Ref_Unchecked_OList)
     return Boolean;

   function Binding_Ref_Id_Valid
     (Id : W_Binding_Ref_Unchecked_Id)
     return Boolean;

   function Binding_Ref_List_Valid
     (Id : W_Binding_Ref_Unchecked_List)
     return Boolean;

   function Loop_OId_Valid
     (Id : W_Loop_Unchecked_OId)
     return Boolean;

   function Loop_OList_Valid
     (Id : W_Loop_Unchecked_OList)
     return Boolean;

   function Loop_Id_Valid
     (Id : W_Loop_Unchecked_Id)
     return Boolean;

   function Loop_List_Valid
     (Id : W_Loop_Unchecked_List)
     return Boolean;

   function Statement_Sequence_OId_Valid
     (Id : W_Statement_Sequence_Unchecked_OId)
     return Boolean;

   function Statement_Sequence_OList_Valid
     (Id : W_Statement_Sequence_Unchecked_OList)
     return Boolean;

   function Statement_Sequence_Id_Valid
     (Id : W_Statement_Sequence_Unchecked_Id)
     return Boolean;

   function Statement_Sequence_List_Valid
     (Id : W_Statement_Sequence_Unchecked_List)
     return Boolean;

   function Abstract_Expr_OId_Valid
     (Id : W_Abstract_Expr_Unchecked_OId)
     return Boolean;

   function Abstract_Expr_OList_Valid
     (Id : W_Abstract_Expr_Unchecked_OList)
     return Boolean;

   function Abstract_Expr_Id_Valid
     (Id : W_Abstract_Expr_Unchecked_Id)
     return Boolean;

   function Abstract_Expr_List_Valid
     (Id : W_Abstract_Expr_Unchecked_List)
     return Boolean;

   function Assert_OId_Valid
     (Id : W_Assert_Unchecked_OId)
     return Boolean;

   function Assert_OList_Valid
     (Id : W_Assert_Unchecked_OList)
     return Boolean;

   function Assert_Id_Valid
     (Id : W_Assert_Unchecked_Id)
     return Boolean;

   function Assert_List_Valid
     (Id : W_Assert_Unchecked_List)
     return Boolean;

   function Raise_OId_Valid
     (Id : W_Raise_Unchecked_OId)
     return Boolean;

   function Raise_OList_Valid
     (Id : W_Raise_Unchecked_OList)
     return Boolean;

   function Raise_Id_Valid
     (Id : W_Raise_Unchecked_Id)
     return Boolean;

   function Raise_List_Valid
     (Id : W_Raise_Unchecked_List)
     return Boolean;

   function Try_Block_OId_Valid
     (Id : W_Try_Block_Unchecked_OId)
     return Boolean;

   function Try_Block_OList_Valid
     (Id : W_Try_Block_Unchecked_OList)
     return Boolean;

   function Try_Block_Id_Valid
     (Id : W_Try_Block_Unchecked_Id)
     return Boolean;

   function Try_Block_List_Valid
     (Id : W_Try_Block_Unchecked_List)
     return Boolean;

   function Function_Decl_OId_Valid
     (Id : W_Function_Decl_Unchecked_OId)
     return Boolean;

   function Function_Decl_OList_Valid
     (Id : W_Function_Decl_Unchecked_OList)
     return Boolean;

   function Function_Decl_Id_Valid
     (Id : W_Function_Decl_Unchecked_Id)
     return Boolean;

   function Function_Decl_List_Valid
     (Id : W_Function_Decl_Unchecked_List)
     return Boolean;

   function Axiom_OId_Valid
     (Id : W_Axiom_Unchecked_OId)
     return Boolean;

   function Axiom_OList_Valid
     (Id : W_Axiom_Unchecked_OList)
     return Boolean;

   function Axiom_Id_Valid
     (Id : W_Axiom_Unchecked_Id)
     return Boolean;

   function Axiom_List_Valid
     (Id : W_Axiom_Unchecked_List)
     return Boolean;

   function Goal_OId_Valid
     (Id : W_Goal_Unchecked_OId)
     return Boolean;

   function Goal_OList_Valid
     (Id : W_Goal_Unchecked_OList)
     return Boolean;

   function Goal_Id_Valid
     (Id : W_Goal_Unchecked_Id)
     return Boolean;

   function Goal_List_Valid
     (Id : W_Goal_Unchecked_List)
     return Boolean;

   function Type_Decl_OId_Valid
     (Id : W_Type_Decl_Unchecked_OId)
     return Boolean;

   function Type_Decl_OList_Valid
     (Id : W_Type_Decl_Unchecked_OList)
     return Boolean;

   function Type_Decl_Id_Valid
     (Id : W_Type_Decl_Unchecked_Id)
     return Boolean;

   function Type_Decl_List_Valid
     (Id : W_Type_Decl_Unchecked_List)
     return Boolean;

   function Global_Ref_Declaration_OId_Valid
     (Id : W_Global_Ref_Declaration_Unchecked_OId)
     return Boolean;

   function Global_Ref_Declaration_OList_Valid
     (Id : W_Global_Ref_Declaration_Unchecked_OList)
     return Boolean;

   function Global_Ref_Declaration_Id_Valid
     (Id : W_Global_Ref_Declaration_Unchecked_Id)
     return Boolean;

   function Global_Ref_Declaration_List_Valid
     (Id : W_Global_Ref_Declaration_Unchecked_List)
     return Boolean;

   function Namespace_Declaration_OId_Valid
     (Id : W_Namespace_Declaration_Unchecked_OId)
     return Boolean;

   function Namespace_Declaration_OList_Valid
     (Id : W_Namespace_Declaration_Unchecked_OList)
     return Boolean;

   function Namespace_Declaration_Id_Valid
     (Id : W_Namespace_Declaration_Unchecked_Id)
     return Boolean;

   function Namespace_Declaration_List_Valid
     (Id : W_Namespace_Declaration_Unchecked_List)
     return Boolean;

   function Exception_Declaration_OId_Valid
     (Id : W_Exception_Declaration_Unchecked_OId)
     return Boolean;

   function Exception_Declaration_OList_Valid
     (Id : W_Exception_Declaration_Unchecked_OList)
     return Boolean;

   function Exception_Declaration_Id_Valid
     (Id : W_Exception_Declaration_Unchecked_Id)
     return Boolean;

   function Exception_Declaration_List_Valid
     (Id : W_Exception_Declaration_Unchecked_List)
     return Boolean;

   function Meta_Declaration_OId_Valid
     (Id : W_Meta_Declaration_Unchecked_OId)
     return Boolean;

   function Meta_Declaration_OList_Valid
     (Id : W_Meta_Declaration_Unchecked_OList)
     return Boolean;

   function Meta_Declaration_Id_Valid
     (Id : W_Meta_Declaration_Unchecked_Id)
     return Boolean;

   function Meta_Declaration_List_Valid
     (Id : W_Meta_Declaration_Unchecked_List)
     return Boolean;

   function Clone_Declaration_OId_Valid
     (Id : W_Clone_Declaration_Unchecked_OId)
     return Boolean;

   function Clone_Declaration_OList_Valid
     (Id : W_Clone_Declaration_Unchecked_OList)
     return Boolean;

   function Clone_Declaration_Id_Valid
     (Id : W_Clone_Declaration_Unchecked_Id)
     return Boolean;

   function Clone_Declaration_List_Valid
     (Id : W_Clone_Declaration_Unchecked_List)
     return Boolean;

   function Clone_Substitution_OId_Valid
     (Id : W_Clone_Substitution_Unchecked_OId)
     return Boolean;

   function Clone_Substitution_OList_Valid
     (Id : W_Clone_Substitution_Unchecked_OList)
     return Boolean;

   function Clone_Substitution_Id_Valid
     (Id : W_Clone_Substitution_Unchecked_Id)
     return Boolean;

   function Clone_Substitution_List_Valid
     (Id : W_Clone_Substitution_Unchecked_List)
     return Boolean;

   function Include_Declaration_OId_Valid
     (Id : W_Include_Declaration_Unchecked_OId)
     return Boolean;

   function Include_Declaration_OList_Valid
     (Id : W_Include_Declaration_Unchecked_OList)
     return Boolean;

   function Include_Declaration_Id_Valid
     (Id : W_Include_Declaration_Unchecked_Id)
     return Boolean;

   function Include_Declaration_List_Valid
     (Id : W_Include_Declaration_Unchecked_List)
     return Boolean;

   function Theory_Declaration_OId_Valid
     (Id : W_Theory_Declaration_Unchecked_OId)
     return Boolean;

   function Theory_Declaration_OList_Valid
     (Id : W_Theory_Declaration_Unchecked_OList)
     return Boolean;

   function Theory_Declaration_Id_Valid
     (Id : W_Theory_Declaration_Unchecked_Id)
     return Boolean;

   function Theory_Declaration_List_Valid
     (Id : W_Theory_Declaration_Unchecked_List)
     return Boolean;

   function Module_OId_Valid
     (Id : W_Module_Unchecked_OId)
     return Boolean;

   function Module_OList_Valid
     (Id : W_Module_Unchecked_OList)
     return Boolean;

   function Module_Id_Valid
     (Id : W_Module_Unchecked_Id)
     return Boolean;

   function Module_List_Valid
     (Id : W_Module_Unchecked_List)
     return Boolean;

   function Expr_OId_Valid
     (Id : W_Expr_Unchecked_OId)
     return Boolean;

   function Expr_OList_Valid
     (Id : W_Expr_Unchecked_OList)
     return Boolean;

   function Expr_Id_Valid
     (Id : W_Expr_Unchecked_Id)
     return Boolean;

   function Expr_List_Valid
     (Id : W_Expr_Unchecked_List)
     return Boolean;

   function Pred_OId_Valid
     (Id : W_Pred_Unchecked_OId)
     return Boolean;

   function Pred_OList_Valid
     (Id : W_Pred_Unchecked_OList)
     return Boolean;

   function Pred_Id_Valid
     (Id : W_Pred_Unchecked_Id)
     return Boolean;

   function Pred_List_Valid
     (Id : W_Pred_Unchecked_List)
     return Boolean;

   function Term_OId_Valid
     (Id : W_Term_Unchecked_OId)
     return Boolean;

   function Term_OList_Valid
     (Id : W_Term_Unchecked_OList)
     return Boolean;

   function Term_Id_Valid
     (Id : W_Term_Unchecked_Id)
     return Boolean;

   function Term_List_Valid
     (Id : W_Term_Unchecked_List)
     return Boolean;

   function Prog_OId_Valid
     (Id : W_Prog_Unchecked_OId)
     return Boolean;

   function Prog_OList_Valid
     (Id : W_Prog_Unchecked_OList)
     return Boolean;

   function Prog_Id_Valid
     (Id : W_Prog_Unchecked_Id)
     return Boolean;

   function Prog_List_Valid
     (Id : W_Prog_Unchecked_List)
     return Boolean;

   function Type_Definition_OId_Valid
     (Id : W_Type_Definition_Unchecked_OId)
     return Boolean;

   function Type_Definition_OList_Valid
     (Id : W_Type_Definition_Unchecked_OList)
     return Boolean;

   function Type_Definition_Id_Valid
     (Id : W_Type_Definition_Unchecked_Id)
     return Boolean;

   function Type_Definition_List_Valid
     (Id : W_Type_Definition_Unchecked_List)
     return Boolean;

   function Declaration_OId_Valid
     (Id : W_Declaration_Unchecked_OId)
     return Boolean;

   function Declaration_OList_Valid
     (Id : W_Declaration_Unchecked_OList)
     return Boolean;

   function Declaration_Id_Valid
     (Id : W_Declaration_Unchecked_Id)
     return Boolean;

   function Declaration_List_Valid
     (Id : W_Declaration_Unchecked_List)
     return Boolean;

   function Any_Node_OId_Valid
     (Id : W_Any_Node_Unchecked_OId)
     return Boolean;

   function Any_Node_OList_Valid
     (Id : W_Any_Node_Unchecked_OList)
     return Boolean;

   function Any_Node_Id_Valid
     (Id : W_Any_Node_Unchecked_Id)
     return Boolean;

   function Any_Node_List_Valid
     (Id : W_Any_Node_Unchecked_List)
     return Boolean;

private

   function Id_Cache_Valid (Id : Why_Node_Id) return Boolean;

   function OId_Cache_Valid (Id : Why_Node_Id) return Boolean;

   function List_Cache_Valid (Id : Why_Node_List) return Boolean;

   function OList_Cache_Valid (Id : Why_Node_List) return Boolean;

   function Unused_At_Start_OId_Children_Valid
     (Id : W_Unused_At_Start_Unchecked_OId)
     return Boolean;

   function Unused_At_Start_OList_Children_Valid
     (Id : W_Unused_At_Start_Unchecked_OList)
     return Boolean;

   function Unused_At_Start_Id_Children_Valid
     (Id : W_Unused_At_Start_Unchecked_Id)
     return Boolean;

   function Unused_At_Start_List_Children_Valid
     (Id : W_Unused_At_Start_Unchecked_List)
     return Boolean;

   function Type_OId_Children_Valid
     (Id : W_Type_Unchecked_OId)
     return Boolean;

   function Type_OList_Children_Valid
     (Id : W_Type_Unchecked_OList)
     return Boolean;

   function Type_Id_Children_Valid
     (Id : W_Type_Unchecked_Id)
     return Boolean;

   function Type_List_Children_Valid
     (Id : W_Type_Unchecked_List)
     return Boolean;

   function Name_OId_Children_Valid
     (Id : W_Name_Unchecked_OId)
     return Boolean;

   function Name_OList_Children_Valid
     (Id : W_Name_Unchecked_OList)
     return Boolean;

   function Name_Id_Children_Valid
     (Id : W_Name_Unchecked_Id)
     return Boolean;

   function Name_List_Children_Valid
     (Id : W_Name_Unchecked_List)
     return Boolean;

   function Effects_OId_Children_Valid
     (Id : W_Effects_Unchecked_OId)
     return Boolean;

   function Effects_OList_Children_Valid
     (Id : W_Effects_Unchecked_OList)
     return Boolean;

   function Effects_Id_Children_Valid
     (Id : W_Effects_Unchecked_Id)
     return Boolean;

   function Effects_List_Children_Valid
     (Id : W_Effects_Unchecked_List)
     return Boolean;

   function Raise_Effect_OId_Children_Valid
     (Id : W_Raise_Effect_Unchecked_OId)
     return Boolean;

   function Raise_Effect_OList_Children_Valid
     (Id : W_Raise_Effect_Unchecked_OList)
     return Boolean;

   function Raise_Effect_Id_Children_Valid
     (Id : W_Raise_Effect_Unchecked_Id)
     return Boolean;

   function Raise_Effect_List_Children_Valid
     (Id : W_Raise_Effect_Unchecked_List)
     return Boolean;

   function Binder_OId_Children_Valid
     (Id : W_Binder_Unchecked_OId)
     return Boolean;

   function Binder_OList_Children_Valid
     (Id : W_Binder_Unchecked_OList)
     return Boolean;

   function Binder_Id_Children_Valid
     (Id : W_Binder_Unchecked_Id)
     return Boolean;

   function Binder_List_Children_Valid
     (Id : W_Binder_Unchecked_List)
     return Boolean;

   function Transparent_Type_Definition_OId_Children_Valid
     (Id : W_Transparent_Type_Definition_Unchecked_OId)
     return Boolean;

   function Transparent_Type_Definition_OList_Children_Valid
     (Id : W_Transparent_Type_Definition_Unchecked_OList)
     return Boolean;

   function Transparent_Type_Definition_Id_Children_Valid
     (Id : W_Transparent_Type_Definition_Unchecked_Id)
     return Boolean;

   function Transparent_Type_Definition_List_Children_Valid
     (Id : W_Transparent_Type_Definition_Unchecked_List)
     return Boolean;

   function Record_Binder_OId_Children_Valid
     (Id : W_Record_Binder_Unchecked_OId)
     return Boolean;

   function Record_Binder_OList_Children_Valid
     (Id : W_Record_Binder_Unchecked_OList)
     return Boolean;

   function Record_Binder_Id_Children_Valid
     (Id : W_Record_Binder_Unchecked_Id)
     return Boolean;

   function Record_Binder_List_Children_Valid
     (Id : W_Record_Binder_Unchecked_List)
     return Boolean;

   function Record_Definition_OId_Children_Valid
     (Id : W_Record_Definition_Unchecked_OId)
     return Boolean;

   function Record_Definition_OList_Children_Valid
     (Id : W_Record_Definition_Unchecked_OList)
     return Boolean;

   function Record_Definition_Id_Children_Valid
     (Id : W_Record_Definition_Unchecked_Id)
     return Boolean;

   function Record_Definition_List_Children_Valid
     (Id : W_Record_Definition_Unchecked_List)
     return Boolean;

   function Range_Type_Definition_OId_Children_Valid
     (Id : W_Range_Type_Definition_Unchecked_OId)
     return Boolean;

   function Range_Type_Definition_OList_Children_Valid
     (Id : W_Range_Type_Definition_Unchecked_OList)
     return Boolean;

   function Range_Type_Definition_Id_Children_Valid
     (Id : W_Range_Type_Definition_Unchecked_Id)
     return Boolean;

   function Range_Type_Definition_List_Children_Valid
     (Id : W_Range_Type_Definition_Unchecked_List)
     return Boolean;

   function Triggers_OId_Children_Valid
     (Id : W_Triggers_Unchecked_OId)
     return Boolean;

   function Triggers_OList_Children_Valid
     (Id : W_Triggers_Unchecked_OList)
     return Boolean;

   function Triggers_Id_Children_Valid
     (Id : W_Triggers_Unchecked_Id)
     return Boolean;

   function Triggers_List_Children_Valid
     (Id : W_Triggers_Unchecked_List)
     return Boolean;

   function Trigger_OId_Children_Valid
     (Id : W_Trigger_Unchecked_OId)
     return Boolean;

   function Trigger_OList_Children_Valid
     (Id : W_Trigger_Unchecked_OList)
     return Boolean;

   function Trigger_Id_Children_Valid
     (Id : W_Trigger_Unchecked_Id)
     return Boolean;

   function Trigger_List_Children_Valid
     (Id : W_Trigger_Unchecked_List)
     return Boolean;

   function Axiom_Dep_OId_Children_Valid
     (Id : W_Axiom_Dep_Unchecked_OId)
     return Boolean;

   function Axiom_Dep_OList_Children_Valid
     (Id : W_Axiom_Dep_Unchecked_OList)
     return Boolean;

   function Axiom_Dep_Id_Children_Valid
     (Id : W_Axiom_Dep_Unchecked_Id)
     return Boolean;

   function Axiom_Dep_List_Children_Valid
     (Id : W_Axiom_Dep_Unchecked_List)
     return Boolean;

   function Handler_OId_Children_Valid
     (Id : W_Handler_Unchecked_OId)
     return Boolean;

   function Handler_OList_Children_Valid
     (Id : W_Handler_Unchecked_OList)
     return Boolean;

   function Handler_Id_Children_Valid
     (Id : W_Handler_Unchecked_Id)
     return Boolean;

   function Handler_List_Children_Valid
     (Id : W_Handler_Unchecked_List)
     return Boolean;

   function Field_Association_OId_Children_Valid
     (Id : W_Field_Association_Unchecked_OId)
     return Boolean;

   function Field_Association_OList_Children_Valid
     (Id : W_Field_Association_Unchecked_OList)
     return Boolean;

   function Field_Association_Id_Children_Valid
     (Id : W_Field_Association_Unchecked_Id)
     return Boolean;

   function Field_Association_List_Children_Valid
     (Id : W_Field_Association_Unchecked_List)
     return Boolean;

   function Variant_OId_Children_Valid
     (Id : W_Variant_Unchecked_OId)
     return Boolean;

   function Variant_OList_Children_Valid
     (Id : W_Variant_Unchecked_OList)
     return Boolean;

   function Variant_Id_Children_Valid
     (Id : W_Variant_Unchecked_Id)
     return Boolean;

   function Variant_List_Children_Valid
     (Id : W_Variant_Unchecked_List)
     return Boolean;

   function Variants_OId_Children_Valid
     (Id : W_Variants_Unchecked_OId)
     return Boolean;

   function Variants_OList_Children_Valid
     (Id : W_Variants_Unchecked_OList)
     return Boolean;

   function Variants_Id_Children_Valid
     (Id : W_Variants_Unchecked_Id)
     return Boolean;

   function Variants_List_Children_Valid
     (Id : W_Variants_Unchecked_List)
     return Boolean;

   function Universal_Quantif_OId_Children_Valid
     (Id : W_Universal_Quantif_Unchecked_OId)
     return Boolean;

   function Universal_Quantif_OList_Children_Valid
     (Id : W_Universal_Quantif_Unchecked_OList)
     return Boolean;

   function Universal_Quantif_Id_Children_Valid
     (Id : W_Universal_Quantif_Unchecked_Id)
     return Boolean;

   function Universal_Quantif_List_Children_Valid
     (Id : W_Universal_Quantif_Unchecked_List)
     return Boolean;

   function Existential_Quantif_OId_Children_Valid
     (Id : W_Existential_Quantif_Unchecked_OId)
     return Boolean;

   function Existential_Quantif_OList_Children_Valid
     (Id : W_Existential_Quantif_Unchecked_OList)
     return Boolean;

   function Existential_Quantif_Id_Children_Valid
     (Id : W_Existential_Quantif_Unchecked_Id)
     return Boolean;

   function Existential_Quantif_List_Children_Valid
     (Id : W_Existential_Quantif_Unchecked_List)
     return Boolean;

   function Not_OId_Children_Valid
     (Id : W_Not_Unchecked_OId)
     return Boolean;

   function Not_OList_Children_Valid
     (Id : W_Not_Unchecked_OList)
     return Boolean;

   function Not_Id_Children_Valid
     (Id : W_Not_Unchecked_Id)
     return Boolean;

   function Not_List_Children_Valid
     (Id : W_Not_Unchecked_List)
     return Boolean;

   function Connection_OId_Children_Valid
     (Id : W_Connection_Unchecked_OId)
     return Boolean;

   function Connection_OList_Children_Valid
     (Id : W_Connection_Unchecked_OList)
     return Boolean;

   function Connection_Id_Children_Valid
     (Id : W_Connection_Unchecked_Id)
     return Boolean;

   function Connection_List_Children_Valid
     (Id : W_Connection_Unchecked_List)
     return Boolean;

   function Label_OId_Children_Valid
     (Id : W_Label_Unchecked_OId)
     return Boolean;

   function Label_OList_Children_Valid
     (Id : W_Label_Unchecked_OList)
     return Boolean;

   function Label_Id_Children_Valid
     (Id : W_Label_Unchecked_Id)
     return Boolean;

   function Label_List_Children_Valid
     (Id : W_Label_Unchecked_List)
     return Boolean;

   function Loc_Label_OId_Children_Valid
     (Id : W_Loc_Label_Unchecked_OId)
     return Boolean;

   function Loc_Label_OList_Children_Valid
     (Id : W_Loc_Label_Unchecked_OList)
     return Boolean;

   function Loc_Label_Id_Children_Valid
     (Id : W_Loc_Label_Unchecked_Id)
     return Boolean;

   function Loc_Label_List_Children_Valid
     (Id : W_Loc_Label_Unchecked_List)
     return Boolean;

   function Identifier_OId_Children_Valid
     (Id : W_Identifier_Unchecked_OId)
     return Boolean;

   function Identifier_OList_Children_Valid
     (Id : W_Identifier_Unchecked_OList)
     return Boolean;

   function Identifier_Id_Children_Valid
     (Id : W_Identifier_Unchecked_Id)
     return Boolean;

   function Identifier_List_Children_Valid
     (Id : W_Identifier_Unchecked_List)
     return Boolean;

   function Tagged_OId_Children_Valid
     (Id : W_Tagged_Unchecked_OId)
     return Boolean;

   function Tagged_OList_Children_Valid
     (Id : W_Tagged_Unchecked_OList)
     return Boolean;

   function Tagged_Id_Children_Valid
     (Id : W_Tagged_Unchecked_Id)
     return Boolean;

   function Tagged_List_Children_Valid
     (Id : W_Tagged_Unchecked_List)
     return Boolean;

   function Call_OId_Children_Valid
     (Id : W_Call_Unchecked_OId)
     return Boolean;

   function Call_OList_Children_Valid
     (Id : W_Call_Unchecked_OList)
     return Boolean;

   function Call_Id_Children_Valid
     (Id : W_Call_Unchecked_Id)
     return Boolean;

   function Call_List_Children_Valid
     (Id : W_Call_Unchecked_List)
     return Boolean;

   function Literal_OId_Children_Valid
     (Id : W_Literal_Unchecked_OId)
     return Boolean;

   function Literal_OList_Children_Valid
     (Id : W_Literal_Unchecked_OList)
     return Boolean;

   function Literal_Id_Children_Valid
     (Id : W_Literal_Unchecked_Id)
     return Boolean;

   function Literal_List_Children_Valid
     (Id : W_Literal_Unchecked_List)
     return Boolean;

   function Binding_OId_Children_Valid
     (Id : W_Binding_Unchecked_OId)
     return Boolean;

   function Binding_OList_Children_Valid
     (Id : W_Binding_Unchecked_OList)
     return Boolean;

   function Binding_Id_Children_Valid
     (Id : W_Binding_Unchecked_Id)
     return Boolean;

   function Binding_List_Children_Valid
     (Id : W_Binding_Unchecked_List)
     return Boolean;

   function Elsif_OId_Children_Valid
     (Id : W_Elsif_Unchecked_OId)
     return Boolean;

   function Elsif_OList_Children_Valid
     (Id : W_Elsif_Unchecked_OList)
     return Boolean;

   function Elsif_Id_Children_Valid
     (Id : W_Elsif_Unchecked_Id)
     return Boolean;

   function Elsif_List_Children_Valid
     (Id : W_Elsif_Unchecked_List)
     return Boolean;

   function Epsilon_OId_Children_Valid
     (Id : W_Epsilon_Unchecked_OId)
     return Boolean;

   function Epsilon_OList_Children_Valid
     (Id : W_Epsilon_Unchecked_OList)
     return Boolean;

   function Epsilon_Id_Children_Valid
     (Id : W_Epsilon_Unchecked_Id)
     return Boolean;

   function Epsilon_List_Children_Valid
     (Id : W_Epsilon_Unchecked_List)
     return Boolean;

   function Conditional_OId_Children_Valid
     (Id : W_Conditional_Unchecked_OId)
     return Boolean;

   function Conditional_OList_Children_Valid
     (Id : W_Conditional_Unchecked_OList)
     return Boolean;

   function Conditional_Id_Children_Valid
     (Id : W_Conditional_Unchecked_Id)
     return Boolean;

   function Conditional_List_Children_Valid
     (Id : W_Conditional_Unchecked_List)
     return Boolean;

   function Integer_Constant_OId_Children_Valid
     (Id : W_Integer_Constant_Unchecked_OId)
     return Boolean;

   function Integer_Constant_OList_Children_Valid
     (Id : W_Integer_Constant_Unchecked_OList)
     return Boolean;

   function Integer_Constant_Id_Children_Valid
     (Id : W_Integer_Constant_Unchecked_Id)
     return Boolean;

   function Integer_Constant_List_Children_Valid
     (Id : W_Integer_Constant_Unchecked_List)
     return Boolean;

   function Range_Constant_OId_Children_Valid
     (Id : W_Range_Constant_Unchecked_OId)
     return Boolean;

   function Range_Constant_OList_Children_Valid
     (Id : W_Range_Constant_Unchecked_OList)
     return Boolean;

   function Range_Constant_Id_Children_Valid
     (Id : W_Range_Constant_Unchecked_Id)
     return Boolean;

   function Range_Constant_List_Children_Valid
     (Id : W_Range_Constant_Unchecked_List)
     return Boolean;

   function Modular_Constant_OId_Children_Valid
     (Id : W_Modular_Constant_Unchecked_OId)
     return Boolean;

   function Modular_Constant_OList_Children_Valid
     (Id : W_Modular_Constant_Unchecked_OList)
     return Boolean;

   function Modular_Constant_Id_Children_Valid
     (Id : W_Modular_Constant_Unchecked_Id)
     return Boolean;

   function Modular_Constant_List_Children_Valid
     (Id : W_Modular_Constant_Unchecked_List)
     return Boolean;

   function Fixed_Constant_OId_Children_Valid
     (Id : W_Fixed_Constant_Unchecked_OId)
     return Boolean;

   function Fixed_Constant_OList_Children_Valid
     (Id : W_Fixed_Constant_Unchecked_OList)
     return Boolean;

   function Fixed_Constant_Id_Children_Valid
     (Id : W_Fixed_Constant_Unchecked_Id)
     return Boolean;

   function Fixed_Constant_List_Children_Valid
     (Id : W_Fixed_Constant_Unchecked_List)
     return Boolean;

   function Real_Constant_OId_Children_Valid
     (Id : W_Real_Constant_Unchecked_OId)
     return Boolean;

   function Real_Constant_OList_Children_Valid
     (Id : W_Real_Constant_Unchecked_OList)
     return Boolean;

   function Real_Constant_Id_Children_Valid
     (Id : W_Real_Constant_Unchecked_Id)
     return Boolean;

   function Real_Constant_List_Children_Valid
     (Id : W_Real_Constant_Unchecked_List)
     return Boolean;

   function Float_Constant_OId_Children_Valid
     (Id : W_Float_Constant_Unchecked_OId)
     return Boolean;

   function Float_Constant_OList_Children_Valid
     (Id : W_Float_Constant_Unchecked_OList)
     return Boolean;

   function Float_Constant_Id_Children_Valid
     (Id : W_Float_Constant_Unchecked_Id)
     return Boolean;

   function Float_Constant_List_Children_Valid
     (Id : W_Float_Constant_Unchecked_List)
     return Boolean;

   function Comment_OId_Children_Valid
     (Id : W_Comment_Unchecked_OId)
     return Boolean;

   function Comment_OList_Children_Valid
     (Id : W_Comment_Unchecked_OList)
     return Boolean;

   function Comment_Id_Children_Valid
     (Id : W_Comment_Unchecked_Id)
     return Boolean;

   function Comment_List_Children_Valid
     (Id : W_Comment_Unchecked_List)
     return Boolean;

   function Deref_OId_Children_Valid
     (Id : W_Deref_Unchecked_OId)
     return Boolean;

   function Deref_OList_Children_Valid
     (Id : W_Deref_Unchecked_OList)
     return Boolean;

   function Deref_Id_Children_Valid
     (Id : W_Deref_Unchecked_Id)
     return Boolean;

   function Deref_List_Children_Valid
     (Id : W_Deref_Unchecked_List)
     return Boolean;

   function Record_Access_OId_Children_Valid
     (Id : W_Record_Access_Unchecked_OId)
     return Boolean;

   function Record_Access_OList_Children_Valid
     (Id : W_Record_Access_Unchecked_OList)
     return Boolean;

   function Record_Access_Id_Children_Valid
     (Id : W_Record_Access_Unchecked_Id)
     return Boolean;

   function Record_Access_List_Children_Valid
     (Id : W_Record_Access_Unchecked_List)
     return Boolean;

   function Record_Update_OId_Children_Valid
     (Id : W_Record_Update_Unchecked_OId)
     return Boolean;

   function Record_Update_OList_Children_Valid
     (Id : W_Record_Update_Unchecked_OList)
     return Boolean;

   function Record_Update_Id_Children_Valid
     (Id : W_Record_Update_Unchecked_Id)
     return Boolean;

   function Record_Update_List_Children_Valid
     (Id : W_Record_Update_Unchecked_List)
     return Boolean;

   function Record_Aggregate_OId_Children_Valid
     (Id : W_Record_Aggregate_Unchecked_OId)
     return Boolean;

   function Record_Aggregate_OList_Children_Valid
     (Id : W_Record_Aggregate_Unchecked_OList)
     return Boolean;

   function Record_Aggregate_Id_Children_Valid
     (Id : W_Record_Aggregate_Unchecked_Id)
     return Boolean;

   function Record_Aggregate_List_Children_Valid
     (Id : W_Record_Aggregate_Unchecked_List)
     return Boolean;

   function Any_Expr_OId_Children_Valid
     (Id : W_Any_Expr_Unchecked_OId)
     return Boolean;

   function Any_Expr_OList_Children_Valid
     (Id : W_Any_Expr_Unchecked_OList)
     return Boolean;

   function Any_Expr_Id_Children_Valid
     (Id : W_Any_Expr_Unchecked_Id)
     return Boolean;

   function Any_Expr_List_Children_Valid
     (Id : W_Any_Expr_Unchecked_List)
     return Boolean;

   function Assignment_OId_Children_Valid
     (Id : W_Assignment_Unchecked_OId)
     return Boolean;

   function Assignment_OList_Children_Valid
     (Id : W_Assignment_Unchecked_OList)
     return Boolean;

   function Assignment_Id_Children_Valid
     (Id : W_Assignment_Unchecked_Id)
     return Boolean;

   function Assignment_List_Children_Valid
     (Id : W_Assignment_Unchecked_List)
     return Boolean;

   function Binding_Ref_OId_Children_Valid
     (Id : W_Binding_Ref_Unchecked_OId)
     return Boolean;

   function Binding_Ref_OList_Children_Valid
     (Id : W_Binding_Ref_Unchecked_OList)
     return Boolean;

   function Binding_Ref_Id_Children_Valid
     (Id : W_Binding_Ref_Unchecked_Id)
     return Boolean;

   function Binding_Ref_List_Children_Valid
     (Id : W_Binding_Ref_Unchecked_List)
     return Boolean;

   function Loop_OId_Children_Valid
     (Id : W_Loop_Unchecked_OId)
     return Boolean;

   function Loop_OList_Children_Valid
     (Id : W_Loop_Unchecked_OList)
     return Boolean;

   function Loop_Id_Children_Valid
     (Id : W_Loop_Unchecked_Id)
     return Boolean;

   function Loop_List_Children_Valid
     (Id : W_Loop_Unchecked_List)
     return Boolean;

   function Statement_Sequence_OId_Children_Valid
     (Id : W_Statement_Sequence_Unchecked_OId)
     return Boolean;

   function Statement_Sequence_OList_Children_Valid
     (Id : W_Statement_Sequence_Unchecked_OList)
     return Boolean;

   function Statement_Sequence_Id_Children_Valid
     (Id : W_Statement_Sequence_Unchecked_Id)
     return Boolean;

   function Statement_Sequence_List_Children_Valid
     (Id : W_Statement_Sequence_Unchecked_List)
     return Boolean;

   function Abstract_Expr_OId_Children_Valid
     (Id : W_Abstract_Expr_Unchecked_OId)
     return Boolean;

   function Abstract_Expr_OList_Children_Valid
     (Id : W_Abstract_Expr_Unchecked_OList)
     return Boolean;

   function Abstract_Expr_Id_Children_Valid
     (Id : W_Abstract_Expr_Unchecked_Id)
     return Boolean;

   function Abstract_Expr_List_Children_Valid
     (Id : W_Abstract_Expr_Unchecked_List)
     return Boolean;

   function Assert_OId_Children_Valid
     (Id : W_Assert_Unchecked_OId)
     return Boolean;

   function Assert_OList_Children_Valid
     (Id : W_Assert_Unchecked_OList)
     return Boolean;

   function Assert_Id_Children_Valid
     (Id : W_Assert_Unchecked_Id)
     return Boolean;

   function Assert_List_Children_Valid
     (Id : W_Assert_Unchecked_List)
     return Boolean;

   function Raise_OId_Children_Valid
     (Id : W_Raise_Unchecked_OId)
     return Boolean;

   function Raise_OList_Children_Valid
     (Id : W_Raise_Unchecked_OList)
     return Boolean;

   function Raise_Id_Children_Valid
     (Id : W_Raise_Unchecked_Id)
     return Boolean;

   function Raise_List_Children_Valid
     (Id : W_Raise_Unchecked_List)
     return Boolean;

   function Try_Block_OId_Children_Valid
     (Id : W_Try_Block_Unchecked_OId)
     return Boolean;

   function Try_Block_OList_Children_Valid
     (Id : W_Try_Block_Unchecked_OList)
     return Boolean;

   function Try_Block_Id_Children_Valid
     (Id : W_Try_Block_Unchecked_Id)
     return Boolean;

   function Try_Block_List_Children_Valid
     (Id : W_Try_Block_Unchecked_List)
     return Boolean;

   function Function_Decl_OId_Children_Valid
     (Id : W_Function_Decl_Unchecked_OId)
     return Boolean;

   function Function_Decl_OList_Children_Valid
     (Id : W_Function_Decl_Unchecked_OList)
     return Boolean;

   function Function_Decl_Id_Children_Valid
     (Id : W_Function_Decl_Unchecked_Id)
     return Boolean;

   function Function_Decl_List_Children_Valid
     (Id : W_Function_Decl_Unchecked_List)
     return Boolean;

   function Axiom_OId_Children_Valid
     (Id : W_Axiom_Unchecked_OId)
     return Boolean;

   function Axiom_OList_Children_Valid
     (Id : W_Axiom_Unchecked_OList)
     return Boolean;

   function Axiom_Id_Children_Valid
     (Id : W_Axiom_Unchecked_Id)
     return Boolean;

   function Axiom_List_Children_Valid
     (Id : W_Axiom_Unchecked_List)
     return Boolean;

   function Goal_OId_Children_Valid
     (Id : W_Goal_Unchecked_OId)
     return Boolean;

   function Goal_OList_Children_Valid
     (Id : W_Goal_Unchecked_OList)
     return Boolean;

   function Goal_Id_Children_Valid
     (Id : W_Goal_Unchecked_Id)
     return Boolean;

   function Goal_List_Children_Valid
     (Id : W_Goal_Unchecked_List)
     return Boolean;

   function Type_Decl_OId_Children_Valid
     (Id : W_Type_Decl_Unchecked_OId)
     return Boolean;

   function Type_Decl_OList_Children_Valid
     (Id : W_Type_Decl_Unchecked_OList)
     return Boolean;

   function Type_Decl_Id_Children_Valid
     (Id : W_Type_Decl_Unchecked_Id)
     return Boolean;

   function Type_Decl_List_Children_Valid
     (Id : W_Type_Decl_Unchecked_List)
     return Boolean;

   function Global_Ref_Declaration_OId_Children_Valid
     (Id : W_Global_Ref_Declaration_Unchecked_OId)
     return Boolean;

   function Global_Ref_Declaration_OList_Children_Valid
     (Id : W_Global_Ref_Declaration_Unchecked_OList)
     return Boolean;

   function Global_Ref_Declaration_Id_Children_Valid
     (Id : W_Global_Ref_Declaration_Unchecked_Id)
     return Boolean;

   function Global_Ref_Declaration_List_Children_Valid
     (Id : W_Global_Ref_Declaration_Unchecked_List)
     return Boolean;

   function Namespace_Declaration_OId_Children_Valid
     (Id : W_Namespace_Declaration_Unchecked_OId)
     return Boolean;

   function Namespace_Declaration_OList_Children_Valid
     (Id : W_Namespace_Declaration_Unchecked_OList)
     return Boolean;

   function Namespace_Declaration_Id_Children_Valid
     (Id : W_Namespace_Declaration_Unchecked_Id)
     return Boolean;

   function Namespace_Declaration_List_Children_Valid
     (Id : W_Namespace_Declaration_Unchecked_List)
     return Boolean;

   function Exception_Declaration_OId_Children_Valid
     (Id : W_Exception_Declaration_Unchecked_OId)
     return Boolean;

   function Exception_Declaration_OList_Children_Valid
     (Id : W_Exception_Declaration_Unchecked_OList)
     return Boolean;

   function Exception_Declaration_Id_Children_Valid
     (Id : W_Exception_Declaration_Unchecked_Id)
     return Boolean;

   function Exception_Declaration_List_Children_Valid
     (Id : W_Exception_Declaration_Unchecked_List)
     return Boolean;

   function Meta_Declaration_OId_Children_Valid
     (Id : W_Meta_Declaration_Unchecked_OId)
     return Boolean;

   function Meta_Declaration_OList_Children_Valid
     (Id : W_Meta_Declaration_Unchecked_OList)
     return Boolean;

   function Meta_Declaration_Id_Children_Valid
     (Id : W_Meta_Declaration_Unchecked_Id)
     return Boolean;

   function Meta_Declaration_List_Children_Valid
     (Id : W_Meta_Declaration_Unchecked_List)
     return Boolean;

   function Clone_Declaration_OId_Children_Valid
     (Id : W_Clone_Declaration_Unchecked_OId)
     return Boolean;

   function Clone_Declaration_OList_Children_Valid
     (Id : W_Clone_Declaration_Unchecked_OList)
     return Boolean;

   function Clone_Declaration_Id_Children_Valid
     (Id : W_Clone_Declaration_Unchecked_Id)
     return Boolean;

   function Clone_Declaration_List_Children_Valid
     (Id : W_Clone_Declaration_Unchecked_List)
     return Boolean;

   function Clone_Substitution_OId_Children_Valid
     (Id : W_Clone_Substitution_Unchecked_OId)
     return Boolean;

   function Clone_Substitution_OList_Children_Valid
     (Id : W_Clone_Substitution_Unchecked_OList)
     return Boolean;

   function Clone_Substitution_Id_Children_Valid
     (Id : W_Clone_Substitution_Unchecked_Id)
     return Boolean;

   function Clone_Substitution_List_Children_Valid
     (Id : W_Clone_Substitution_Unchecked_List)
     return Boolean;

   function Include_Declaration_OId_Children_Valid
     (Id : W_Include_Declaration_Unchecked_OId)
     return Boolean;

   function Include_Declaration_OList_Children_Valid
     (Id : W_Include_Declaration_Unchecked_OList)
     return Boolean;

   function Include_Declaration_Id_Children_Valid
     (Id : W_Include_Declaration_Unchecked_Id)
     return Boolean;

   function Include_Declaration_List_Children_Valid
     (Id : W_Include_Declaration_Unchecked_List)
     return Boolean;

   function Theory_Declaration_OId_Children_Valid
     (Id : W_Theory_Declaration_Unchecked_OId)
     return Boolean;

   function Theory_Declaration_OList_Children_Valid
     (Id : W_Theory_Declaration_Unchecked_OList)
     return Boolean;

   function Theory_Declaration_Id_Children_Valid
     (Id : W_Theory_Declaration_Unchecked_Id)
     return Boolean;

   function Theory_Declaration_List_Children_Valid
     (Id : W_Theory_Declaration_Unchecked_List)
     return Boolean;

   function Module_OId_Children_Valid
     (Id : W_Module_Unchecked_OId)
     return Boolean;

   function Module_OList_Children_Valid
     (Id : W_Module_Unchecked_OList)
     return Boolean;

   function Module_Id_Children_Valid
     (Id : W_Module_Unchecked_Id)
     return Boolean;

   function Module_List_Children_Valid
     (Id : W_Module_Unchecked_List)
     return Boolean;

   function Expr_OId_Children_Valid
     (Id : W_Expr_Unchecked_OId)
     return Boolean;

   function Expr_OList_Children_Valid
     (Id : W_Expr_Unchecked_OList)
     return Boolean;

   function Expr_Id_Children_Valid
     (Id : W_Expr_Unchecked_Id)
     return Boolean;

   function Expr_List_Children_Valid
     (Id : W_Expr_Unchecked_List)
     return Boolean;

   function Pred_OId_Children_Valid
     (Id : W_Pred_Unchecked_OId)
     return Boolean;

   function Pred_OList_Children_Valid
     (Id : W_Pred_Unchecked_OList)
     return Boolean;

   function Pred_Id_Children_Valid
     (Id : W_Pred_Unchecked_Id)
     return Boolean;

   function Pred_List_Children_Valid
     (Id : W_Pred_Unchecked_List)
     return Boolean;

   function Term_OId_Children_Valid
     (Id : W_Term_Unchecked_OId)
     return Boolean;

   function Term_OList_Children_Valid
     (Id : W_Term_Unchecked_OList)
     return Boolean;

   function Term_Id_Children_Valid
     (Id : W_Term_Unchecked_Id)
     return Boolean;

   function Term_List_Children_Valid
     (Id : W_Term_Unchecked_List)
     return Boolean;

   function Prog_OId_Children_Valid
     (Id : W_Prog_Unchecked_OId)
     return Boolean;

   function Prog_OList_Children_Valid
     (Id : W_Prog_Unchecked_OList)
     return Boolean;

   function Prog_Id_Children_Valid
     (Id : W_Prog_Unchecked_Id)
     return Boolean;

   function Prog_List_Children_Valid
     (Id : W_Prog_Unchecked_List)
     return Boolean;

   function Type_Definition_OId_Children_Valid
     (Id : W_Type_Definition_Unchecked_OId)
     return Boolean;

   function Type_Definition_OList_Children_Valid
     (Id : W_Type_Definition_Unchecked_OList)
     return Boolean;

   function Type_Definition_Id_Children_Valid
     (Id : W_Type_Definition_Unchecked_Id)
     return Boolean;

   function Type_Definition_List_Children_Valid
     (Id : W_Type_Definition_Unchecked_List)
     return Boolean;

   function Declaration_OId_Children_Valid
     (Id : W_Declaration_Unchecked_OId)
     return Boolean;

   function Declaration_OList_Children_Valid
     (Id : W_Declaration_Unchecked_OList)
     return Boolean;

   function Declaration_Id_Children_Valid
     (Id : W_Declaration_Unchecked_Id)
     return Boolean;

   function Declaration_List_Children_Valid
     (Id : W_Declaration_Unchecked_List)
     return Boolean;

   function Any_Node_OId_Children_Valid
     (Id : W_Any_Node_Unchecked_OId)
     return Boolean;

   function Any_Node_OList_Children_Valid
     (Id : W_Any_Node_Unchecked_OList)
     return Boolean;

   function Any_Node_Id_Children_Valid
     (Id : W_Any_Node_Unchecked_Id)
     return Boolean;

   function Any_Node_List_Children_Valid
     (Id : W_Any_Node_Unchecked_List)
     return Boolean;

   function Unused_At_Start_OId_Valid
     (Id : W_Unused_At_Start_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Unused_At_Start_Id_Valid (Id));

   function Unused_At_Start_OList_Valid
     (Id : W_Unused_At_Start_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Unused_At_Start_List_Valid (Id));

   function Unused_At_Start_Id_Valid
     (Id : W_Unused_At_Start_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Unused_At_Start_Id_Children_Valid (Id));

   function Unused_At_Start_List_Valid
     (Id : W_Unused_At_Start_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Type_OId_Valid
     (Id : W_Type_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Type_Id_Valid (Id));

   function Type_OList_Valid
     (Id : W_Type_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Type_List_Valid (Id));

   function Type_Id_Valid
     (Id : W_Type_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Type_Id_Children_Valid (Id));

   function Type_List_Valid
     (Id : W_Type_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Name_OId_Valid
     (Id : W_Name_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Name_Id_Valid (Id));

   function Name_OList_Valid
     (Id : W_Name_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Name_List_Valid (Id));

   function Name_Id_Valid
     (Id : W_Name_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Name_Id_Children_Valid (Id));

   function Name_List_Valid
     (Id : W_Name_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Effects_OId_Valid
     (Id : W_Effects_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Effects_Id_Valid (Id));

   function Effects_OList_Valid
     (Id : W_Effects_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Effects_List_Valid (Id));

   function Effects_Id_Valid
     (Id : W_Effects_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Effects_Id_Children_Valid (Id));

   function Effects_List_Valid
     (Id : W_Effects_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Raise_Effect_OId_Valid
     (Id : W_Raise_Effect_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Raise_Effect_Id_Valid (Id));

   function Raise_Effect_OList_Valid
     (Id : W_Raise_Effect_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Raise_Effect_List_Valid (Id));

   function Raise_Effect_Id_Valid
     (Id : W_Raise_Effect_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Raise_Effect_Id_Children_Valid (Id));

   function Raise_Effect_List_Valid
     (Id : W_Raise_Effect_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Binder_OId_Valid
     (Id : W_Binder_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Binder_Id_Valid (Id));

   function Binder_OList_Valid
     (Id : W_Binder_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Binder_List_Valid (Id));

   function Binder_Id_Valid
     (Id : W_Binder_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Binder_Id_Children_Valid (Id));

   function Binder_List_Valid
     (Id : W_Binder_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Transparent_Type_Definition_OId_Valid
     (Id : W_Transparent_Type_Definition_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Transparent_Type_Definition_Id_Valid (Id));

   function Transparent_Type_Definition_OList_Valid
     (Id : W_Transparent_Type_Definition_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Transparent_Type_Definition_List_Valid (Id));

   function Transparent_Type_Definition_Id_Valid
     (Id : W_Transparent_Type_Definition_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Transparent_Type_Definition_Id_Children_Valid (Id));

   function Transparent_Type_Definition_List_Valid
     (Id : W_Transparent_Type_Definition_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Record_Binder_OId_Valid
     (Id : W_Record_Binder_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Record_Binder_Id_Valid (Id));

   function Record_Binder_OList_Valid
     (Id : W_Record_Binder_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Record_Binder_List_Valid (Id));

   function Record_Binder_Id_Valid
     (Id : W_Record_Binder_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Record_Binder_Id_Children_Valid (Id));

   function Record_Binder_List_Valid
     (Id : W_Record_Binder_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Record_Definition_OId_Valid
     (Id : W_Record_Definition_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Record_Definition_Id_Valid (Id));

   function Record_Definition_OList_Valid
     (Id : W_Record_Definition_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Record_Definition_List_Valid (Id));

   function Record_Definition_Id_Valid
     (Id : W_Record_Definition_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Record_Definition_Id_Children_Valid (Id));

   function Record_Definition_List_Valid
     (Id : W_Record_Definition_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Range_Type_Definition_OId_Valid
     (Id : W_Range_Type_Definition_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Range_Type_Definition_Id_Valid (Id));

   function Range_Type_Definition_OList_Valid
     (Id : W_Range_Type_Definition_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Range_Type_Definition_List_Valid (Id));

   function Range_Type_Definition_Id_Valid
     (Id : W_Range_Type_Definition_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Range_Type_Definition_Id_Children_Valid (Id));

   function Range_Type_Definition_List_Valid
     (Id : W_Range_Type_Definition_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Triggers_OId_Valid
     (Id : W_Triggers_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Triggers_Id_Valid (Id));

   function Triggers_OList_Valid
     (Id : W_Triggers_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Triggers_List_Valid (Id));

   function Triggers_Id_Valid
     (Id : W_Triggers_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Triggers_Id_Children_Valid (Id));

   function Triggers_List_Valid
     (Id : W_Triggers_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Trigger_OId_Valid
     (Id : W_Trigger_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Trigger_Id_Valid (Id));

   function Trigger_OList_Valid
     (Id : W_Trigger_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Trigger_List_Valid (Id));

   function Trigger_Id_Valid
     (Id : W_Trigger_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Trigger_Id_Children_Valid (Id));

   function Trigger_List_Valid
     (Id : W_Trigger_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Axiom_Dep_OId_Valid
     (Id : W_Axiom_Dep_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Axiom_Dep_Id_Valid (Id));

   function Axiom_Dep_OList_Valid
     (Id : W_Axiom_Dep_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Axiom_Dep_List_Valid (Id));

   function Axiom_Dep_Id_Valid
     (Id : W_Axiom_Dep_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Axiom_Dep_Id_Children_Valid (Id));

   function Axiom_Dep_List_Valid
     (Id : W_Axiom_Dep_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Handler_OId_Valid
     (Id : W_Handler_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Handler_Id_Valid (Id));

   function Handler_OList_Valid
     (Id : W_Handler_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Handler_List_Valid (Id));

   function Handler_Id_Valid
     (Id : W_Handler_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Handler_Id_Children_Valid (Id));

   function Handler_List_Valid
     (Id : W_Handler_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Field_Association_OId_Valid
     (Id : W_Field_Association_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Field_Association_Id_Valid (Id));

   function Field_Association_OList_Valid
     (Id : W_Field_Association_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Field_Association_List_Valid (Id));

   function Field_Association_Id_Valid
     (Id : W_Field_Association_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Field_Association_Id_Children_Valid (Id));

   function Field_Association_List_Valid
     (Id : W_Field_Association_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Variant_OId_Valid
     (Id : W_Variant_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Variant_Id_Valid (Id));

   function Variant_OList_Valid
     (Id : W_Variant_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Variant_List_Valid (Id));

   function Variant_Id_Valid
     (Id : W_Variant_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Variant_Id_Children_Valid (Id));

   function Variant_List_Valid
     (Id : W_Variant_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Variants_OId_Valid
     (Id : W_Variants_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Variants_Id_Valid (Id));

   function Variants_OList_Valid
     (Id : W_Variants_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Variants_List_Valid (Id));

   function Variants_Id_Valid
     (Id : W_Variants_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Variants_Id_Children_Valid (Id));

   function Variants_List_Valid
     (Id : W_Variants_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Universal_Quantif_OId_Valid
     (Id : W_Universal_Quantif_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Universal_Quantif_Id_Valid (Id));

   function Universal_Quantif_OList_Valid
     (Id : W_Universal_Quantif_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Universal_Quantif_List_Valid (Id));

   function Universal_Quantif_Id_Valid
     (Id : W_Universal_Quantif_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Universal_Quantif_Id_Children_Valid (Id));

   function Universal_Quantif_List_Valid
     (Id : W_Universal_Quantif_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Existential_Quantif_OId_Valid
     (Id : W_Existential_Quantif_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Existential_Quantif_Id_Valid (Id));

   function Existential_Quantif_OList_Valid
     (Id : W_Existential_Quantif_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Existential_Quantif_List_Valid (Id));

   function Existential_Quantif_Id_Valid
     (Id : W_Existential_Quantif_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Existential_Quantif_Id_Children_Valid (Id));

   function Existential_Quantif_List_Valid
     (Id : W_Existential_Quantif_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Not_OId_Valid
     (Id : W_Not_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Not_Id_Valid (Id));

   function Not_OList_Valid
     (Id : W_Not_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Not_List_Valid (Id));

   function Not_Id_Valid
     (Id : W_Not_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Not_Id_Children_Valid (Id));

   function Not_List_Valid
     (Id : W_Not_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Connection_OId_Valid
     (Id : W_Connection_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Connection_Id_Valid (Id));

   function Connection_OList_Valid
     (Id : W_Connection_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Connection_List_Valid (Id));

   function Connection_Id_Valid
     (Id : W_Connection_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Connection_Id_Children_Valid (Id));

   function Connection_List_Valid
     (Id : W_Connection_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Label_OId_Valid
     (Id : W_Label_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Label_Id_Valid (Id));

   function Label_OList_Valid
     (Id : W_Label_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Label_List_Valid (Id));

   function Label_Id_Valid
     (Id : W_Label_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Label_Id_Children_Valid (Id));

   function Label_List_Valid
     (Id : W_Label_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Loc_Label_OId_Valid
     (Id : W_Loc_Label_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Loc_Label_Id_Valid (Id));

   function Loc_Label_OList_Valid
     (Id : W_Loc_Label_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Loc_Label_List_Valid (Id));

   function Loc_Label_Id_Valid
     (Id : W_Loc_Label_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Loc_Label_Id_Children_Valid (Id));

   function Loc_Label_List_Valid
     (Id : W_Loc_Label_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Identifier_OId_Valid
     (Id : W_Identifier_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Identifier_Id_Valid (Id));

   function Identifier_OList_Valid
     (Id : W_Identifier_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Identifier_List_Valid (Id));

   function Identifier_Id_Valid
     (Id : W_Identifier_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Identifier_Id_Children_Valid (Id));

   function Identifier_List_Valid
     (Id : W_Identifier_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Tagged_OId_Valid
     (Id : W_Tagged_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Tagged_Id_Valid (Id));

   function Tagged_OList_Valid
     (Id : W_Tagged_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Tagged_List_Valid (Id));

   function Tagged_Id_Valid
     (Id : W_Tagged_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Tagged_Id_Children_Valid (Id));

   function Tagged_List_Valid
     (Id : W_Tagged_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Call_OId_Valid
     (Id : W_Call_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Call_Id_Valid (Id));

   function Call_OList_Valid
     (Id : W_Call_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Call_List_Valid (Id));

   function Call_Id_Valid
     (Id : W_Call_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Call_Id_Children_Valid (Id));

   function Call_List_Valid
     (Id : W_Call_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Literal_OId_Valid
     (Id : W_Literal_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Literal_Id_Valid (Id));

   function Literal_OList_Valid
     (Id : W_Literal_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Literal_List_Valid (Id));

   function Literal_Id_Valid
     (Id : W_Literal_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Literal_Id_Children_Valid (Id));

   function Literal_List_Valid
     (Id : W_Literal_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Binding_OId_Valid
     (Id : W_Binding_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Binding_Id_Valid (Id));

   function Binding_OList_Valid
     (Id : W_Binding_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Binding_List_Valid (Id));

   function Binding_Id_Valid
     (Id : W_Binding_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Binding_Id_Children_Valid (Id));

   function Binding_List_Valid
     (Id : W_Binding_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Elsif_OId_Valid
     (Id : W_Elsif_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Elsif_Id_Valid (Id));

   function Elsif_OList_Valid
     (Id : W_Elsif_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Elsif_List_Valid (Id));

   function Elsif_Id_Valid
     (Id : W_Elsif_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Elsif_Id_Children_Valid (Id));

   function Elsif_List_Valid
     (Id : W_Elsif_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Epsilon_OId_Valid
     (Id : W_Epsilon_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Epsilon_Id_Valid (Id));

   function Epsilon_OList_Valid
     (Id : W_Epsilon_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Epsilon_List_Valid (Id));

   function Epsilon_Id_Valid
     (Id : W_Epsilon_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Epsilon_Id_Children_Valid (Id));

   function Epsilon_List_Valid
     (Id : W_Epsilon_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Conditional_OId_Valid
     (Id : W_Conditional_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Conditional_Id_Valid (Id));

   function Conditional_OList_Valid
     (Id : W_Conditional_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Conditional_List_Valid (Id));

   function Conditional_Id_Valid
     (Id : W_Conditional_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Conditional_Id_Children_Valid (Id));

   function Conditional_List_Valid
     (Id : W_Conditional_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Integer_Constant_OId_Valid
     (Id : W_Integer_Constant_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Integer_Constant_Id_Valid (Id));

   function Integer_Constant_OList_Valid
     (Id : W_Integer_Constant_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Integer_Constant_List_Valid (Id));

   function Integer_Constant_Id_Valid
     (Id : W_Integer_Constant_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Integer_Constant_Id_Children_Valid (Id));

   function Integer_Constant_List_Valid
     (Id : W_Integer_Constant_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Range_Constant_OId_Valid
     (Id : W_Range_Constant_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Range_Constant_Id_Valid (Id));

   function Range_Constant_OList_Valid
     (Id : W_Range_Constant_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Range_Constant_List_Valid (Id));

   function Range_Constant_Id_Valid
     (Id : W_Range_Constant_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Range_Constant_Id_Children_Valid (Id));

   function Range_Constant_List_Valid
     (Id : W_Range_Constant_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Modular_Constant_OId_Valid
     (Id : W_Modular_Constant_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Modular_Constant_Id_Valid (Id));

   function Modular_Constant_OList_Valid
     (Id : W_Modular_Constant_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Modular_Constant_List_Valid (Id));

   function Modular_Constant_Id_Valid
     (Id : W_Modular_Constant_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Modular_Constant_Id_Children_Valid (Id));

   function Modular_Constant_List_Valid
     (Id : W_Modular_Constant_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Fixed_Constant_OId_Valid
     (Id : W_Fixed_Constant_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Fixed_Constant_Id_Valid (Id));

   function Fixed_Constant_OList_Valid
     (Id : W_Fixed_Constant_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Fixed_Constant_List_Valid (Id));

   function Fixed_Constant_Id_Valid
     (Id : W_Fixed_Constant_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Fixed_Constant_Id_Children_Valid (Id));

   function Fixed_Constant_List_Valid
     (Id : W_Fixed_Constant_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Real_Constant_OId_Valid
     (Id : W_Real_Constant_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Real_Constant_Id_Valid (Id));

   function Real_Constant_OList_Valid
     (Id : W_Real_Constant_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Real_Constant_List_Valid (Id));

   function Real_Constant_Id_Valid
     (Id : W_Real_Constant_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Real_Constant_Id_Children_Valid (Id));

   function Real_Constant_List_Valid
     (Id : W_Real_Constant_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Float_Constant_OId_Valid
     (Id : W_Float_Constant_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Float_Constant_Id_Valid (Id));

   function Float_Constant_OList_Valid
     (Id : W_Float_Constant_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Float_Constant_List_Valid (Id));

   function Float_Constant_Id_Valid
     (Id : W_Float_Constant_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Float_Constant_Id_Children_Valid (Id));

   function Float_Constant_List_Valid
     (Id : W_Float_Constant_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Comment_OId_Valid
     (Id : W_Comment_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Comment_Id_Valid (Id));

   function Comment_OList_Valid
     (Id : W_Comment_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Comment_List_Valid (Id));

   function Comment_Id_Valid
     (Id : W_Comment_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Comment_Id_Children_Valid (Id));

   function Comment_List_Valid
     (Id : W_Comment_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Deref_OId_Valid
     (Id : W_Deref_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Deref_Id_Valid (Id));

   function Deref_OList_Valid
     (Id : W_Deref_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Deref_List_Valid (Id));

   function Deref_Id_Valid
     (Id : W_Deref_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Deref_Id_Children_Valid (Id));

   function Deref_List_Valid
     (Id : W_Deref_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Record_Access_OId_Valid
     (Id : W_Record_Access_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Record_Access_Id_Valid (Id));

   function Record_Access_OList_Valid
     (Id : W_Record_Access_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Record_Access_List_Valid (Id));

   function Record_Access_Id_Valid
     (Id : W_Record_Access_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Record_Access_Id_Children_Valid (Id));

   function Record_Access_List_Valid
     (Id : W_Record_Access_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Record_Update_OId_Valid
     (Id : W_Record_Update_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Record_Update_Id_Valid (Id));

   function Record_Update_OList_Valid
     (Id : W_Record_Update_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Record_Update_List_Valid (Id));

   function Record_Update_Id_Valid
     (Id : W_Record_Update_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Record_Update_Id_Children_Valid (Id));

   function Record_Update_List_Valid
     (Id : W_Record_Update_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Record_Aggregate_OId_Valid
     (Id : W_Record_Aggregate_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Record_Aggregate_Id_Valid (Id));

   function Record_Aggregate_OList_Valid
     (Id : W_Record_Aggregate_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Record_Aggregate_List_Valid (Id));

   function Record_Aggregate_Id_Valid
     (Id : W_Record_Aggregate_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Record_Aggregate_Id_Children_Valid (Id));

   function Record_Aggregate_List_Valid
     (Id : W_Record_Aggregate_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Any_Expr_OId_Valid
     (Id : W_Any_Expr_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Any_Expr_Id_Valid (Id));

   function Any_Expr_OList_Valid
     (Id : W_Any_Expr_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Any_Expr_List_Valid (Id));

   function Any_Expr_Id_Valid
     (Id : W_Any_Expr_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Any_Expr_Id_Children_Valid (Id));

   function Any_Expr_List_Valid
     (Id : W_Any_Expr_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Assignment_OId_Valid
     (Id : W_Assignment_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Assignment_Id_Valid (Id));

   function Assignment_OList_Valid
     (Id : W_Assignment_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Assignment_List_Valid (Id));

   function Assignment_Id_Valid
     (Id : W_Assignment_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Assignment_Id_Children_Valid (Id));

   function Assignment_List_Valid
     (Id : W_Assignment_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Binding_Ref_OId_Valid
     (Id : W_Binding_Ref_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Binding_Ref_Id_Valid (Id));

   function Binding_Ref_OList_Valid
     (Id : W_Binding_Ref_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Binding_Ref_List_Valid (Id));

   function Binding_Ref_Id_Valid
     (Id : W_Binding_Ref_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Binding_Ref_Id_Children_Valid (Id));

   function Binding_Ref_List_Valid
     (Id : W_Binding_Ref_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Loop_OId_Valid
     (Id : W_Loop_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Loop_Id_Valid (Id));

   function Loop_OList_Valid
     (Id : W_Loop_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Loop_List_Valid (Id));

   function Loop_Id_Valid
     (Id : W_Loop_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Loop_Id_Children_Valid (Id));

   function Loop_List_Valid
     (Id : W_Loop_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Statement_Sequence_OId_Valid
     (Id : W_Statement_Sequence_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Statement_Sequence_Id_Valid (Id));

   function Statement_Sequence_OList_Valid
     (Id : W_Statement_Sequence_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Statement_Sequence_List_Valid (Id));

   function Statement_Sequence_Id_Valid
     (Id : W_Statement_Sequence_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Statement_Sequence_Id_Children_Valid (Id));

   function Statement_Sequence_List_Valid
     (Id : W_Statement_Sequence_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Abstract_Expr_OId_Valid
     (Id : W_Abstract_Expr_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Abstract_Expr_Id_Valid (Id));

   function Abstract_Expr_OList_Valid
     (Id : W_Abstract_Expr_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Abstract_Expr_List_Valid (Id));

   function Abstract_Expr_Id_Valid
     (Id : W_Abstract_Expr_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Abstract_Expr_Id_Children_Valid (Id));

   function Abstract_Expr_List_Valid
     (Id : W_Abstract_Expr_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Assert_OId_Valid
     (Id : W_Assert_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Assert_Id_Valid (Id));

   function Assert_OList_Valid
     (Id : W_Assert_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Assert_List_Valid (Id));

   function Assert_Id_Valid
     (Id : W_Assert_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Assert_Id_Children_Valid (Id));

   function Assert_List_Valid
     (Id : W_Assert_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Raise_OId_Valid
     (Id : W_Raise_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Raise_Id_Valid (Id));

   function Raise_OList_Valid
     (Id : W_Raise_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Raise_List_Valid (Id));

   function Raise_Id_Valid
     (Id : W_Raise_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Raise_Id_Children_Valid (Id));

   function Raise_List_Valid
     (Id : W_Raise_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Try_Block_OId_Valid
     (Id : W_Try_Block_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Try_Block_Id_Valid (Id));

   function Try_Block_OList_Valid
     (Id : W_Try_Block_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Try_Block_List_Valid (Id));

   function Try_Block_Id_Valid
     (Id : W_Try_Block_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Try_Block_Id_Children_Valid (Id));

   function Try_Block_List_Valid
     (Id : W_Try_Block_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Function_Decl_OId_Valid
     (Id : W_Function_Decl_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Function_Decl_Id_Valid (Id));

   function Function_Decl_OList_Valid
     (Id : W_Function_Decl_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Function_Decl_List_Valid (Id));

   function Function_Decl_Id_Valid
     (Id : W_Function_Decl_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Function_Decl_Id_Children_Valid (Id));

   function Function_Decl_List_Valid
     (Id : W_Function_Decl_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Axiom_OId_Valid
     (Id : W_Axiom_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Axiom_Id_Valid (Id));

   function Axiom_OList_Valid
     (Id : W_Axiom_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Axiom_List_Valid (Id));

   function Axiom_Id_Valid
     (Id : W_Axiom_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Axiom_Id_Children_Valid (Id));

   function Axiom_List_Valid
     (Id : W_Axiom_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Goal_OId_Valid
     (Id : W_Goal_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Goal_Id_Valid (Id));

   function Goal_OList_Valid
     (Id : W_Goal_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Goal_List_Valid (Id));

   function Goal_Id_Valid
     (Id : W_Goal_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Goal_Id_Children_Valid (Id));

   function Goal_List_Valid
     (Id : W_Goal_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Type_Decl_OId_Valid
     (Id : W_Type_Decl_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Type_Decl_Id_Valid (Id));

   function Type_Decl_OList_Valid
     (Id : W_Type_Decl_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Type_Decl_List_Valid (Id));

   function Type_Decl_Id_Valid
     (Id : W_Type_Decl_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Type_Decl_Id_Children_Valid (Id));

   function Type_Decl_List_Valid
     (Id : W_Type_Decl_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Global_Ref_Declaration_OId_Valid
     (Id : W_Global_Ref_Declaration_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Global_Ref_Declaration_Id_Valid (Id));

   function Global_Ref_Declaration_OList_Valid
     (Id : W_Global_Ref_Declaration_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Global_Ref_Declaration_List_Valid (Id));

   function Global_Ref_Declaration_Id_Valid
     (Id : W_Global_Ref_Declaration_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Global_Ref_Declaration_Id_Children_Valid (Id));

   function Global_Ref_Declaration_List_Valid
     (Id : W_Global_Ref_Declaration_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Namespace_Declaration_OId_Valid
     (Id : W_Namespace_Declaration_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Namespace_Declaration_Id_Valid (Id));

   function Namespace_Declaration_OList_Valid
     (Id : W_Namespace_Declaration_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Namespace_Declaration_List_Valid (Id));

   function Namespace_Declaration_Id_Valid
     (Id : W_Namespace_Declaration_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Namespace_Declaration_Id_Children_Valid (Id));

   function Namespace_Declaration_List_Valid
     (Id : W_Namespace_Declaration_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Exception_Declaration_OId_Valid
     (Id : W_Exception_Declaration_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Exception_Declaration_Id_Valid (Id));

   function Exception_Declaration_OList_Valid
     (Id : W_Exception_Declaration_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Exception_Declaration_List_Valid (Id));

   function Exception_Declaration_Id_Valid
     (Id : W_Exception_Declaration_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Exception_Declaration_Id_Children_Valid (Id));

   function Exception_Declaration_List_Valid
     (Id : W_Exception_Declaration_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Meta_Declaration_OId_Valid
     (Id : W_Meta_Declaration_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Meta_Declaration_Id_Valid (Id));

   function Meta_Declaration_OList_Valid
     (Id : W_Meta_Declaration_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Meta_Declaration_List_Valid (Id));

   function Meta_Declaration_Id_Valid
     (Id : W_Meta_Declaration_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Meta_Declaration_Id_Children_Valid (Id));

   function Meta_Declaration_List_Valid
     (Id : W_Meta_Declaration_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Clone_Declaration_OId_Valid
     (Id : W_Clone_Declaration_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Clone_Declaration_Id_Valid (Id));

   function Clone_Declaration_OList_Valid
     (Id : W_Clone_Declaration_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Clone_Declaration_List_Valid (Id));

   function Clone_Declaration_Id_Valid
     (Id : W_Clone_Declaration_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Clone_Declaration_Id_Children_Valid (Id));

   function Clone_Declaration_List_Valid
     (Id : W_Clone_Declaration_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Clone_Substitution_OId_Valid
     (Id : W_Clone_Substitution_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Clone_Substitution_Id_Valid (Id));

   function Clone_Substitution_OList_Valid
     (Id : W_Clone_Substitution_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Clone_Substitution_List_Valid (Id));

   function Clone_Substitution_Id_Valid
     (Id : W_Clone_Substitution_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Clone_Substitution_Id_Children_Valid (Id));

   function Clone_Substitution_List_Valid
     (Id : W_Clone_Substitution_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Include_Declaration_OId_Valid
     (Id : W_Include_Declaration_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Include_Declaration_Id_Valid (Id));

   function Include_Declaration_OList_Valid
     (Id : W_Include_Declaration_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Include_Declaration_List_Valid (Id));

   function Include_Declaration_Id_Valid
     (Id : W_Include_Declaration_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Include_Declaration_Id_Children_Valid (Id));

   function Include_Declaration_List_Valid
     (Id : W_Include_Declaration_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Theory_Declaration_OId_Valid
     (Id : W_Theory_Declaration_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Theory_Declaration_Id_Valid (Id));

   function Theory_Declaration_OList_Valid
     (Id : W_Theory_Declaration_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Theory_Declaration_List_Valid (Id));

   function Theory_Declaration_Id_Valid
     (Id : W_Theory_Declaration_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Theory_Declaration_Id_Children_Valid (Id));

   function Theory_Declaration_List_Valid
     (Id : W_Theory_Declaration_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Module_OId_Valid
     (Id : W_Module_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Module_Id_Valid (Id));

   function Module_OList_Valid
     (Id : W_Module_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Module_List_Valid (Id));

   function Module_Id_Valid
     (Id : W_Module_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Module_Id_Children_Valid (Id));

   function Module_List_Valid
     (Id : W_Module_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Expr_OId_Valid
     (Id : W_Expr_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Expr_Id_Valid (Id));

   function Expr_OList_Valid
     (Id : W_Expr_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Expr_List_Valid (Id));

   function Expr_Id_Valid
     (Id : W_Expr_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Expr_Id_Children_Valid (Id));

   function Expr_List_Valid
     (Id : W_Expr_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Pred_OId_Valid
     (Id : W_Pred_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Pred_Id_Valid (Id));

   function Pred_OList_Valid
     (Id : W_Pred_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Pred_List_Valid (Id));

   function Pred_Id_Valid
     (Id : W_Pred_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Pred_Id_Children_Valid (Id));

   function Pred_List_Valid
     (Id : W_Pred_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Term_OId_Valid
     (Id : W_Term_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Term_Id_Valid (Id));

   function Term_OList_Valid
     (Id : W_Term_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Term_List_Valid (Id));

   function Term_Id_Valid
     (Id : W_Term_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Term_Id_Children_Valid (Id));

   function Term_List_Valid
     (Id : W_Term_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Prog_OId_Valid
     (Id : W_Prog_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Prog_Id_Valid (Id));

   function Prog_OList_Valid
     (Id : W_Prog_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Prog_List_Valid (Id));

   function Prog_Id_Valid
     (Id : W_Prog_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Prog_Id_Children_Valid (Id));

   function Prog_List_Valid
     (Id : W_Prog_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Type_Definition_OId_Valid
     (Id : W_Type_Definition_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Type_Definition_Id_Valid (Id));

   function Type_Definition_OList_Valid
     (Id : W_Type_Definition_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Type_Definition_List_Valid (Id));

   function Type_Definition_Id_Valid
     (Id : W_Type_Definition_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Type_Definition_Id_Children_Valid (Id));

   function Type_Definition_List_Valid
     (Id : W_Type_Definition_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Declaration_OId_Valid
     (Id : W_Declaration_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Declaration_Id_Valid (Id));

   function Declaration_OList_Valid
     (Id : W_Declaration_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Declaration_List_Valid (Id));

   function Declaration_Id_Valid
     (Id : W_Declaration_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Declaration_Id_Children_Valid (Id));

   function Declaration_List_Valid
     (Id : W_Declaration_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Any_Node_OId_Valid
     (Id : W_Any_Node_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Any_Node_Id_Valid (Id));

   function Any_Node_OList_Valid
     (Id : W_Any_Node_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Any_Node_List_Valid (Id));

   function Any_Node_Id_Valid
     (Id : W_Any_Node_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid (Id)
      or else Any_Node_Id_Children_Valid (Id));

   function Any_Node_List_Valid
     (Id : W_Any_Node_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then (for all Element of Get_List (Id) =>
     Id_Cache_Valid (Element)));

   function Id_Cache_Valid (Id : Why_Node_Id) return Boolean renames
     Is_Checked;

   function OId_Cache_Valid (Id : Why_Node_Id) return Boolean is
     (Id = Why_Empty or else Id_Cache_Valid (Id));

   function List_Cache_Valid (Id : Why_Node_List) return Boolean is
     (not Is_Empty (Id) and then Is_Checked (Id));

   function OList_Cache_Valid (Id : Why_Node_List) return Boolean is
     (Is_Empty (Id) or else List_Cache_Valid (Id));

   function Unused_At_Start_OId_Children_Valid
     (Id : W_Unused_At_Start_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Unused_At_Start_Id_Children_Valid (Id));

   function Unused_At_Start_OList_Children_Valid
     (Id : W_Unused_At_Start_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Unused_At_Start_List_Children_Valid (Id));

   function Unused_At_Start_Id_Children_Valid
     (Id : W_Unused_At_Start_Unchecked_Id)
     return Boolean is
     (True);

   function Unused_At_Start_List_Children_Valid
     (Id : W_Unused_At_Start_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Type_OId_Children_Valid
     (Id : W_Type_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Type_Id_Children_Valid (Id));

   function Type_OList_Children_Valid
     (Id : W_Type_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Type_List_Children_Valid (Id));

   function Type_Id_Children_Valid
     (Id : W_Type_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
         (Node_Table (Id).K1_Name));

   function Type_List_Children_Valid
     (Id : W_Type_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Name_OId_Children_Valid
     (Id : W_Name_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Name_Id_Children_Valid (Id));

   function Name_OList_Children_Valid
     (Id : W_Name_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Name_List_Children_Valid (Id));

   function Name_Id_Children_Valid
     (Id : W_Name_Unchecked_Id)
     return Boolean is
     (OId_Cache_Valid
         (Node_Table (Id).K2_Module));

   function Name_List_Children_Valid
     (Id : W_Name_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Effects_OId_Children_Valid
     (Id : W_Effects_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Effects_Id_Children_Valid (Id));

   function Effects_OList_Children_Valid
     (Id : W_Effects_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Effects_List_Children_Valid (Id));

   function Effects_Id_Children_Valid
     (Id : W_Effects_Unchecked_Id)
     return Boolean is
     (OList_Cache_Valid
       (Node_Table (Id).K3_Reads)
       and then
       OList_Cache_Valid
         (Node_Table (Id).K3_Writes)
       and then
       OList_Cache_Valid
         (Node_Table (Id).K3_Raises));

   function Effects_List_Children_Valid
     (Id : W_Effects_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Raise_Effect_OId_Children_Valid
     (Id : W_Raise_Effect_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Raise_Effect_Id_Children_Valid (Id));

   function Raise_Effect_OList_Children_Valid
     (Id : W_Raise_Effect_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Raise_Effect_List_Children_Valid (Id));

   function Raise_Effect_Id_Children_Valid
     (Id : W_Raise_Effect_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
       (Node_Table (Id).K4_Name)
       and then
       OId_Cache_Valid
         (Node_Table (Id).K4_Arg_Id)
       and then
       OId_Cache_Valid
         (Node_Table (Id).K4_Post));

   function Raise_Effect_List_Children_Valid
     (Id : W_Raise_Effect_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Binder_OId_Children_Valid
     (Id : W_Binder_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Binder_Id_Children_Valid (Id));

   function Binder_OList_Children_Valid
     (Id : W_Binder_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Binder_List_Children_Valid (Id));

   function Binder_Id_Children_Valid
     (Id : W_Binder_Unchecked_Id)
     return Boolean is
     (OId_Cache_Valid
       (Node_Table (Id).K5_Name)
       and then
       Id_Cache_Valid
         (Node_Table (Id).K5_Arg_Type));

   function Binder_List_Children_Valid
     (Id : W_Binder_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Transparent_Type_Definition_OId_Children_Valid
     (Id : W_Transparent_Type_Definition_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Transparent_Type_Definition_Id_Children_Valid (Id));

   function Transparent_Type_Definition_OList_Children_Valid
     (Id : W_Transparent_Type_Definition_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Transparent_Type_Definition_List_Children_Valid (Id));

   function Transparent_Type_Definition_Id_Children_Valid
     (Id : W_Transparent_Type_Definition_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
       (Node_Table (Id).K6_Type_Definition));

   function Transparent_Type_Definition_List_Children_Valid
     (Id : W_Transparent_Type_Definition_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Record_Binder_OId_Children_Valid
     (Id : W_Record_Binder_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Record_Binder_Id_Children_Valid (Id));

   function Record_Binder_OList_Children_Valid
     (Id : W_Record_Binder_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Record_Binder_List_Children_Valid (Id));

   function Record_Binder_Id_Children_Valid
     (Id : W_Record_Binder_Unchecked_Id)
     return Boolean is
     (OId_Cache_Valid
       (Node_Table (Id).K7_Name)
       and then
       Id_Cache_Valid
         (Node_Table (Id).K7_Arg_Type));

   function Record_Binder_List_Children_Valid
     (Id : W_Record_Binder_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Record_Definition_OId_Children_Valid
     (Id : W_Record_Definition_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Record_Definition_Id_Children_Valid (Id));

   function Record_Definition_OList_Children_Valid
     (Id : W_Record_Definition_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Record_Definition_List_Children_Valid (Id));

   function Record_Definition_Id_Children_Valid
     (Id : W_Record_Definition_Unchecked_Id)
     return Boolean is
     (List_Cache_Valid
       (Node_Table (Id).K8_Fields));

   function Record_Definition_List_Children_Valid
     (Id : W_Record_Definition_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Range_Type_Definition_OId_Children_Valid
     (Id : W_Range_Type_Definition_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Range_Type_Definition_Id_Children_Valid (Id));

   function Range_Type_Definition_OList_Children_Valid
     (Id : W_Range_Type_Definition_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Range_Type_Definition_List_Children_Valid (Id));

   function Range_Type_Definition_Id_Children_Valid
     (Id : W_Range_Type_Definition_Unchecked_Id)
     return Boolean is
     (True);

   function Range_Type_Definition_List_Children_Valid
     (Id : W_Range_Type_Definition_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Triggers_OId_Children_Valid
     (Id : W_Triggers_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Triggers_Id_Children_Valid (Id));

   function Triggers_OList_Children_Valid
     (Id : W_Triggers_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Triggers_List_Children_Valid (Id));

   function Triggers_Id_Children_Valid
     (Id : W_Triggers_Unchecked_Id)
     return Boolean is
     (List_Cache_Valid
       (Node_Table (Id).K10_Triggers));

   function Triggers_List_Children_Valid
     (Id : W_Triggers_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Trigger_OId_Children_Valid
     (Id : W_Trigger_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Trigger_Id_Children_Valid (Id));

   function Trigger_OList_Children_Valid
     (Id : W_Trigger_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Trigger_List_Children_Valid (Id));

   function Trigger_Id_Children_Valid
     (Id : W_Trigger_Unchecked_Id)
     return Boolean is
     (List_Cache_Valid
       (Node_Table (Id).K11_Terms));

   function Trigger_List_Children_Valid
     (Id : W_Trigger_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Axiom_Dep_OId_Children_Valid
     (Id : W_Axiom_Dep_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Axiom_Dep_Id_Children_Valid (Id));

   function Axiom_Dep_OList_Children_Valid
     (Id : W_Axiom_Dep_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Axiom_Dep_List_Children_Valid (Id));

   function Axiom_Dep_Id_Children_Valid
     (Id : W_Axiom_Dep_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
       (Node_Table (Id).K12_Name));

   function Axiom_Dep_List_Children_Valid
     (Id : W_Axiom_Dep_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Handler_OId_Children_Valid
     (Id : W_Handler_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Handler_Id_Children_Valid (Id));

   function Handler_OList_Children_Valid
     (Id : W_Handler_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Handler_List_Children_Valid (Id));

   function Handler_Id_Children_Valid
     (Id : W_Handler_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
       (Node_Table (Id).K13_Name)
       and then
       OId_Cache_Valid
         (Node_Table (Id).K13_Arg_Id)
       and then
       Id_Cache_Valid
         (Node_Table (Id).K13_Def));

   function Handler_List_Children_Valid
     (Id : W_Handler_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Field_Association_OId_Children_Valid
     (Id : W_Field_Association_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Field_Association_Id_Children_Valid (Id));

   function Field_Association_OList_Children_Valid
     (Id : W_Field_Association_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Field_Association_List_Children_Valid (Id));

   function Field_Association_Id_Children_Valid
     (Id : W_Field_Association_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
       (Node_Table (Id).K14_Field)
       and then
       Id_Cache_Valid
         (Node_Table (Id).K14_Value));

   function Field_Association_List_Children_Valid
     (Id : W_Field_Association_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Variant_OId_Children_Valid
     (Id : W_Variant_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Variant_Id_Children_Valid (Id));

   function Variant_OList_Children_Valid
     (Id : W_Variant_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Variant_List_Children_Valid (Id));

   function Variant_Id_Children_Valid
     (Id : W_Variant_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
       (Node_Table (Id).K15_Cmp_Op)
       and then
       Id_Cache_Valid
         (Node_Table (Id).K15_Expr));

   function Variant_List_Children_Valid
     (Id : W_Variant_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Variants_OId_Children_Valid
     (Id : W_Variants_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Variants_Id_Children_Valid (Id));

   function Variants_OList_Children_Valid
     (Id : W_Variants_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Variants_List_Children_Valid (Id));

   function Variants_Id_Children_Valid
     (Id : W_Variants_Unchecked_Id)
     return Boolean is
     (List_Cache_Valid
       (Node_Table (Id).K16_Variants));

   function Variants_List_Children_Valid
     (Id : W_Variants_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Universal_Quantif_OId_Children_Valid
     (Id : W_Universal_Quantif_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Universal_Quantif_Id_Children_Valid (Id));

   function Universal_Quantif_OList_Children_Valid
     (Id : W_Universal_Quantif_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Universal_Quantif_List_Children_Valid (Id));

   function Universal_Quantif_Id_Children_Valid
     (Id : W_Universal_Quantif_Unchecked_Id)
     return Boolean is
     (List_Cache_Valid
       (Node_Table (Id).K17_Variables)
       and then
       Id_Cache_Valid
         (Node_Table (Id).K17_Var_Type)
       and then
       OId_Cache_Valid
         (Node_Table (Id).K17_Triggers)
       and then
       Id_Cache_Valid
         (Node_Table (Id).K17_Pred));

   function Universal_Quantif_List_Children_Valid
     (Id : W_Universal_Quantif_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Existential_Quantif_OId_Children_Valid
     (Id : W_Existential_Quantif_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Existential_Quantif_Id_Children_Valid (Id));

   function Existential_Quantif_OList_Children_Valid
     (Id : W_Existential_Quantif_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Existential_Quantif_List_Children_Valid (Id));

   function Existential_Quantif_Id_Children_Valid
     (Id : W_Existential_Quantif_Unchecked_Id)
     return Boolean is
     (List_Cache_Valid
       (Node_Table (Id).K18_Variables)
       and then
       Id_Cache_Valid
         (Node_Table (Id).K18_Var_Type)
       and then
       Id_Cache_Valid
         (Node_Table (Id).K18_Pred));

   function Existential_Quantif_List_Children_Valid
     (Id : W_Existential_Quantif_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Not_OId_Children_Valid
     (Id : W_Not_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Not_Id_Children_Valid (Id));

   function Not_OList_Children_Valid
     (Id : W_Not_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Not_List_Children_Valid (Id));

   function Not_Id_Children_Valid
     (Id : W_Not_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
       (Node_Table (Id).K19_Right));

   function Not_List_Children_Valid
     (Id : W_Not_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Connection_OId_Children_Valid
     (Id : W_Connection_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Connection_Id_Children_Valid (Id));

   function Connection_OList_Children_Valid
     (Id : W_Connection_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Connection_List_Children_Valid (Id));

   function Connection_Id_Children_Valid
     (Id : W_Connection_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
       (Node_Table (Id).K20_Left)
       and then
       Id_Cache_Valid
         (Node_Table (Id).K20_Right)
       and then
       OList_Cache_Valid
         (Node_Table (Id).K20_More_Right));

   function Connection_List_Children_Valid
     (Id : W_Connection_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Label_OId_Children_Valid
     (Id : W_Label_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Label_Id_Children_Valid (Id));

   function Label_OList_Children_Valid
     (Id : W_Label_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Label_List_Children_Valid (Id));

   function Label_Id_Children_Valid
     (Id : W_Label_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
         (Node_Table (Id).K21_Def)
       and then
       OId_Cache_Valid
         (Node_Table (Id).K21_Typ));

   function Label_List_Children_Valid
     (Id : W_Label_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Loc_Label_OId_Children_Valid
     (Id : W_Loc_Label_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Loc_Label_Id_Children_Valid (Id));

   function Loc_Label_OList_Children_Valid
     (Id : W_Loc_Label_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Loc_Label_List_Children_Valid (Id));

   function Loc_Label_Id_Children_Valid
     (Id : W_Loc_Label_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
         (Node_Table (Id).K22_Def));

   function Loc_Label_List_Children_Valid
     (Id : W_Loc_Label_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Identifier_OId_Children_Valid
     (Id : W_Identifier_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Identifier_Id_Children_Valid (Id));

   function Identifier_OList_Children_Valid
     (Id : W_Identifier_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Identifier_List_Children_Valid (Id));

   function Identifier_Id_Children_Valid
     (Id : W_Identifier_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
       (Node_Table (Id).K23_Name)
       and then
       OId_Cache_Valid
         (Node_Table (Id).K23_Typ));

   function Identifier_List_Children_Valid
     (Id : W_Identifier_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Tagged_OId_Children_Valid
     (Id : W_Tagged_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Tagged_Id_Children_Valid (Id));

   function Tagged_OList_Children_Valid
     (Id : W_Tagged_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Tagged_List_Children_Valid (Id));

   function Tagged_Id_Children_Valid
     (Id : W_Tagged_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
         (Node_Table (Id).K24_Def)
       and then
       OId_Cache_Valid
         (Node_Table (Id).K24_Typ));

   function Tagged_List_Children_Valid
     (Id : W_Tagged_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Call_OId_Children_Valid
     (Id : W_Call_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Call_Id_Children_Valid (Id));

   function Call_OList_Children_Valid
     (Id : W_Call_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Call_List_Children_Valid (Id));

   function Call_Id_Children_Valid
     (Id : W_Call_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
       (Node_Table (Id).K25_Name)
       and then
       OList_Cache_Valid
         (Node_Table (Id).K25_Args)
       and then
       OId_Cache_Valid
         (Node_Table (Id).K25_Typ));

   function Call_List_Children_Valid
     (Id : W_Call_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Literal_OId_Children_Valid
     (Id : W_Literal_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Literal_Id_Children_Valid (Id));

   function Literal_OList_Children_Valid
     (Id : W_Literal_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Literal_List_Children_Valid (Id));

   function Literal_Id_Children_Valid
     (Id : W_Literal_Unchecked_Id)
     return Boolean is
     (OId_Cache_Valid
         (Node_Table (Id).K26_Typ));

   function Literal_List_Children_Valid
     (Id : W_Literal_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Binding_OId_Children_Valid
     (Id : W_Binding_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Binding_Id_Children_Valid (Id));

   function Binding_OList_Children_Valid
     (Id : W_Binding_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Binding_List_Children_Valid (Id));

   function Binding_Id_Children_Valid
     (Id : W_Binding_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
       (Node_Table (Id).K27_Name)
       and then
       Id_Cache_Valid
         (Node_Table (Id).K27_Def)
       and then
       Id_Cache_Valid
         (Node_Table (Id).K27_Context)
       and then
       OId_Cache_Valid
         (Node_Table (Id).K27_Typ));

   function Binding_List_Children_Valid
     (Id : W_Binding_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Elsif_OId_Children_Valid
     (Id : W_Elsif_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Elsif_Id_Children_Valid (Id));

   function Elsif_OList_Children_Valid
     (Id : W_Elsif_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Elsif_List_Children_Valid (Id));

   function Elsif_Id_Children_Valid
     (Id : W_Elsif_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
       (Node_Table (Id).K28_Condition)
       and then
       Id_Cache_Valid
         (Node_Table (Id).K28_Then_Part)
       and then
       OId_Cache_Valid
         (Node_Table (Id).K28_Typ));

   function Elsif_List_Children_Valid
     (Id : W_Elsif_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Epsilon_OId_Children_Valid
     (Id : W_Epsilon_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Epsilon_Id_Children_Valid (Id));

   function Epsilon_OList_Children_Valid
     (Id : W_Epsilon_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Epsilon_List_Children_Valid (Id));

   function Epsilon_Id_Children_Valid
     (Id : W_Epsilon_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
       (Node_Table (Id).K29_Name)
       and then
       Id_Cache_Valid
         (Node_Table (Id).K29_Typ)
       and then
       Id_Cache_Valid
         (Node_Table (Id).K29_Pred));

   function Epsilon_List_Children_Valid
     (Id : W_Epsilon_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Conditional_OId_Children_Valid
     (Id : W_Conditional_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Conditional_Id_Children_Valid (Id));

   function Conditional_OList_Children_Valid
     (Id : W_Conditional_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Conditional_List_Children_Valid (Id));

   function Conditional_Id_Children_Valid
     (Id : W_Conditional_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
       (Node_Table (Id).K30_Condition)
       and then
       Id_Cache_Valid
         (Node_Table (Id).K30_Then_Part)
       and then
       OList_Cache_Valid
         (Node_Table (Id).K30_Elsif_Parts)
       and then
       OId_Cache_Valid
         (Node_Table (Id).K30_Else_Part)
       and then
       OId_Cache_Valid
         (Node_Table (Id).K30_Typ));

   function Conditional_List_Children_Valid
     (Id : W_Conditional_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Integer_Constant_OId_Children_Valid
     (Id : W_Integer_Constant_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Integer_Constant_Id_Children_Valid (Id));

   function Integer_Constant_OList_Children_Valid
     (Id : W_Integer_Constant_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Integer_Constant_List_Children_Valid (Id));

   function Integer_Constant_Id_Children_Valid
     (Id : W_Integer_Constant_Unchecked_Id)
     return Boolean is
     (True);

   function Integer_Constant_List_Children_Valid
     (Id : W_Integer_Constant_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Range_Constant_OId_Children_Valid
     (Id : W_Range_Constant_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Range_Constant_Id_Children_Valid (Id));

   function Range_Constant_OList_Children_Valid
     (Id : W_Range_Constant_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Range_Constant_List_Children_Valid (Id));

   function Range_Constant_Id_Children_Valid
     (Id : W_Range_Constant_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
         (Node_Table (Id).K32_Typ));

   function Range_Constant_List_Children_Valid
     (Id : W_Range_Constant_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Modular_Constant_OId_Children_Valid
     (Id : W_Modular_Constant_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Modular_Constant_Id_Children_Valid (Id));

   function Modular_Constant_OList_Children_Valid
     (Id : W_Modular_Constant_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Modular_Constant_List_Children_Valid (Id));

   function Modular_Constant_Id_Children_Valid
     (Id : W_Modular_Constant_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
         (Node_Table (Id).K33_Typ));

   function Modular_Constant_List_Children_Valid
     (Id : W_Modular_Constant_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Fixed_Constant_OId_Children_Valid
     (Id : W_Fixed_Constant_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Fixed_Constant_Id_Children_Valid (Id));

   function Fixed_Constant_OList_Children_Valid
     (Id : W_Fixed_Constant_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Fixed_Constant_List_Children_Valid (Id));

   function Fixed_Constant_Id_Children_Valid
     (Id : W_Fixed_Constant_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
         (Node_Table (Id).K34_Typ));

   function Fixed_Constant_List_Children_Valid
     (Id : W_Fixed_Constant_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Real_Constant_OId_Children_Valid
     (Id : W_Real_Constant_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Real_Constant_Id_Children_Valid (Id));

   function Real_Constant_OList_Children_Valid
     (Id : W_Real_Constant_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Real_Constant_List_Children_Valid (Id));

   function Real_Constant_Id_Children_Valid
     (Id : W_Real_Constant_Unchecked_Id)
     return Boolean is
     (True);

   function Real_Constant_List_Children_Valid
     (Id : W_Real_Constant_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Float_Constant_OId_Children_Valid
     (Id : W_Float_Constant_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Float_Constant_Id_Children_Valid (Id));

   function Float_Constant_OList_Children_Valid
     (Id : W_Float_Constant_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Float_Constant_List_Children_Valid (Id));

   function Float_Constant_Id_Children_Valid
     (Id : W_Float_Constant_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
         (Node_Table (Id).K36_Typ));

   function Float_Constant_List_Children_Valid
     (Id : W_Float_Constant_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Comment_OId_Children_Valid
     (Id : W_Comment_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Comment_Id_Children_Valid (Id));

   function Comment_OList_Children_Valid
     (Id : W_Comment_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Comment_List_Children_Valid (Id));

   function Comment_Id_Children_Valid
     (Id : W_Comment_Unchecked_Id)
     return Boolean is
     (True);

   function Comment_List_Children_Valid
     (Id : W_Comment_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Deref_OId_Children_Valid
     (Id : W_Deref_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Deref_Id_Children_Valid (Id));

   function Deref_OList_Children_Valid
     (Id : W_Deref_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Deref_List_Children_Valid (Id));

   function Deref_Id_Children_Valid
     (Id : W_Deref_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
       (Node_Table (Id).K38_Right)
       and then
       Id_Cache_Valid
         (Node_Table (Id).K38_Typ));

   function Deref_List_Children_Valid
     (Id : W_Deref_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Record_Access_OId_Children_Valid
     (Id : W_Record_Access_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Record_Access_Id_Children_Valid (Id));

   function Record_Access_OList_Children_Valid
     (Id : W_Record_Access_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Record_Access_List_Children_Valid (Id));

   function Record_Access_Id_Children_Valid
     (Id : W_Record_Access_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
       (Node_Table (Id).K39_Name)
       and then
       Id_Cache_Valid
         (Node_Table (Id).K39_Field)
       and then
       OId_Cache_Valid
         (Node_Table (Id).K39_Typ));

   function Record_Access_List_Children_Valid
     (Id : W_Record_Access_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Record_Update_OId_Children_Valid
     (Id : W_Record_Update_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Record_Update_Id_Children_Valid (Id));

   function Record_Update_OList_Children_Valid
     (Id : W_Record_Update_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Record_Update_List_Children_Valid (Id));

   function Record_Update_Id_Children_Valid
     (Id : W_Record_Update_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
       (Node_Table (Id).K40_Name)
       and then
       List_Cache_Valid
         (Node_Table (Id).K40_Updates)
       and then
       OId_Cache_Valid
         (Node_Table (Id).K40_Typ));

   function Record_Update_List_Children_Valid
     (Id : W_Record_Update_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Record_Aggregate_OId_Children_Valid
     (Id : W_Record_Aggregate_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Record_Aggregate_Id_Children_Valid (Id));

   function Record_Aggregate_OList_Children_Valid
     (Id : W_Record_Aggregate_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Record_Aggregate_List_Children_Valid (Id));

   function Record_Aggregate_Id_Children_Valid
     (Id : W_Record_Aggregate_Unchecked_Id)
     return Boolean is
     (List_Cache_Valid
       (Node_Table (Id).K41_Associations)
       and then
       OId_Cache_Valid
         (Node_Table (Id).K41_Typ));

   function Record_Aggregate_List_Children_Valid
     (Id : W_Record_Aggregate_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Any_Expr_OId_Children_Valid
     (Id : W_Any_Expr_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Any_Expr_Id_Children_Valid (Id));

   function Any_Expr_OList_Children_Valid
     (Id : W_Any_Expr_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Any_Expr_List_Children_Valid (Id));

   function Any_Expr_Id_Children_Valid
     (Id : W_Any_Expr_Unchecked_Id)
     return Boolean is
     (OId_Cache_Valid
       (Node_Table (Id).K42_Effects)
       and then
       OId_Cache_Valid
         (Node_Table (Id).K42_Pre)
       and then
       OId_Cache_Valid
         (Node_Table (Id).K42_Post)
       and then
       Id_Cache_Valid
         (Node_Table (Id).K42_Return_Type));

   function Any_Expr_List_Children_Valid
     (Id : W_Any_Expr_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Assignment_OId_Children_Valid
     (Id : W_Assignment_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Assignment_Id_Children_Valid (Id));

   function Assignment_OList_Children_Valid
     (Id : W_Assignment_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Assignment_List_Children_Valid (Id));

   function Assignment_Id_Children_Valid
     (Id : W_Assignment_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
       (Node_Table (Id).K43_Name)
       and then
       Id_Cache_Valid
         (Node_Table (Id).K43_Value)
       and then
       Id_Cache_Valid
         (Node_Table (Id).K43_Typ));

   function Assignment_List_Children_Valid
     (Id : W_Assignment_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Binding_Ref_OId_Children_Valid
     (Id : W_Binding_Ref_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Binding_Ref_Id_Children_Valid (Id));

   function Binding_Ref_OList_Children_Valid
     (Id : W_Binding_Ref_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Binding_Ref_List_Children_Valid (Id));

   function Binding_Ref_Id_Children_Valid
     (Id : W_Binding_Ref_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
       (Node_Table (Id).K44_Name)
       and then
       Id_Cache_Valid
         (Node_Table (Id).K44_Def)
       and then
       Id_Cache_Valid
         (Node_Table (Id).K44_Context)
       and then
       Id_Cache_Valid
         (Node_Table (Id).K44_Typ));

   function Binding_Ref_List_Children_Valid
     (Id : W_Binding_Ref_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Loop_OId_Children_Valid
     (Id : W_Loop_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Loop_Id_Children_Valid (Id));

   function Loop_OList_Children_Valid
     (Id : W_Loop_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Loop_List_Children_Valid (Id));

   function Loop_Id_Children_Valid
     (Id : W_Loop_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
       (Node_Table (Id).K45_Code_Before)
       and then
       OList_Cache_Valid
         (Node_Table (Id).K45_Invariants)
       and then
       OList_Cache_Valid
         (Node_Table (Id).K45_Variants)
       and then
       Id_Cache_Valid
         (Node_Table (Id).K45_Code_After));

   function Loop_List_Children_Valid
     (Id : W_Loop_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Statement_Sequence_OId_Children_Valid
     (Id : W_Statement_Sequence_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Statement_Sequence_Id_Children_Valid (Id));

   function Statement_Sequence_OList_Children_Valid
     (Id : W_Statement_Sequence_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Statement_Sequence_List_Children_Valid (Id));

   function Statement_Sequence_Id_Children_Valid
     (Id : W_Statement_Sequence_Unchecked_Id)
     return Boolean is
     (List_Cache_Valid
       (Node_Table (Id).K46_Statements));

   function Statement_Sequence_List_Children_Valid
     (Id : W_Statement_Sequence_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Abstract_Expr_OId_Children_Valid
     (Id : W_Abstract_Expr_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Abstract_Expr_Id_Children_Valid (Id));

   function Abstract_Expr_OList_Children_Valid
     (Id : W_Abstract_Expr_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Abstract_Expr_List_Children_Valid (Id));

   function Abstract_Expr_Id_Children_Valid
     (Id : W_Abstract_Expr_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
       (Node_Table (Id).K47_Expr)
       and then
       Id_Cache_Valid
         (Node_Table (Id).K47_Post)
       and then
       OId_Cache_Valid
         (Node_Table (Id).K47_Typ));

   function Abstract_Expr_List_Children_Valid
     (Id : W_Abstract_Expr_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Assert_OId_Children_Valid
     (Id : W_Assert_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Assert_Id_Children_Valid (Id));

   function Assert_OList_Children_Valid
     (Id : W_Assert_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Assert_List_Children_Valid (Id));

   function Assert_Id_Children_Valid
     (Id : W_Assert_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
       (Node_Table (Id).K48_Pred));

   function Assert_List_Children_Valid
     (Id : W_Assert_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Raise_OId_Children_Valid
     (Id : W_Raise_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Raise_Id_Children_Valid (Id));

   function Raise_OList_Children_Valid
     (Id : W_Raise_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Raise_List_Children_Valid (Id));

   function Raise_Id_Children_Valid
     (Id : W_Raise_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
       (Node_Table (Id).K49_Name)
       and then
       OId_Cache_Valid
         (Node_Table (Id).K49_Arg)
       and then
       OId_Cache_Valid
         (Node_Table (Id).K49_Typ));

   function Raise_List_Children_Valid
     (Id : W_Raise_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Try_Block_OId_Children_Valid
     (Id : W_Try_Block_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Try_Block_Id_Children_Valid (Id));

   function Try_Block_OList_Children_Valid
     (Id : W_Try_Block_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Try_Block_List_Children_Valid (Id));

   function Try_Block_Id_Children_Valid
     (Id : W_Try_Block_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
       (Node_Table (Id).K50_Prog)
       and then
       List_Cache_Valid
         (Node_Table (Id).K50_Handler)
       and then
       OId_Cache_Valid
         (Node_Table (Id).K50_Typ));

   function Try_Block_List_Children_Valid
     (Id : W_Try_Block_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Function_Decl_OId_Children_Valid
     (Id : W_Function_Decl_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Function_Decl_Id_Children_Valid (Id));

   function Function_Decl_OList_Children_Valid
     (Id : W_Function_Decl_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Function_Decl_List_Children_Valid (Id));

   function Function_Decl_Id_Children_Valid
     (Id : W_Function_Decl_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
       (Node_Table (Id).K51_Name)
       and then
       OList_Cache_Valid
         (Node_Table (Id).K51_Binders)
       and then
       OId_Cache_Valid
         (Node_Table (Id).K51_Effects)
       and then
       OId_Cache_Valid
         (Node_Table (Id).K51_Pre)
       and then
       OId_Cache_Valid
         (Node_Table (Id).K51_Post)
       and then
       OId_Cache_Valid
         (Node_Table (Id).K51_Return_Type)
       and then
       OId_Cache_Valid
         (Node_Table (Id).K51_Def));

   function Function_Decl_List_Children_Valid
     (Id : W_Function_Decl_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Axiom_OId_Children_Valid
     (Id : W_Axiom_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Axiom_Id_Children_Valid (Id));

   function Axiom_OList_Children_Valid
     (Id : W_Axiom_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Axiom_List_Children_Valid (Id));

   function Axiom_Id_Children_Valid
     (Id : W_Axiom_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
         (Node_Table (Id).K52_Def)
       and then
       OId_Cache_Valid
         (Node_Table (Id).K52_Dep));

   function Axiom_List_Children_Valid
     (Id : W_Axiom_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Goal_OId_Children_Valid
     (Id : W_Goal_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Goal_Id_Children_Valid (Id));

   function Goal_OList_Children_Valid
     (Id : W_Goal_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Goal_List_Children_Valid (Id));

   function Goal_Id_Children_Valid
     (Id : W_Goal_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
         (Node_Table (Id).K53_Def));

   function Goal_List_Children_Valid
     (Id : W_Goal_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Type_Decl_OId_Children_Valid
     (Id : W_Type_Decl_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Type_Decl_Id_Children_Valid (Id));

   function Type_Decl_OList_Children_Valid
     (Id : W_Type_Decl_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Type_Decl_List_Children_Valid (Id));

   function Type_Decl_Id_Children_Valid
     (Id : W_Type_Decl_Unchecked_Id)
     return Boolean is
     (OList_Cache_Valid
       (Node_Table (Id).K54_Args)
       and then
       Id_Cache_Valid
         (Node_Table (Id).K54_Name)
       and then
       OId_Cache_Valid
         (Node_Table (Id).K54_Definition));

   function Type_Decl_List_Children_Valid
     (Id : W_Type_Decl_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Global_Ref_Declaration_OId_Children_Valid
     (Id : W_Global_Ref_Declaration_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Global_Ref_Declaration_Id_Children_Valid (Id));

   function Global_Ref_Declaration_OList_Children_Valid
     (Id : W_Global_Ref_Declaration_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Global_Ref_Declaration_List_Children_Valid (Id));

   function Global_Ref_Declaration_Id_Children_Valid
     (Id : W_Global_Ref_Declaration_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
       (Node_Table (Id).K55_Name)
       and then
       Id_Cache_Valid
         (Node_Table (Id).K55_Ref_Type));

   function Global_Ref_Declaration_List_Children_Valid
     (Id : W_Global_Ref_Declaration_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Namespace_Declaration_OId_Children_Valid
     (Id : W_Namespace_Declaration_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Namespace_Declaration_Id_Children_Valid (Id));

   function Namespace_Declaration_OList_Children_Valid
     (Id : W_Namespace_Declaration_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Namespace_Declaration_List_Children_Valid (Id));

   function Namespace_Declaration_Id_Children_Valid
     (Id : W_Namespace_Declaration_Unchecked_Id)
     return Boolean is
     (OList_Cache_Valid
       (Node_Table (Id).K56_Declarations));

   function Namespace_Declaration_List_Children_Valid
     (Id : W_Namespace_Declaration_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Exception_Declaration_OId_Children_Valid
     (Id : W_Exception_Declaration_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Exception_Declaration_Id_Children_Valid (Id));

   function Exception_Declaration_OList_Children_Valid
     (Id : W_Exception_Declaration_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Exception_Declaration_List_Children_Valid (Id));

   function Exception_Declaration_Id_Children_Valid
     (Id : W_Exception_Declaration_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
       (Node_Table (Id).K57_Name)
       and then
       OId_Cache_Valid
         (Node_Table (Id).K57_Arg));

   function Exception_Declaration_List_Children_Valid
     (Id : W_Exception_Declaration_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Meta_Declaration_OId_Children_Valid
     (Id : W_Meta_Declaration_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Meta_Declaration_Id_Children_Valid (Id));

   function Meta_Declaration_OList_Children_Valid
     (Id : W_Meta_Declaration_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Meta_Declaration_List_Children_Valid (Id));

   function Meta_Declaration_Id_Children_Valid
     (Id : W_Meta_Declaration_Unchecked_Id)
     return Boolean is
     (True);

   function Meta_Declaration_List_Children_Valid
     (Id : W_Meta_Declaration_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Clone_Declaration_OId_Children_Valid
     (Id : W_Clone_Declaration_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Clone_Declaration_Id_Children_Valid (Id));

   function Clone_Declaration_OList_Children_Valid
     (Id : W_Clone_Declaration_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Clone_Declaration_List_Children_Valid (Id));

   function Clone_Declaration_Id_Children_Valid
     (Id : W_Clone_Declaration_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
       (Node_Table (Id).K59_Origin)
       and then
       OList_Cache_Valid
         (Node_Table (Id).K59_Substitutions));

   function Clone_Declaration_List_Children_Valid
     (Id : W_Clone_Declaration_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Clone_Substitution_OId_Children_Valid
     (Id : W_Clone_Substitution_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Clone_Substitution_Id_Children_Valid (Id));

   function Clone_Substitution_OList_Children_Valid
     (Id : W_Clone_Substitution_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Clone_Substitution_List_Children_Valid (Id));

   function Clone_Substitution_Id_Children_Valid
     (Id : W_Clone_Substitution_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
         (Node_Table (Id).K60_Orig_Name)
       and then
       Id_Cache_Valid
         (Node_Table (Id).K60_Image));

   function Clone_Substitution_List_Children_Valid
     (Id : W_Clone_Substitution_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Include_Declaration_OId_Children_Valid
     (Id : W_Include_Declaration_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Include_Declaration_Id_Children_Valid (Id));

   function Include_Declaration_OList_Children_Valid
     (Id : W_Include_Declaration_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Include_Declaration_List_Children_Valid (Id));

   function Include_Declaration_Id_Children_Valid
     (Id : W_Include_Declaration_Unchecked_Id)
     return Boolean is
     (Id_Cache_Valid
       (Node_Table (Id).K61_Module));

   function Include_Declaration_List_Children_Valid
     (Id : W_Include_Declaration_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Theory_Declaration_OId_Children_Valid
     (Id : W_Theory_Declaration_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Theory_Declaration_Id_Children_Valid (Id));

   function Theory_Declaration_OList_Children_Valid
     (Id : W_Theory_Declaration_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Theory_Declaration_List_Children_Valid (Id));

   function Theory_Declaration_Id_Children_Valid
     (Id : W_Theory_Declaration_Unchecked_Id)
     return Boolean is
     (OList_Cache_Valid
       (Node_Table (Id).K62_Declarations)
       and then
       OList_Cache_Valid
         (Node_Table (Id).K62_Includes));

   function Theory_Declaration_List_Children_Valid
     (Id : W_Theory_Declaration_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Module_OId_Children_Valid
     (Id : W_Module_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Module_Id_Children_Valid (Id));

   function Module_OList_Children_Valid
     (Id : W_Module_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Module_List_Children_Valid (Id));

   function Module_Id_Children_Valid
     (Id : W_Module_Unchecked_Id)
     return Boolean is
     (True);

   function Module_List_Children_Valid
     (Id : W_Module_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Expr_OId_Children_Valid
     (Id : W_Expr_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Expr_Id_Children_Valid (Id));

   function Expr_OList_Children_Valid
     (Id : W_Expr_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Expr_List_Children_Valid (Id));

   function Expr_Id_Children_Valid
     (Id : W_Expr_Unchecked_Id)
     return Boolean is
     (case Get_Kind (Id) is
        when W_Universal_Quantif =>
           Universal_Quantif_Id_Children_Valid (Id),
        when W_Existential_Quantif =>
           Existential_Quantif_Id_Children_Valid (Id),
        when W_Not =>
           Not_Id_Children_Valid (Id),
        when W_Connection =>
           Connection_Id_Children_Valid (Id),
        when W_Label =>
           Label_Id_Children_Valid (Id),
        when W_Loc_Label =>
           Loc_Label_Id_Children_Valid (Id),
        when W_Identifier =>
           Identifier_Id_Children_Valid (Id),
        when W_Tagged =>
           Tagged_Id_Children_Valid (Id),
        when W_Call =>
           Call_Id_Children_Valid (Id),
        when W_Literal =>
           Literal_Id_Children_Valid (Id),
        when W_Binding =>
           Binding_Id_Children_Valid (Id),
        when W_Elsif =>
           Elsif_Id_Children_Valid (Id),
        when W_Epsilon =>
           Epsilon_Id_Children_Valid (Id),
        when W_Conditional =>
           Conditional_Id_Children_Valid (Id),
        when W_Integer_Constant =>
           Integer_Constant_Id_Children_Valid (Id),
        when W_Range_Constant =>
           Range_Constant_Id_Children_Valid (Id),
        when W_Modular_Constant =>
           Modular_Constant_Id_Children_Valid (Id),
        when W_Fixed_Constant =>
           Fixed_Constant_Id_Children_Valid (Id),
        when W_Real_Constant =>
           Real_Constant_Id_Children_Valid (Id),
        when W_Float_Constant =>
           Float_Constant_Id_Children_Valid (Id),
        when W_Comment =>
           Comment_Id_Children_Valid (Id),
        when W_Deref =>
           Deref_Id_Children_Valid (Id),
        when W_Record_Access =>
           Record_Access_Id_Children_Valid (Id),
        when W_Record_Update =>
           Record_Update_Id_Children_Valid (Id),
        when W_Record_Aggregate =>
           Record_Aggregate_Id_Children_Valid (Id),
        when W_Any_Expr =>
           Any_Expr_Id_Children_Valid (Id),
        when W_Assignment =>
           Assignment_Id_Children_Valid (Id),
        when W_Binding_Ref =>
           Binding_Ref_Id_Children_Valid (Id),
        when W_Loop =>
           Loop_Id_Children_Valid (Id),
        when W_Statement_Sequence =>
           Statement_Sequence_Id_Children_Valid (Id),
        when W_Abstract_Expr =>
           Abstract_Expr_Id_Children_Valid (Id),
        when W_Assert =>
           Assert_Id_Children_Valid (Id),
        when W_Raise =>
           Raise_Id_Children_Valid (Id),
        when W_Try_Block =>
           Try_Block_Id_Children_Valid (Id),
        when others =>
           False);

   function Expr_List_Children_Valid
     (Id : W_Expr_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Pred_OId_Children_Valid
     (Id : W_Pred_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Pred_Id_Children_Valid (Id));

   function Pred_OList_Children_Valid
     (Id : W_Pred_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Pred_List_Children_Valid (Id));

   function Pred_Id_Children_Valid
     (Id : W_Pred_Unchecked_Id)
     return Boolean is
     (case Get_Kind (Id) is
        when W_Universal_Quantif =>
           Universal_Quantif_Id_Children_Valid (Id),
        when W_Existential_Quantif =>
           Existential_Quantif_Id_Children_Valid (Id),
        when W_Not =>
           Not_Id_Children_Valid (Id),
        when W_Connection =>
           Connection_Id_Children_Valid (Id),
        when W_Label =>
           Label_Id_Children_Valid (Id),
        when W_Loc_Label =>
           Loc_Label_Id_Children_Valid (Id),
        when W_Identifier =>
           Identifier_Id_Children_Valid (Id),
        when W_Tagged =>
           Tagged_Id_Children_Valid (Id),
        when W_Call =>
           Call_Id_Children_Valid (Id),
        when W_Literal =>
           Literal_Id_Children_Valid (Id),
        when W_Binding =>
           Binding_Id_Children_Valid (Id),
        when W_Elsif =>
           Elsif_Id_Children_Valid (Id),
        when W_Epsilon =>
           Epsilon_Id_Children_Valid (Id),
        when W_Conditional =>
           Conditional_Id_Children_Valid (Id),
        when others =>
           False);

   function Pred_List_Children_Valid
     (Id : W_Pred_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Term_OId_Children_Valid
     (Id : W_Term_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Term_Id_Children_Valid (Id));

   function Term_OList_Children_Valid
     (Id : W_Term_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Term_List_Children_Valid (Id));

   function Term_Id_Children_Valid
     (Id : W_Term_Unchecked_Id)
     return Boolean is
     (case Get_Kind (Id) is
        when W_Label =>
           Label_Id_Children_Valid (Id),
        when W_Loc_Label =>
           Loc_Label_Id_Children_Valid (Id),
        when W_Identifier =>
           Identifier_Id_Children_Valid (Id),
        when W_Tagged =>
           Tagged_Id_Children_Valid (Id),
        when W_Call =>
           Call_Id_Children_Valid (Id),
        when W_Literal =>
           Literal_Id_Children_Valid (Id),
        when W_Binding =>
           Binding_Id_Children_Valid (Id),
        when W_Elsif =>
           Elsif_Id_Children_Valid (Id),
        when W_Epsilon =>
           Epsilon_Id_Children_Valid (Id),
        when W_Conditional =>
           Conditional_Id_Children_Valid (Id),
        when W_Integer_Constant =>
           Integer_Constant_Id_Children_Valid (Id),
        when W_Range_Constant =>
           Range_Constant_Id_Children_Valid (Id),
        when W_Modular_Constant =>
           Modular_Constant_Id_Children_Valid (Id),
        when W_Fixed_Constant =>
           Fixed_Constant_Id_Children_Valid (Id),
        when W_Real_Constant =>
           Real_Constant_Id_Children_Valid (Id),
        when W_Float_Constant =>
           Float_Constant_Id_Children_Valid (Id),
        when W_Comment =>
           Comment_Id_Children_Valid (Id),
        when W_Deref =>
           Deref_Id_Children_Valid (Id),
        when W_Record_Access =>
           Record_Access_Id_Children_Valid (Id),
        when W_Record_Update =>
           Record_Update_Id_Children_Valid (Id),
        when W_Record_Aggregate =>
           Record_Aggregate_Id_Children_Valid (Id),
        when others =>
           False);

   function Term_List_Children_Valid
     (Id : W_Term_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Prog_OId_Children_Valid
     (Id : W_Prog_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Prog_Id_Children_Valid (Id));

   function Prog_OList_Children_Valid
     (Id : W_Prog_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Prog_List_Children_Valid (Id));

   function Prog_Id_Children_Valid
     (Id : W_Prog_Unchecked_Id)
     return Boolean is
     (case Get_Kind (Id) is
        when W_Not =>
           Not_Id_Children_Valid (Id),
        when W_Connection =>
           Connection_Id_Children_Valid (Id),
        when W_Label =>
           Label_Id_Children_Valid (Id),
        when W_Loc_Label =>
           Loc_Label_Id_Children_Valid (Id),
        when W_Identifier =>
           Identifier_Id_Children_Valid (Id),
        when W_Tagged =>
           Tagged_Id_Children_Valid (Id),
        when W_Call =>
           Call_Id_Children_Valid (Id),
        when W_Literal =>
           Literal_Id_Children_Valid (Id),
        when W_Binding =>
           Binding_Id_Children_Valid (Id),
        when W_Elsif =>
           Elsif_Id_Children_Valid (Id),
        when W_Epsilon =>
           Epsilon_Id_Children_Valid (Id),
        when W_Conditional =>
           Conditional_Id_Children_Valid (Id),
        when W_Integer_Constant =>
           Integer_Constant_Id_Children_Valid (Id),
        when W_Range_Constant =>
           Range_Constant_Id_Children_Valid (Id),
        when W_Modular_Constant =>
           Modular_Constant_Id_Children_Valid (Id),
        when W_Fixed_Constant =>
           Fixed_Constant_Id_Children_Valid (Id),
        when W_Real_Constant =>
           Real_Constant_Id_Children_Valid (Id),
        when W_Float_Constant =>
           Float_Constant_Id_Children_Valid (Id),
        when W_Comment =>
           Comment_Id_Children_Valid (Id),
        when W_Deref =>
           Deref_Id_Children_Valid (Id),
        when W_Record_Access =>
           Record_Access_Id_Children_Valid (Id),
        when W_Record_Update =>
           Record_Update_Id_Children_Valid (Id),
        when W_Record_Aggregate =>
           Record_Aggregate_Id_Children_Valid (Id),
        when W_Any_Expr =>
           Any_Expr_Id_Children_Valid (Id),
        when W_Assignment =>
           Assignment_Id_Children_Valid (Id),
        when W_Binding_Ref =>
           Binding_Ref_Id_Children_Valid (Id),
        when W_Loop =>
           Loop_Id_Children_Valid (Id),
        when W_Statement_Sequence =>
           Statement_Sequence_Id_Children_Valid (Id),
        when W_Abstract_Expr =>
           Abstract_Expr_Id_Children_Valid (Id),
        when W_Assert =>
           Assert_Id_Children_Valid (Id),
        when W_Raise =>
           Raise_Id_Children_Valid (Id),
        when W_Try_Block =>
           Try_Block_Id_Children_Valid (Id),
        when others =>
           False);

   function Prog_List_Children_Valid
     (Id : W_Prog_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Type_Definition_OId_Children_Valid
     (Id : W_Type_Definition_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Type_Definition_Id_Children_Valid (Id));

   function Type_Definition_OList_Children_Valid
     (Id : W_Type_Definition_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Type_Definition_List_Children_Valid (Id));

   function Type_Definition_Id_Children_Valid
     (Id : W_Type_Definition_Unchecked_Id)
     return Boolean is
     (case Get_Kind (Id) is
        when W_Transparent_Type_Definition =>
           Transparent_Type_Definition_Id_Children_Valid (Id),
        when W_Record_Binder =>
           Record_Binder_Id_Children_Valid (Id),
        when W_Record_Definition =>
           Record_Definition_Id_Children_Valid (Id),
        when W_Range_Type_Definition =>
           Range_Type_Definition_Id_Children_Valid (Id),
        when others =>
           False);

   function Type_Definition_List_Children_Valid
     (Id : W_Type_Definition_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Declaration_OId_Children_Valid
     (Id : W_Declaration_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Declaration_Id_Children_Valid (Id));

   function Declaration_OList_Children_Valid
     (Id : W_Declaration_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Declaration_List_Children_Valid (Id));

   function Declaration_Id_Children_Valid
     (Id : W_Declaration_Unchecked_Id)
     return Boolean is
     (case Get_Kind (Id) is
        when W_Function_Decl =>
           Function_Decl_Id_Children_Valid (Id),
        when W_Axiom =>
           Axiom_Id_Children_Valid (Id),
        when W_Goal =>
           Goal_Id_Children_Valid (Id),
        when W_Type_Decl =>
           Type_Decl_Id_Children_Valid (Id),
        when W_Global_Ref_Declaration =>
           Global_Ref_Declaration_Id_Children_Valid (Id),
        when W_Namespace_Declaration =>
           Namespace_Declaration_Id_Children_Valid (Id),
        when W_Exception_Declaration =>
           Exception_Declaration_Id_Children_Valid (Id),
        when W_Meta_Declaration =>
           Meta_Declaration_Id_Children_Valid (Id),
        when W_Clone_Declaration =>
           Clone_Declaration_Id_Children_Valid (Id),
        when others =>
           False);

   function Declaration_List_Children_Valid
     (Id : W_Declaration_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

   function Any_Node_OId_Children_Valid
     (Id : W_Any_Node_Unchecked_OId)
     return Boolean is
     (Id = Why_Empty
      or else Any_Node_Id_Children_Valid (Id));

   function Any_Node_OList_Children_Valid
     (Id : W_Any_Node_Unchecked_OList)
     return Boolean is
     (Is_Empty (Id)
      or else Any_Node_List_Children_Valid (Id));

   function Any_Node_Id_Children_Valid
     (Id : W_Any_Node_Unchecked_Id)
     return Boolean is
     (case Get_Kind (Id) is
        when W_Type =>
           Type_Id_Children_Valid (Id),
        when W_Name =>
           Name_Id_Children_Valid (Id),
        when W_Effects =>
           Effects_Id_Children_Valid (Id),
        when W_Raise_Effect =>
           Raise_Effect_Id_Children_Valid (Id),
        when W_Binder =>
           Binder_Id_Children_Valid (Id),
        when W_Transparent_Type_Definition =>
           Transparent_Type_Definition_Id_Children_Valid (Id),
        when W_Record_Binder =>
           Record_Binder_Id_Children_Valid (Id),
        when W_Record_Definition =>
           Record_Definition_Id_Children_Valid (Id),
        when W_Range_Type_Definition =>
           Range_Type_Definition_Id_Children_Valid (Id),
        when W_Triggers =>
           Triggers_Id_Children_Valid (Id),
        when W_Trigger =>
           Trigger_Id_Children_Valid (Id),
        when W_Axiom_Dep =>
           Axiom_Dep_Id_Children_Valid (Id),
        when W_Handler =>
           Handler_Id_Children_Valid (Id),
        when W_Field_Association =>
           Field_Association_Id_Children_Valid (Id),
        when W_Variant =>
           Variant_Id_Children_Valid (Id),
        when W_Variants =>
           Variants_Id_Children_Valid (Id),
        when W_Universal_Quantif =>
           Universal_Quantif_Id_Children_Valid (Id),
        when W_Existential_Quantif =>
           Existential_Quantif_Id_Children_Valid (Id),
        when W_Not =>
           Not_Id_Children_Valid (Id),
        when W_Connection =>
           Connection_Id_Children_Valid (Id),
        when W_Label =>
           Label_Id_Children_Valid (Id),
        when W_Loc_Label =>
           Loc_Label_Id_Children_Valid (Id),
        when W_Identifier =>
           Identifier_Id_Children_Valid (Id),
        when W_Tagged =>
           Tagged_Id_Children_Valid (Id),
        when W_Call =>
           Call_Id_Children_Valid (Id),
        when W_Literal =>
           Literal_Id_Children_Valid (Id),
        when W_Binding =>
           Binding_Id_Children_Valid (Id),
        when W_Elsif =>
           Elsif_Id_Children_Valid (Id),
        when W_Epsilon =>
           Epsilon_Id_Children_Valid (Id),
        when W_Conditional =>
           Conditional_Id_Children_Valid (Id),
        when W_Integer_Constant =>
           Integer_Constant_Id_Children_Valid (Id),
        when W_Range_Constant =>
           Range_Constant_Id_Children_Valid (Id),
        when W_Modular_Constant =>
           Modular_Constant_Id_Children_Valid (Id),
        when W_Fixed_Constant =>
           Fixed_Constant_Id_Children_Valid (Id),
        when W_Real_Constant =>
           Real_Constant_Id_Children_Valid (Id),
        when W_Float_Constant =>
           Float_Constant_Id_Children_Valid (Id),
        when W_Comment =>
           Comment_Id_Children_Valid (Id),
        when W_Deref =>
           Deref_Id_Children_Valid (Id),
        when W_Record_Access =>
           Record_Access_Id_Children_Valid (Id),
        when W_Record_Update =>
           Record_Update_Id_Children_Valid (Id),
        when W_Record_Aggregate =>
           Record_Aggregate_Id_Children_Valid (Id),
        when W_Any_Expr =>
           Any_Expr_Id_Children_Valid (Id),
        when W_Assignment =>
           Assignment_Id_Children_Valid (Id),
        when W_Binding_Ref =>
           Binding_Ref_Id_Children_Valid (Id),
        when W_Loop =>
           Loop_Id_Children_Valid (Id),
        when W_Statement_Sequence =>
           Statement_Sequence_Id_Children_Valid (Id),
        when W_Abstract_Expr =>
           Abstract_Expr_Id_Children_Valid (Id),
        when W_Assert =>
           Assert_Id_Children_Valid (Id),
        when W_Raise =>
           Raise_Id_Children_Valid (Id),
        when W_Try_Block =>
           Try_Block_Id_Children_Valid (Id),
        when W_Function_Decl =>
           Function_Decl_Id_Children_Valid (Id),
        when W_Axiom =>
           Axiom_Id_Children_Valid (Id),
        when W_Goal =>
           Goal_Id_Children_Valid (Id),
        when W_Type_Decl =>
           Type_Decl_Id_Children_Valid (Id),
        when W_Global_Ref_Declaration =>
           Global_Ref_Declaration_Id_Children_Valid (Id),
        when W_Namespace_Declaration =>
           Namespace_Declaration_Id_Children_Valid (Id),
        when W_Exception_Declaration =>
           Exception_Declaration_Id_Children_Valid (Id),
        when W_Meta_Declaration =>
           Meta_Declaration_Id_Children_Valid (Id),
        when W_Clone_Declaration =>
           Clone_Declaration_Id_Children_Valid (Id),
        when W_Clone_Substitution =>
           Clone_Substitution_Id_Children_Valid (Id),
        when W_Include_Declaration =>
           Include_Declaration_Id_Children_Valid (Id),
        when W_Theory_Declaration =>
           Theory_Declaration_Id_Children_Valid (Id),
        when W_Module =>
           Module_Id_Children_Valid (Id),
        when others =>
           False);

   function Any_Node_List_Children_Valid
     (Id : W_Any_Node_Unchecked_List)
     return Boolean is
     (not Is_Empty (Id)
      and then List_Cache_Valid (Id));

end Why.Atree.Validity;